﻿/// <reference path="Signal.ts" />


var ActionBar = (function () {
    function ActionBar() {
    }
    ActionBar.initialise = function (parent, p_pathToParentApp) {
        ActionBar.m_parent = document.getElementById(parent);
        ActionBar.m_pathToParentApp = p_pathToParentApp;

        if (ActionBar.m_pathToParentApp == null) {
            ActionBar.m_pathToParentApp = "../parent/";
        }

        var style = $('<style>::-webkit-scrollbar { display: none; }</style>');
        $('html > head').append(style);

        ActionBar.onInitialiseComplete();
    };

    ActionBar.getPathByTagInXML = function (p_tag) {
        console.log("getPathByTag(" + p_tag + ")");
        return ActionBar.m_pathToParentApp + p_tag;
    };

    ActionBar.getPathByTag = function (p_tag) {
        return ActionBar.getPathByTagInXML(p_tag);
    };

    ActionBar.onInitialiseComplete = function () {
        var _width = window.innerWidth;
        var _height = window.innerHeight;

        // Assign the document to a member variable
        ActionBar.m_playerNames = new Array();

        ActionBar.m_showActionBarSignal = new Signal();
        ActionBar.m_hideActionbarSignal = new Signal();
        ActionBar.m_onBackClickedSignal = new Signal();

        //The background tint for when the action bar is showing.
        ActionBar.m_backgroundTint = document.createElement("div");
        ActionBar.m_backgroundTint.setAttribute('style', 'z-index: 999999; width: ' + _width + 'px; height: ' + _height + 'px; position: absolute; top:-1px; left:-1px; background-color: rgba(0, 0, 0, 0.33); border: none; padding: 0 0;');
        ActionBar.m_parent.appendChild(ActionBar.m_backgroundTint);
        ActionBar.m_backgroundTint.hidden = true;
        ActionBar.m_backgroundTint.onclick = ActionBar.onBackgroundClicked;

        ActionBar.m_actionBar = document.createElement('actionBar');
        ActionBar.m_actionBar.setAttribute('style', 'z-index: 1000000; position:absolute; top: -' + (window.innerHeight * 0.35) + 'px; left: 0px; width: ' + _width + 'px; height: ' + (_height * 0.2) + 'px; padding: 0; margin: 0; transition: top 0.5s;');

        ActionBar.m_parent.appendChild(ActionBar.m_actionBar);

        ActionBar.m_actionBarBackground = document.createElement("img");
        ActionBar.m_actionBarBackground.src = ActionBar.getPathByTag("navPanel.png");
        ActionBar.m_actionBarBackground.setAttribute('style', 'width: 100%; height: 137%; min-height: 137%; ');
        ActionBar.m_actionBar.appendChild(ActionBar.m_actionBarBackground);

        ActionBar.m_showActionBarButton = document.createElement("img");

        var gamesButton = document.createElement("img");
        gamesButton.setAttribute('src', ActionBar.getPathByTag('games.png'));
        gamesButton.setAttribute('style', 'height: 80%; width: auto; top: 5%; left: 1.5%; position: absolute;');
        gamesButton.onclick = function () {
            console.log("gamesClicked");
            ActionBar.hideActionbar(false);
            ActionBar.m_onBackClickedSignal.dispatch();
        };
        ActionBar.m_actionBar.appendChild(gamesButton);

        ActionBar.m_showActionBarButton.setAttribute('style', 'z-index: 999998; position:absolute; top:0%; left: ' + _width * 0.5 + 'px; padding: 0; margin-left: -5%; width: 10%; height: auto; -webkit-touch-callout: none; -webkit-user-select: none; -khtml-user-select: none; -moz-user-select: none; -ms-user-select: none; user-select: none;');
        ActionBar.m_showActionBarButton.name = "ActionBarToggleButton";
        ActionBar.m_showActionBarButton.src = ActionBar.getPathByTag("actionBarToggleButton.png");
        ActionBar.m_showActionBarButton.onclick = ActionBar.showActionBar;
        ActionBar.m_parent.appendChild(ActionBar.m_showActionBarButton);

        ActionBar.createBatteryStatusButton(ActionBar.m_actionBar);
        ActionBar.createErrorButton(ActionBar.m_actionBar);
        ActionBar.createConnectionButton(ActionBar.m_actionBar);

        var usersListDiv = document.createElement("div");
        usersListDiv.setAttribute('style', "width: 72%; max-width:none; height: 60%; max-height: 60%; overflow-x: scroll; overflow-y: hidden; position:absolute; top: 23%; left: 12.5%; -webkit-overflow-scrolling: touch; float:left;");
        ActionBar.m_actionBar.appendChild(usersListDiv);

        var usersListTable = document.createElement("table");
        usersListDiv.appendChild(usersListTable);

        var userListTableBody = document.createElement("tbody");
        usersListTable.appendChild(userListTableBody);

        var usersListScroller = document.createElement("usersListScroller");
        usersListScroller.setAttribute('style', "display:table-row; -webkit-touch-callout: none; -webkit-user-select: none;\
            -khtml-user-select: none; -moz-user-select: none; -ms-user-select: none; user-select: none;");

        userListTableBody.appendChild(usersListScroller);

        Tgoma.ErrorHelper.errorSignal.add(ActionBar.onControllerErrorsReturned, ActionBar);
        ActionBar.onControllerErrorsReturned(Tgoma.ErrorHelper.currentErrorEnum, 0, 0);
        TgomaMessaging.callPlugin(null, null, ActionBar, TgomaMessaging.TGOMA_MODULE_NAME, "getHasControllerErrors");

        TgomaMessaging.callPlugin(ActionBar.onUserListReturned, null, ActionBar, TgomaMessaging.USER_MODULE_NAME, "getUserListWithDetails");
    };

    ActionBar.showActionBar = function () {
        console.log("[ActionBar] showActionBar");
        ActionBar.m_backgroundTint.hidden = false;

        ActionBar.m_backShowing = true;
        ActionBar.m_actionBar.style.top = "0";
        ActionBar.m_showActionBarSignal.dispatch();
    };

    ActionBar.hideActionbar = function (p_userChanged) {
        console.log("[ActionBar] hideActionbar");

        ActionBar.m_backgroundTint.hidden = true;
        ActionBar.m_backShowing = false;
        ActionBar.m_actionBar.style.top = -(window.innerHeight * 0.35) + 'px';
        ActionBar.m_hideActionbarSignal.dispatch(p_userChanged);

        // Close any error dialogs we have showing!
        closeErrorDialog();
    };

    ActionBar.onControllerErrorsReturned = function (p_errorEnum, p_errorEnum2, p_errorEnum3) {
        console.log("[ActionBar] onControllerErrorsReturned(" + p_errorEnum + ")");
        if (ActionBar != null && ActionBar.m_controllerErrorButton != null) {
            ActionBar.m_controllerErrorButton.hidden = (p_errorEnum == 0 && p_errorEnum2 == 0 && p_errorEnum3 == 0);
        }
    };

    ActionBar.createErrorButton = function (p_parent) {
        console.log("[ActionBar] createErrorButton(" + p_parent + ")");
        ActionBar.m_controllerErrorButton = document.createElement("img");
        ActionBar.m_controllerErrorButton.src = ActionBar.getPathByTag("error.png");
        ActionBar.m_controllerErrorButton.setAttribute('style', "position: absolute; top: 33%; right: 9.5%; padding: 0; margin: 0; height: 25%;");

        ActionBar.m_controllerErrorButton.onclick = function () {
            console.log("[ActionBar] m_controllerErrorButton.onclick()");
            Tgoma.ErrorHelper.currentErrorEnum;
            var errorField1 = Tgoma.ErrorHelper.currentErrorField1;
            if (errorField1 > 0) {
                if ((ActionBar.CONTROLLER_ERROR_CABLE_A & errorField1) && (ActionBar.CONTROLLER_ERROR_CABLE_B & errorField1)) {
                    showErrorDialogWithEnum(3, 1, ActionBar.getPathByTag);
                } else if (ActionBar.CONTROLLER_ERROR_CABLE_A & errorField1) {
                    showErrorDialogWithEnum(1, 1, ActionBar.getPathByTag);
                } else if (ActionBar.CONTROLLER_ERROR_CABLE_B & errorField1) {
                    showErrorDialogWithEnum(2, 1, ActionBar.getPathByTag);
                } else if (ActionBar.CONTROLLER_ERROR_AUTH & errorField1) {
                    showErrorDialogWithEnum(4, 1, ActionBar.getPathByTag);
                }
            }
            //TgomaMessaging.callPlugin(null, null, ActionBar, "TgomaMessaging", "showControllerErrors");
        };

        p_parent.appendChild(this.m_controllerErrorButton);
        ActionBar.m_controllerErrorButton.hidden = true;
    };

    ActionBar.createBatteryStatusButton = function (p_parent) {
        console.log("[ActionBar] createBatteryStatusButton(" + p_parent + ")");
        ActionBar.m_batteryStatus = document.createElement("img");
        ActionBar.m_batteryStatus.src = ActionBar.getPathByTag("batteryHigh.png");
        ActionBar.m_batteryStatus.setAttribute('style', "position: absolute; top: 33%; right: 1.5%; padding: 0; margin: 0; width: auto; height: 25%;");

        p_parent.appendChild(ActionBar.m_batteryStatus);

        // Hide it to start with
        ActionBar.m_batteryStatus.hidden = true;

        Tgoma.BatteryHelper.batterySignal.add(ActionBar.onBatteryStatus, ActionBar);

        TgomaMessaging.callPlugin(null, null, ActionBar, "Bluetooth", "getBatteryStatus");
    };

    ActionBar.createConnectionButton = function (p_parent) {
        console.log("[ActionBar] createConnectionButton(" + p_parent + ")");
        ActionBar.m_connectionButton = document.createElement("img");

        ActionBar.m_connectionButton.setAttribute('style', "position: absolute; top: 33%; right: 5.5%; padding: 0; margin: 0; width: auto; height: 25%;");

        ActionBar.onConnectionStatusChanged(Tgoma.ConnectionHelper.isConnected);
        Tgoma.ConnectionHelper.connectionSignal.add(ActionBar.onConnectionStatusChanged, ActionBar);

        p_parent.appendChild(ActionBar.m_connectionButton);
    };

    ActionBar.onConnectionStatusChanged = function (p_connected) {
        if (p_connected) {
            this.m_connectionButton.src = ActionBar.getPathByTag("connected_icon.png");
            this.m_isConnected = true;
        } else {
            ActionBar.m_connectionButton.src = ActionBar.getPathByTag("disconnected_icon.png");
            ActionBar.m_controllerErrorButton.hidden = true;
            ActionBar.m_batteryStatus.hidden = true;
            if (this.m_isConnected) {
                ActionBar.showActionBar();
            }
            this.m_isConnected = false;
        }

        ActionBar.m_connectionButton.onclick = function () {
            if (p_connected) {
                TgomaMessaging.callPlugin(null, null, ActionBar, TgomaMessaging.BLUETOOTH_MODULE_NAME, "disconnect");
            } else {
                TgomaMessaging.callPlugin(null, null, ActionBar, TgomaMessaging.BLUETOOTH_MODULE_NAME, "connect");
                ActionBar.m_controllerErrorButton.hidden = true;
            }
        };
    };

    ActionBar.onUserListUpdated = function (p_usersList, p_context) {
        var usersListScroller = ActionBar.m_parent.getElementsByTagName("usersListScroller");

        for (var i = 0; i < p_usersList.length; i++) {
            ActionBar.m_playerNames[i].children[0].setAttribute("name", p_usersList[i].userName);
            ActionBar.m_playerNames[i].children[1].innerHTML = p_usersList[i].userName;
        }
    };

    ActionBar.onUserListReturned = function (p_usersList, p_context) {
        console.log("onUsersListReturned()" + p_usersList);
        var usersListScroller = ActionBar.m_parent.getElementsByTagName("usersListScroller");

        while (usersListScroller[0].hasChildNodes()) {
            usersListScroller[0].removeChild(usersListScroller[0].lastChild);
        }

        usersListScroller[0]["scrollLeft"] = 0;
        var numberOfUsers = p_usersList.length;
        var user;

        for (var i = 0; i < numberOfUsers; i++) {
            user = p_usersList[i];

            var tableCell = document.createElement("td");
            tableCell.setAttribute("style", "height:" + window.innerHeight * 0.08 + "px;");
            var cellDivRelative = document.createElement("div");
            var cellDiv = document.createElement("div");
            cellDiv.setAttribute("style", "position: relative; height: 100%;");

            var playerObject = document.createElement("img");
            playerObject.setAttribute('style', "width: auto; height:" + window.innerHeight * 0.08 + "px; padding: 0px 0px; margin: 0px 7px;");

            if (i == 0) {
                playerObject.src = ActionBar.getPathByTag("players_selected.png");
            } else {
                playerObject.src = ActionBar.getPathByTag("players.png");
            }
            playerObject["name"] = user.userName;

            usersListScroller[0].appendChild(tableCell);
            tableCell.appendChild(cellDiv);
            cellDiv.appendChild(playerObject);

            var nameText = document.createElement("div");
            nameText.innerHTML += user.userName;
            nameText.setAttribute('style', "position:absolute; top: 30%; left: 35%; pointer-events: none; font-size: 3vh; white-space: nowrap; text-overflow: ellipsis; overflow: hidden; width: 50%; font-family: 'trebuchet ms', 'sans-serif'");
            cellDiv.appendChild(nameText);

            playerObject.onclick = ActionBar.onPlayerButtonClicked;

            ActionBar.m_playerNames.push(cellDiv);
        }
    };

    ActionBar.onPlayerButtonClicked = function (evt) {
        var name = evt.target["name"];
        parent.console.log("selected player " + name);

        if (name != Tgoma.UserHelper.currentUser) {
            ActionBar.hideActionbar(true);
            TgomaMessaging.callPlugin(null, null, null, TgomaMessaging.USER_MODULE_NAME, "setUser", [name]);
            TgomaMessaging.callPlugin(ActionBar.onUserListUpdated, null, null, TgomaMessaging.USER_MODULE_NAME, "getUserListWithDetails");
        } else {
            ActionBar.hideActionbar(false);
        }
    };

    Object.defineProperty(ActionBar, "onShowActionBarSignal", {
        get: function () {
            return ActionBar.m_showActionBarSignal;
        },
        enumerable: true,
        configurable: true
    });

    Object.defineProperty(ActionBar, "onHideActionBarSignal", {
        get: function () {
            return ActionBar.m_hideActionbarSignal;
        },
        enumerable: true,
        configurable: true
    });

    Object.defineProperty(ActionBar, "onBackClickedSignal", {
        get: function () {
            return ActionBar.m_onBackClickedSignal;
        },
        enumerable: true,
        configurable: true
    });

    ActionBar.onBackgroundClicked = function () {
        ActionBar.hideActionbar(false);
    };

    ActionBar.onBatteryStatus = function (p_status) {
        console.log("onBatteryStatus(" + p_status + ")");
        if (p_status == -1) {
            return;
        }
        ActionBar.m_batteryStatus.hidden = false;

        if (p_status <= 33) {
            ActionBar.m_batteryStatus.src = ActionBar.getPathByTag("batteryLow.png");
        } else if (p_status <= 66) {
            ActionBar.m_batteryStatus.src = ActionBar.getPathByTag("batteryMedium.png");
        } else if (p_status > 66) {
            ActionBar.m_batteryStatus.src = ActionBar.getPathByTag("batteryHigh.png");
        }
    };
    ActionBar.CONTROLLER_ERROR_CABLE_A = 1;
    ActionBar.CONTROLLER_ERROR_CABLE_B = 2;
    ActionBar.CONTROLLER_ERROR_CABLE_AB = 3;
    ActionBar.CONTROLLER_ERROR_AUTH = 4;

    ActionBar.m_backShowing = false;

    ActionBar.m_isConnected = false;
    return ActionBar;
})();
