var m_user;

$(document).ready(function() {
	window.onerror = parent.window.onerror;
  $("#confirmButton").click(onConfirmClicked);
  $("#cancelButton").click(onCancelClicked);

	$('#password').on('input', function() { 
	    checkValidity($("#password"), $("#passwordTips"), parent.Tgoma.LanguageManager.getString("LBL_old_password"));
	});

  	$('#newPassword').on('input', function() { 
	    checkValidity($("#newPassword"), $("#newPasswordTips"), parent.Tgoma.LanguageManager.getString("LBL_new_password"))
	});

  	$('#newPasswordConfirm').on('input', function() { 
	    checkValidity($("#newPasswordConfirm"), $("#newPasswordConfirmTips"), parent.Tgoma.LanguageManager.getString("LBL_new_password"))
	});

	$("#changePasswordForm").submit(function(e) {
		onConfirmClicked();
		e.preventDefault();
		return false;
	});

	$("#cancelButton").click(onCancelClicked);

	parent.document.addEventListener('onChangePassword', onPasswordChangeReturned);
	parent.document.addEventListener('onResetPassword', onResetPasswordReturned);
	parent.document.addEventListener('onLoginFailed', onLoginFailed);
	
});

$(window).unload(function () {
	parent.document.removeEventListener('onChangePassword', onPasswordChangeReturned);
	parent.document.removeEventListener('onResetPassword', onResetPasswordReturned);
	parent.document.removeEventListener('onLoginFailed', onLoginFailed);
})

function onConfirmClicked(evt) {
	console.log("[ChangePassword.htm] onConfirmClicked()");
	// Remove any 
	$("#newPassword").removeClass("input-state-error");
 	$("#newPasswordTips").removeClass("tip-state-visible");
	$("#newPasswordConfirm").removeClass("input-state-error");
 	$("#newPasswordConfirmTips").removeClass("tip-state-visible");

 	// Validity testing!
	var _valid = checkValidity($("#password"), $("#passwordTips"), parent.Tgoma.LanguageManager.getString("LBL_old_password")); //Leaving blank 
	console.log(_valid);
	_valid = checkValidity($("#newPassword"), $("#newPasswordTips"), parent.Tgoma.LanguageManager.getString("LBL_new_password")) && _valid;
	console.log(_valid);
	_valid = checkValidity($("#newPasswordConfirm"), $("#newPasswordConfirmTips"), parent.Tgoma.LanguageManager.getString("LBL_new_password")) && _valid;
	console.log(_valid);
	_valid = checkMatch($("#newPassword"), $("#newPasswordConfirm"), $("#newPasswordTips"), $("#newPasswordConfirmTips"), "passwords_dont_match") && _valid;

	if (_valid) {
		// Send them away to the native code for password validation (if successful, this will change the DB too)
		parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.USER_MODULE_NAME, 
			"changePassword", [$("#password").val(), $("#newPassword").val()]);

        parent.plugins.ProgressView.show(parent.Tgoma.LanguageManager.getString("changing_password"), "CIRCLE", true);
	}
}

function onLoginFailed() {
    parent.plugins.ProgressView.hide();
	setTimeout(function() { parent.showAlert("password_login_failed") }, 1);
}

function onPasswordChangeReturned(e) {
	console.log("[ChangePassword.htm] onPasswordChangeReturned()");

	var p_succeeded = e.succeeded;

    parent.plugins.ProgressView.hide();

    // Don't block the thread!
    setTimeout(function() {
		if (p_succeeded) {
			parent.showAlert("password_change_success");
			if (parent.getURLParameter("ftue", location) == "true") {
				parent.loadFrame("familyPreferences", "nav-hidden=true?ftue=true");
			} else {
				parent.loadFrame("familyPreferences");
			} 
		} else {
			parent.showAlert("password_change_failed");
		}
	}, 1);
}

function onResetPasswordReturned(e) {
	console.log("[ChangePassword.htm] onResetPasswordReturned()");

	var p_succeeded = e.succeeded;

    parent.plugins.ProgressView.hide();

    // Don't block the thread!
	setTimeout(function() {
		if (p_succeeded) {
			parent.showAlert("password_reset_success");
		} else {
			parent.showAlert("password_reset_fail");
		}
	}, 1);
}

function checkValidity(p_field, p_tips, p_name) {

    p_field.removeClass("input-state-error");
 	p_tips.removeClass("tip-state-visible");
	// If the field matches the regex
	function validatePassword(p_password) {
	return regexp.test(p_password);
}
	var _valid = checkRegexp(p_field, p_tips, /^([\u0400-\u04FF\u4E00-\u9FFFa-zA-Z0-9@*#\`\~\!\$\%\^\&\(\)\_\-\=\+\<\>\,\.\/\?\'\"\ '])+$/, "password_format_error");
	// and the length
	_valid = checkLength(p_field, p_tips, p_name, 6, 60) && _valid;

	return _valid;
}

function onForgotPasswordClicked() {
	console.log("[ChangePassword.htm] onForgotPasswordClicked()");
	var messsage = parent.Tgoma.LanguageManager.getString("password_reset_confirmation",parent.Tgoma.UserHelper.currentFamilyAccount.m_email);
	parent.showConfirm(messsage,onResetPasswordConfirmReturned);
}


function onResetPasswordConfirmReturned(resetPassword)
{
	if(resetPassword)
	{
		parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.USER_MODULE_NAME, 
			"resetPassword", [parent.Tgoma.UserHelper.currentFamilyAccount.m_email]);

        //parent.plugins.ProgressView.show("Sending email...", "CIRCLE", true);
	}
}

function onCancelClicked(evt) {
	console.log("[ChangePassword.htm] onCancelClicked()");
	if (parent.getURLParameter("ftue", location) == "true") {
		parent.loadFrame("familyPreferences", "nav-hidden=true?ftue=true");
	} else {
		parent.loadFrame("familyPreferences");
	} 
}

function checkLength(p_field, p_fieldTips, p_name, min, max ) {
  //console.log("[ChangePassword.htm] checkLength()");
  if (p_field.val().length > max || p_field.val().length < min ) {
  	//var errorMessage = parent.Tgoma.LanguageManager.getString("length_check_error", p_name , min , max);
    updateTips(p_field, p_fieldTips, "length_check_error", p_name , min , max);
    return false;
  } 
  return true;
}

function checkRegexp(p_field, p_fieldTips, regexp, p_error) {
  //console.log("[ChangePassword.htm] checkRegexp()");
  if (!(regexp.test(p_field.val()))) {
    updateTips(p_field, p_fieldTips, p_error);
    return false;
  } 
  return true;
}

function checkMatch(p_first, p_second, p_tipsFirst, p_tipsSecond, p_message) {
  //console.log("[ChangePassword.htm] checkMatch()");
  if (p_first.val() != p_second.val()) {
    updateTips(p_first, p_tipsFirst, p_message);
    updateTips(p_second, p_tipsSecond, p_message);
    return false;
  }
  return true;
}

function updateTips(p_field, p_fieldTips, p_error) {
  var copy = null;
  copy = [].slice.call(arguments);
  copy.splice(0,2);
  p_error = parent.Tgoma.LanguageManager.getString.apply(parent.Tgoma.LanguageManager, copy);
  console.log("[ChangePassword.htm] updateTips(" + p_field + ", " + p_fieldTips + ", " + p_error + ")");
  p_fieldTips.text(p_error).addClass("tip-state-visible");
  p_field.addClass("input-state-error");
}