$(document).ready(function() { 
	window.onerror = parent.window.onerror;
	//onConnectionStatusReturned(false);
	window.lastZone = 0;
	window.consecutiveBounces = 0;
	window.inProgress = false;
	window._totalJumps = 0;
	window._orientationCompleted = false;
	parent.Tgoma.TrampolineHelper.polarLocationMessageDeprecatedSignal.add(onPolarLocation, this);
	parent.Tgoma.ConnectionHelper.connectionSignal.addOnce(onConnectionStatusChanged,this);

	window.jumpSound = new Audio("Jump1.wav");
	var isConnectedToTrampoline = parent.Tgoma.ConnectionHelper.isConnected;
	onConnectionStatusReturned(isConnectedToTrampoline);

	$("#back-button").click(onBackButtonClicked);

});

$( window ).unload(function() {
	parent.Tgoma.TrampolineHelper.polarLocationMessageDeprecatedSignal.remove(onPolarLocation, this.document);
	if(!_orientationCompleted)
	{
		parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "changeTabletLocation", [window.startingOrientation]);
	}
	parent.Tgoma.ConnectionHelper.connectionSignal.remove(onConnectionStatusChanged, this.document);
});

function onConnectionStatusReturned(status)
{
	if(status)
	{
		parent.TgomaMessaging.callPlugin(onTabletLocationReturned, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getTabletLocation");
		setMessage("start_jumping_part_1", "start_jumping_part_2")
	}
	else
	{
		setMessage("connect_to_controller_part_1","connect_to_controller_part_2");
		$("#beginButton").hide(); 
	}
}

function onConnectionStatusChanged(status)
{
	if(status && !window.inProgress)
	{
		parent.TgomaMessaging.callPlugin(onTabletLocationReturned, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getTabletLocation");
		setMessage("start_jumping_part_1", "start_jumping_part_2");
	}
	else if(status && window.inProgress)
	{
		setMessage("keep_jumping_part_1", "start_jumping_part_2");
	}
	else if(!status && window.inProgress)
	{
		setMessage("lost_connection_part_1", "lost_connection_part_2");
	}
}

function onTabletLocationReturned(location){
	console.log("onTabletLocationReturned("+location+")");
	window.inProgress = true;
	window.startingOrientation = location;
	window.currentOrientation = location;
}

function onPolarLocation(magnitude, angle){

	if (window._totalJumps == 0) {
      	parent.window.analytics.trackEvent('Orientation', 'Start');
	}
	window._totalJumps++

	if(window.jumpSound != null && window.jumpSound != undefined)
	{
		window.jumpSound.play();
	}

	if(magnitude < 20)
	{
		setMessage("jump_closer_part_1", "start_jumping_part_2");
		return;
	}

	console.log("Angle = " + angle.toString());

	setMessage("keep_jumping_part_1","start_jumping_part_2");
	
	var deviceLocation = Math.round(angle / 64) % 4;
	console.log(deviceLocation.toString());

	if(deviceLocation != 0)
	{
		window.consecutiveBounces = 0;
		var newLocation = parseInt((window.currentOrientation + deviceLocation)%4);
		parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "changeTabletLocation", [newLocation]);
		window.currentOrientation = newLocation;
		console.log(newLocation.toString());
	}
	else
	{
		window.consecutiveBounces ++;
		if(window.consecutiveBounces >= 3)
		{
			_orientationCompleted = true;
			$("#textAndImage").hide();	
			$("#back-button").hide();
      		parent.window.analytics.trackEvent('Orientation', 'Complete');
			setMessage("position_set","");
			parent.Tgoma.TrampolineHelper.polarLocationMessageDeprecatedSignal.remove(onPolarLocation, this);
			parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "saveTabletLocation", [window.currentOrientation]);
			setTimeout(function () {
				if (parent.getURLParameter("ftue", location) == "true") {
					parent.loadFrame("ftue", "nav-hidden=true");
				} else {
					parent.loadFrame("games");
				}
			}, 3000);

		}
	}
}

function onBackButtonClicked() {
	if (parent.getURLParameter("ftue", location) == "true") {
		parent.loadFrame("ftue", "nav-hidden=true");
	} else {
		parent.loadFrame("settings");
	}
}


function setMessage(p_titleMessage,p_message){
	$("#messageField").text(parent.Tgoma.LanguageManager.getString(p_message));
	$("#mainMessageArea").text(parent.Tgoma.LanguageManager.getString(p_titleMessage));
}