var m_loginFailedOrCanceledCallbacks = [];
window.showResetPassword = false;

$(document).ready(function() {
  window.onerror = parent.window.onerror;
  $("#password-entry-form").submit(submitPassword);
  document.addEventListener('keydown', function(e) {
    window.focus();
  });

  document.addEventListener('touchend', function(e) {
      window.focus();
  });
  setTimeout(function(){window.focus()},1);
});

function submitPassword(e){
    console.log("[ConfirmPassword] password-entry-form.submit()");
    if(e != null)
    {
      e.preventDefault();
    }
    // Close the password entry dialog
      $("#password-dialog").dialog( "close" );

      // Force sensible defaults that the authentication manager recognises when there is no window function or params
      var func = window.requestFunction;
      if (func == null || func == "")
      {
          func = "none";
      }
      var params = window.requestParams;
      if(params == null)
      {
        params = "{}";
      }
      // Submit a login request with our current family account's email and the password they just entered
      parent.TgomaMessaging.callPlugin(null, onInternetCheckFailed, this, 
        parent.TgomaMessaging.USER_MODULE_NAME, "loginForRequest", 
        [parent.Tgoma.UserHelper.currentFamilyAccount.m_email, $("#password-entry-field").val(), window.requestFunction, params]);

      // Clear the input value
      $("#password-entry-field").val("");
      e.preventDefault();
      return false;
}

function setPasswordCheckFunction(p_passwordCheckFunction){
  m_passwordCheckFunction = p_passwordCheckFunction;
};

function setPasswordCheckValue(p_passwordCheckValue){
  m_passwordCheckValue = p_passwordCheckValue;
};

function setPasswordConfirmationDescription(p_description){
  window.description = p_description;
}

function setShowResetPassowrd(p_showResetPassword)
{
  window.showResetPassword = p_showResetPassword;
}

function setRequestParams(p_requestFunction, p_requestParams){
  window.requestFunction = p_requestFunction;
  window.requestParams = p_requestParams;
}

function onInternetCheckFailed() {
  // Tell them they need internet
  console.log("onInternetCheckFailed()")
  setTimeout(function() { parent.showAlert("check_internet_connection"); }, 1);
  for(var i in m_loginFailedOrCanceledCallbacks)
  {
    m_loginFailedOrCanceledCallbacks[i]();
  }
  m_loginFailedOrCanceledCallbacks.length = 0; // Clear it
}

function onInternetCheckPassed() {
  console.log("onInternetCheckPassed()");
  var buttons = {};
  buttons[parent.Tgoma.LanguageManager.getString("BTN_cancel")] = function () 
  {
      $( this ).dialog( "close" );
      for(var i in m_loginFailedOrCanceledCallbacks)
      {
        m_loginFailedOrCanceledCallbacks[i]();
      }
      m_loginFailedOrCanceledCallbacks.length = 0; // Clear it
  };

  if(window.showResetPassword)
  {
    buttons[parent.Tgoma.LanguageManager.getString("LBL_forgotten_password")] = function (){
      var email = Tgoma.UserHelper.m_currentFamilyAccount.m_email;
      parent.document.addEventListener('onResetPassword', onResetPasswordReturned, false);
      email = email.toLowerCase();
      parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.USER_MODULE_NAME, 
      "resetPassword", [email]);
      parent.plugins.ProgressView.show(parent.Tgoma.LanguageManager.getString("sending_email"), "CIRCLE", true);
    }
  }
  buttons[parent.Tgoma.LanguageManager.getString("BTN_submit")] = submitPassword;

  $("#password-dialog").dialog({
    //position: { my: "bottom", at: "center", of: window },
    height: "auto",
    width: "60%",
    modal: true,
    resizable: false,
    open: passwordDialogOpened,
    buttons: buttons
  });
  $("#descriptionText").text(window.description);
    
  $("#password-dialog").show();
  $("#password-dialog").dialog( "option", "position", { my: "center", at: "center center-20%", of: window} );
}

function onResetPasswordReturned(e)
{
  console.log("[ChangePassword.htm] onResetPasswordReturned()");

  var p_succeeded = e.succeeded;

    parent.plugins.ProgressView.hide();

    // Don't block the thread!
    setTimeout(function() {
    if (p_succeeded) {
      parent.showAlert("reset_email_sent", Tgoma.UserHelper.m_currentFamilyAccount.m_email);
    } else {
      parent.showAlert("password_reset_fail");
    }
  }, 1);
}

function passwordDialogOpened(event, ui) {
  $(".ui-dialog-titlebar-close").hide();
    setTimeout(function()
    {  
      if(parent.Tgoma.ApplicationUtils.DeviceUtils.isMobile.iOS())
      {
        $("#password-dialog").dialog( "option", "position", "center" );
      }
      else
      {
        $("#password-dialog").dialog( "option", "position", "center center-20%" );
      }
    },1);
}

function showConfirmPasswordDialog(p_callback) {
  if(p_callback!= null && isFunction(p_callback))
  {
    m_loginFailedOrCanceledCallbacks.push(p_callback);
  }
  parent.TgomaMessaging.callPlugin(onInternetCheckPassed, onInternetCheckFailed, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "isConnectedToInternet", []);
  $("#password-entry-field").val("");
}

function isFunction(functionToCheck) {
 var getType = {};
 return functionToCheck && getType.toString.call(functionToCheck) === '[object Function]';
}