var BUILD_OUT_OF_DATE = false;
var PROMPT_FOR_UPDATE = false; 

var m_downloadCallback;
var m_connected = false;
var m_showingOverlay = false;
var m_lastPageVisited = "";
var m_doingFtue = false;
var m_isParentApp = true;

var _currentlySelectedButton;

window.onload = function () {
    console.log("Window loaded");
    document.addEventListener("deviceready", onDeviceReady, false);
    document.addEventListener("onSyncComplete", onSyncComplete, false);
};

$(window).unload(function () {
    document.removeEventListener("backbutton", onBackKeyDown, false);
    if (isMobile.Android()) {
        window.removeEventListener("native.keyboardhide", onKeyboardHide, false);
        window.removeEventListener("native.keyboardshow", onKeyboardShow, false);
    }
});

function onDeviceReady() {

    window.onresize = function () {
        document.body.style.top = "0px";
    };
    document.body.style.height = window.innerHeight + "px";
    document.body.style.position = "absolute";

    // This is awful - thanks, iOS.
    $("#navTitle").height($("#navPanel").height() * 0.7);
    $(".welcome-text").css("margin-top", (($("#navPanel").height() * 0.7) - $(".welcome-text").height()) / 2);

    // Exit from fullscreen mode, and set up some keyboard event listeners on android.
    if (isMobile.Android()) {
        window.addEventListener("native.keyboardhide", onKeyboardHide, false);
        window.addEventListener("native.keyboardshow", onKeyboardShow, false);
        AndroidFullScreen.immersiveMode();
    }

    // Lock orientation - the cordova screen orientation plugin has changed recently so this
    // has been configured to work with both versions.
    if (screen.lockOrientation != undefined)
    {
        // Deprecated
        screen.lockOrientation('landscape');
    }
    else
    {
        screen.orientation.lock('landscape');
    }

    init();
}

function init() {

    console.log("init()");

    //Check to make sure we have springfree messaging loaded, otherwise wait a bit and try again.
    if (typeof TgomaMessaging !== 'undefined')  {
        try {
            // Check to see if this is a first time setup
            TgomaMessaging.callPlugin(null, null, this, TgomaMessaging.TGOMA_MODULE_NAME, "startAutomaticDownloads");
            TgomaMessaging.callPlugin(onTabletLocationReturned, null, this, TgomaMessaging.TGOMA_MODULE_NAME, "getTabletLocation");
            TgomaMessaging.Internal.ApplicationManagement.getRaygunApiKey(this, onRaygunApiKeyReturned);

            // The tgoma initialisation makes the calls that will trigger these signals so we need to attach listeners
            // to them before initialising tgoma helpers.
            Tgoma.UserHelper.userChangedSignal.add(onPlayerChanged, this);
            Tgoma.UserHelper.userUpdatedSignal.add(onPlayerChanged, this);
            Tgoma.ConnectionHelper.connectionSignal.add(onConnectionReturned, this);
            Tgoma.BatteryHelper.batterySignal.add(onBatteryStatus, this);
            // Initialise tgoma helpers, the language manager, and purchase validation
            Tgoma.initForParent(onTgomaInitialised);
            SpringfreePurchaseValidation.initialise();
        }
        catch (err) {
            console.error("Error initialising native code" + err);
        }

        FastClick.attach(document.getElementById("topBar"));
    }
    else {
        setTimeout(init, 100);
    }
}

function onTgomaInitialised(p_parentManifest) {

    addFrameLocalisedText(document);
    document.getElementsByTagName("HTML")[0].setAttribute("lang", Tgoma.LanguageManager.getLanguageTag()); //Setting up the page to have the correct language tag.

    //This needs to be done here to make sure localised messages have been loaded.
    if (BUILD_OUT_OF_DATE && !sessionStorage.getItem("shownUpdateAlert")) {
        sessionStorage.setItem("shownUpdateAlert", true)
        if (Tgoma.ApplicationUtils.DeviceUtils.isMobile.iOS()) {
            showAlert("app_update_required_iOS");
        }
        else {
            showAlert("app_update_required_android");
        }
    }
    if (PROMPT_FOR_UPDATE && !sessionStorage.getItem("shownUpdateAlert")) {
        sessionStorage.setItem("shownUpdateAlert", true);
        if (isMobile.iOS()) {
            showAlert("app_update_prompt_iOS");
        }
        else {
            showAlert("app_update_prompt_android");
        }
    }

    // Do this once to handle the initial connection state (since only changes will be picked up by the event listener)
    onConnectionReturned(parent.Tgoma.ConnectionHelper.isConnected);

    TgomaMessaging.Internal.Trampoline.getBatteryStatus(null);
    $.getScript(parent.getPathByTag("errorDialog-v2.js"), function () {
        onGetHasControllerErrorsReturned(Tgoma.ErrorHelper.currentErrorField1,
                                         Tgoma.ErrorHelper.currentErrorField2,
                                         Tgoma.ErrorHelper.currentErrorField3);
        Tgoma.ErrorHelper.errorSignal.add(onGetHasControllerErrorsReturned);
        TgomaMessaging.callPlugin(null, null, this, TgomaMessaging.TGOMA_MODULE_NAME, "getHasControllerErrors");
        $("#error").click(onErrorButtonClicked);
    });

    // Get info from the main app c++ managers
    console.log("Manifest version: " + getManifestVersion(manifestDoc));
    TgomaMessaging.callPlugin(onAppVersionReturned, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getVersionNumber");
    TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "setParentAppContent", [getManifestVersion(manifestDoc)]);

    document.addEventListener("onAuthTokenLoginReturned", onAuthTokenReturned, false)

    TgomaMessaging.callPlugin(handleAuthTokenReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getIsAuthTokenValid", []);

    TgomaMessaging.Internal.ApplicationManagement.toggleScreenTimeout(false);

    TgomaMessaging.callPlugin(onNumberOfUnseenGamesReturned, null, null, "UserManagement", "getNumberOfUnseenGames", []);
    TgomaMessaging.callPlugin(onNumberOfUnseenEventsReturned, null, null, "UserManagement", "getNumberOfUnseenNewsEvents", []);

    // Add listeners to all of the navigation buttons.
    var navButtonList = document.getElementsByClassName("navButton");
    for (var i = 0; i < navButtonList.length; i++) {
        navButtonList[i].addEventListener("click", onNavButtonClicked, false);
        //navButtonList[i].addEventListener("touchstart", onNavButtonMouseDown, false);
    }
    // Add listener to the player button
    document.getElementById("players").addEventListener("click", onNavButtonClicked, false);
    // And the connection button
    document.getElementById("connection").addEventListener("click", onConnectionButtonClicked, false);
    // Add the back key listener
    document.addEventListener("backbutton", onBackKeyDown, false);

    // Hide the battery status
    $("#battery").hide();

    // DON'T do this until tgoma helpers (especially the language manager) are all initialised!
    LoadStartingFrame();
}

/***** Content Frames *****/
function LoadStartingFrame() {

    // Decode URL parameters
    // We're going to check for a frame request
    var _frame = getURLParameter("frameID", location);

    if (_frame != null) {
        loadFrame(_frame);
    }
    else {
        // See if they've completed the FTUE
        TgomaMessaging.Internal.UserManagement.getHasCompletedFtue(
            function (p_hasCompletedFtue) {
                if (p_hasCompletedFtue) {
                    // Load up the games frame if they have
                    $("#games").src = getPathByTag("games_selected.png");
                    loadFrame("games");
                }
                else {
                    // Send them to the FTUE if they haven't
                    loadFrame("ftue", "nav-hidden=true");
                }
            }, this);
    }
}

function getURLParameter(name, p_location) {
    return decodeURIComponent((new RegExp('[?|&]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(p_location.search) || [, ""])[1].replace(/\+/g, '%20')) || null
}

function onFrameLoaded() {
    $("#contentContainer").css("height", "81%");
    $("#contentFrame").css("visibility", "hidden");
    setTimeout(function () {
        $("#contentContainer").css("height", "80%");
        $("#contentFrame").css("visibility", "");
    }, 20); //Hack to fix scrolling iframes on android.

    var documentToLocalise = contentFrame.document ? contentFrame.document : contentFrame.contentWindow.document;
    addFrameLocalisedText(documentToLocalise);
}

function addFrameLocalisedText(p_document) {
    var textFields = p_document.getElementsByClassName("text");
    var textWithHtml = p_document.getElementsByClassName("textWithHtml");
    var buttons = p_document.getElementsByClassName("buttonText");
    var radioButtons = p_document.getElementsByClassName("radioText");
    var placeholderText = p_document.getElementsByClassName("placeholderText");

    for (var i = 0; i < textFields.length; i++) {
        $(textFields[i]).html(Tgoma.LanguageManager.getString(textFields[i].getAttribute("texttag")));
    }
    for (var i = 0; i < textWithHtml.length; i++) {
        $(textWithHtml[i]).html(Tgoma.LanguageManager.getString(textWithHtml[i].getAttribute("texttag")) + textWithHtml[i].getAttribute("htmlContent"));
    }
    for (var i = 0; i < buttons.length; i++) {
        $(buttons[i]).attr("value", Tgoma.LanguageManager.getString(buttons[i].getAttribute("texttag")));
    }
    for (var i = 0; i < radioButtons.length; i++) {
        $(radioButtons[i]).next().text(Tgoma.LanguageManager.getString(radioButtons[i].getAttribute("texttag")));
    }
    for (var i = 0; i < placeholderText.length; i++) {
        $(placeholderText[i]).attr("placeholder", Tgoma.LanguageManager.getString(placeholderText[i].getAttribute("texttag")));
    }
    p_document.dispatchEvent(new Event("localisedFramePopulated"));
}

/***** Alert Icons *****/
function refreshUnseenGames() {
    TgomaMessaging.callPlugin(onNumberOfUnseenGamesReturned, null, null, "UserManagement", "getNumberOfUnseenGames", []);
}

function refreshUnseenEvents() {
    TgomaMessaging.callPlugin(onNumberOfUnseenEventsReturned, null, null, "UserManagement", "getNumberOfUnseenNewsEvents", []);
}

function onNumberOfUnseenGamesReturned(p_numberOfGames) {
    if (p_numberOfGames > 0) {
        //Show the store
        $("#shopAlert").css("visibility", "");
        $("#shop").css("visibility", "");
    }
    else if (p_numberOfGames < 0) {
        //hide the store
        $("#shopAlert").css("visibility", "hidden");
        $("#shop").css("visibility", "hidden");
    }
    else {
        //hide just the icon
        $("#shopAlert").css("visibility", "hidden");
        $("#shop").css("visibility", "");
    }
}

function onNumberOfUnseenEventsReturned(p_numberOfEvents) {
    if (p_numberOfEvents > 0) {
        //Show the alert icon
        $("#newsAlert").css("visibility", "");
    }
    else {
        //hide the icon
        $("#newsAlert").css("visibility", "hidden");
    }
}

function setItemAsSeen(p_itemName) {
    TgomaMessaging.callPlugin(function (a) { console.log(a); }, function (error) { console.log("Error"); }, null, "UserManagement", "addSeenItem", [p_itemName.toString()]);
}

function onGetHasControllerErrorsReturned(p_errorfield1, p_errorfield2, p_errorfield3) {
    if (p_errorfield1 > 0 || p_errorfield2 > 0 || p_errorfield3 > 0) {
        $("#error").show();
        if (p_errorfield1 > 0) {
            // Javascript converts 64 bit numbers to 32 bit when doing bitwise operations so we will have to look at them in two parts
            var w = 4294967296; // 2^32
            // Since we know the flags we want are in the higher 32 bits of the field value we only consider that
            var firmwareUpdateFlag = CONTROLLER_NOTICE_FIRMWARE_UPDATE_ACTIVE / w;
            var errorHigh = p_errorfield1 / w;

            if ((firmwareUpdateFlag & errorHigh) && sessionStorage.getItem("shownFirmwareUpgradeAlert") == "false") {
                sessionStorage.setItem("shownFirmwareUpgradeAlert", true);
                showAlert("firmware_update_active");
            }
        }
    } else {
        $("#error").hide();
    }
}

/***** Dialogs *****/
function showAlert(p_alertText) {
    argumentsCopy = [].slice.call(arguments);
    setTimeout(function () { //This sometimes needs to be run on the next update loop on iOS otherwise you can't close the dialog.
        p_alertText = Tgoma.LanguageManager.getString.apply(Tgoma.LanguageManager, argumentsCopy);

        if (navigator.notification != null) {

            var okText = Tgoma.LanguageManager.getString("BTN_ok");
            if (Tgoma.ApplicationUtils.DeviceUtils.isMobile.iOS()) {
                navigator.notification.alert("", null, p_alertText, okText);
            }
            else {
                navigator.notification.alert(p_alertText, null, "", okText);
            }
        }
        else {
            var iframe = document.createElement("IFRAME");
            iframe.setAttribute("src", 'data:text/plain,');
            document.documentElement.appendChild(iframe);
            window.frames[window.frames.length - 1].window.alert(p_alertText);
            iframe.parentNode.removeChild(iframe);
        }
    }, 1)
}

function showConfirm(p_confirmText, p_callback) {
    p_confirmText = Tgoma.LanguageManager.getString(p_confirmText);

    if (navigator.notification != null && p_callback != null) {
        var ok = Tgoma.LanguageManager.getString("BTN_ok");
        var cancel = Tgoma.LanguageManager.getString("BTN_cancel");
        if (Tgoma.ApplicationUtils.DeviceUtils.isMobile.iOS()) {
            navigator.notification.confirm("", function (result) { p_callback(result == 1); }, p_confirmText, [ok, cancel])
        }
        else {
            navigator.notification.confirm(p_confirmText, function (result) { p_callback(result == 1); }, "", [ok, cancel])
        }
    }
    else {
        var iframe = document.createElement("IFRAME");
        iframe.setAttribute("src", 'data:text/plain,');
        document.documentElement.appendChild(iframe);
        var _choice = window.frames[window.frames.length - 1].window.confirm(p_confirmText);
        iframe.parentNode.removeChild(iframe);
        if (p_callback != null) {
            p_callback(_choice);
        }
        else {
            return _choice;
        }

    }
}

function showPrompt(p_promptText) {
    p_promptText = Tgoma.LanguageManager.getString.apply(Tgoma.LanguageManager, arguments);
    var iframe = document.createElement("IFRAME");
    iframe.setAttribute("src", 'data:text/plain,');
    document.documentElement.appendChild(iframe);
    var _email = window.frames[window.frames.length - 1].window.prompt(p_promptText);
    iframe.parentNode.removeChild(iframe);
    return _email;
}

function showSafetyMessage(p_callback) {
    if (!sessionStorage.getItem("acceptedSafetyMessage")) {
        var dialogOverlay;

        $("#safety-dialog").dialog({
            width: screen.width * 0.8,
            height: 'auto',
            modal: true,
            open: function () {
                $(".ui-dialog-titlebar-close").hide();
                //get the last overlay in the dom
                $dialogOverlay = $(".ui-widget-overlay").last();
                //remove any event handler bound to it.
                $dialogOverlay.unbind();
                $dialogOverlay.click(function () {
                    //close the dialog whenever the overlay is clicked.
                    $("#safety-dialog").dialog("close");
                });
            }
        });

        $('#safety-dialog').dialog('open');

        //$("#safety-recommendations-link").click(onSafetyRecommendationsClicked);
        $("#safety-confirm-button").unbind("click");//Have to unbind otherwise you can end up with loads of callbacks.
        $("#safety-confirm-button").click(function () {
            sessionStorage.setItem("acceptedSafetyMessage", true);
            $('#safety-dialog').dialog('close');
            $("#safety-confirm-button").unbind("click");//Have to unbind otherwise you can end up with loads of callbacks.
            p_callback();
        });
    }
    else {
        p_callback();
    }
}

function loadOverlayFrame(address, parameters) {
    console.log("loadOverlayFrame(" + address + ")");

    //m_lastPageVisited = document.getElementById("contentFrame").src;
    //loadFrame(address, null);

    m_showingOverlay = true;

    if (parameters != null) {
        address += "?" + parameters;
    }
    document.getElementById("overlayFrame").src = address;
    document.getElementById("overlay").style.display = 'block';

}

function hideOverlayFrame() {
    //loadFrame(m_lastPageVisited, null);
    m_showingOverlay = false;
    document.getElementById("overlayFrame").style.visibility = 'hidden';
    document.getElementById("overlay").style.display = 'none';
    document.getElementById("overlayFrame").src = getPathByTag('blank.htm')

}


/***** Listeners *****/
function onSyncComplete(p_success) {
    console.log("onSyncComplete");
    if (!p_success.succeeded) {
        setTimeout(function () {
            showConfirm(Tgoma.LanguageManager.getString("syncing_failed"), function (_choice) {
                if (_choice) {
                    parent.TgomaMessaging.callPlugin(null, onRetrySyncError, this, parent.TgomaMessaging.USER_MODULE_NAME, "syncUsers", [false]);
                }
                else {
                    parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "syncUsers", [true]);
                }
            });
        }, 1);
    }
}

function onRetrySyncError(error) {
    console.log(error);
    onSyncComplete(false);
}

function onAppVersionReturned(versionNumber) {
    console.log("onAppVersionReturned(" + versionNumber + ")");

    if (versionNumber["appVersion"] != "") {
        TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "setParentAppVersion", [versionNumber["appVersion"]]);
    }
}

function onAuthTokenReturned(authTokenEvent) {
    var valid = authTokenEvent.succeedded;
    if (!sessionStorage.getItem("shownInvalidTokenPrompt")) {
        handleAuthTokenReturned(valid);
    }
}

function handleAuthTokenReturned(p_valid) {
    console.log("handleAuthTokenReturned(" + p_valid + ")");
    if (!p_valid) {

        sessionStorage.setItem("shownInvalidTokenPrompt", true); // We only want to see this once per app launch.

        $(".password-dialog").load("confirmPassword.htm");
        $.getScript(parent.getPathByTag("confirmPassword.js"));
        setTimeout(function () {

            var requestParams = new Object();
            setRequestParams("none", JSON.stringify(requestParams));

            Tgoma.UserHelper.familyLoginReturnedSignal.addOnce(onLoginToRefreshToken, this);

            // Show the password entry dialog that will send our request to native
            setPasswordConfirmationDescription(Tgoma.LanguageManager.getString("enter_password_to_continue"));
            setShowResetPassowrd(true);
            showConfirmPasswordDialog(function () {
                showAlert("missing_password_warning");
                Tgoma.UserHelper.familyLoginReturnedSignal.removeAll(onLoginToRefreshToken, this);
            });
        }, 1000); //Wait a second just to make sure we're all good. No rush.
    }
}

function onLoginToRefreshToken(p_success, p_error) {
    console.log("onLoginToRefreshToken(" + p_success + ")");
    if (!p_success) {
        setTimeout(function () {
            var message = Tgoma.LanguageManager.getString("login_error", p_error);
            showConfirm(message, function (retry) {
                if (retry) {
                    var requestParams = new Object();
                    setRequestParams("none", JSON.stringify(requestParams));
                    Tgoma.UserHelper.familyLoginReturnedSignal.addOnce(onLoginToRefreshToken, this);
                    showConfirmPasswordDialog();
                }
                else {
                    showAlert("missing_password_warning");
                }
            });
        }, 1);
    }
    else {
        setTimeout(function () {
            showAlert("Login succeedded");
        }, 1);
    }
}

function onRaygunApiKeyReturned(p_data) {
    Raygun.init(p_data["apiKey"], {
        disablePulse: false,
        disableAnonymousUserTracking: true
    }).attach();

    Raygun.onBeforeSend(function (error) {
        console.log("BeforeSend: ", error);
        return error;
    });

    Raygun.setVersion("parent_" + getManifestVersion(manifestDoc));
}


function onConnectionButtonClicked(p_event) {
    if (m_connected) {
        $("#error").hide();
        TgomaMessaging.callPlugin(null, null, this, TgomaMessaging.BLUETOOTH_MODULE_NAME, "disconnect");
    }
    else {
        TgomaMessaging.callPlugin(null, null, this, TgomaMessaging.BLUETOOTH_MODULE_NAME, "connect");
    }
}

function onConnectionReturned(p_connected) {
    // Only proceed if the language manager is ready, otherwise wait a bit and try again.
    // This is to prevent race conditions in the firmware update dialog if the controller returns errors.
    // There is no harm in waiting in other cases too as the main frame won't load until the language manager is ready either.
    if (Tgoma.LanguageManager.m_ready)
    {
        console.log("onConnectionReturned(" + p_connected + ")");
        m_connected = p_connected;
        if (m_connected) {
            $("#connection").attr("src", "connected_icon.png");
            TgomaMessaging.callPlugin(onGetHasControllerErrorsReturned, null, this, TgomaMessaging.TGOMA_MODULE_NAME, "getHasControllerErrors");
        }
        else {
            $("#connection").attr("src", "disconnected_icon.png");
            $("#battery").hide();
            $("#error").hide();
            sessionStorage.setItem("shownFirmwareUpgradeAlert", false);
        }
    }
    else
    {
        setTimeout(onConnectionReturned, 100, p_connected);
    }

}

function onErrorButtonClicked(evt) {
    console.log("onErrorButtonClicked()");
    var _errors = Tgoma.ErrorHelper.currentErrorField1;
    console.log("Errors = ", _errors);
    if (_errors > 0) {
        if ((CONTROLLER_ERROR_CABLE_A & _errors) && (CONTROLLER_ERROR_CABLE_B & _errors)) {
            showErrorDialogWithEnum(3, 1, getPathByTag);
        }
        else if (CONTROLLER_ERROR_CABLE_A & _errors) {
            showErrorDialogWithEnum(1, 1, getPathByTag);
        }
        else if (CONTROLLER_ERROR_CABLE_B & _errors) {
            showErrorDialogWithEnum(2, 1, getPathByTag);
        }
        else if (CONTROLLER_ERROR_AUTH & _errors) {
            showErrorDialogWithEnum(4, 1, getPathByTag);
        }
    }
}

function onPlayerChanged(p_player) {
    console.log("onPlayerChanged(" + p_player.m_name + ")");
    document.getElementById("playerName").innerHTML = p_player.m_name;

    Raygun.setUser(
        Tgoma.UserHelper.currentFamilyAccount.m_parseId,
        false,
        Tgoma.UserHelper.currentFamilyAccount.m_email,
        Tgoma.UserHelper.currentFamilyAccount.m_familyName
    );

    //Need to update the notifcations for events and games.
    refreshUnseenEvents();
    refreshUnseenGames();
}

function onPlayerUpdated(p_player) {
    console.log("onPlayerUpdated(" + p_player.m_name + ")");
    document.getElementById("playerName").innerHTML = p_player.m_name;
}

function onTabletLocationReturned(location) {
    if (location == -1) { // unconfigured
        loadFrame("configureTrampoline");
    }
}


function onBackKeyDown() {
    if (m_showingOverlay) {
        hideOverlayFrame();
    }
    else {
        if (m_doingFtue) {
            loadFrame("ftue", "nav-hidden=true");
        } else {
            $("#games").click();
        }
    }
}

function onBatteryStatus(p_status) {
    console.log("onBatteryStatus(" + p_status + ")");

    // If it's -1, we're not actually connected.
    if (p_status < 0) { return; }

    $("#battery").show();

    if (p_status <= 33) {
        $("#battery").attr("src", "batteryLow.png");
    }
    else if (p_status <= 66) {
        $("#battery").attr("src", "batteryMedium.png");
    }
    else if (p_status > 66) {
        $("#battery").attr("src", "batteryHigh.png");
    }
}

function onNavButtonClicked(evt) {
    console.log("onNavButtonClicked(" + evt.target.id + ")");

    loadFrame(evt.target.id);

    if (_currentlySelectedButton != null) {
        _currentlySelectedButton.src = _currentlySelectedButton.id + ".png";
    }

    _currentlySelectedButton = evt.target;

    evt.target.src = getPathByTag(evt.target.id + "_tapped.png");
    setTimeout(function () { evt.target.src = getPathByTag(evt.target.id + "_selected.png"); }, 200);
}

function onNavButtonMouseDown(evt) {
    console.log("onNavButtonMouseDown(" + evt.target.id + ")");

    evt.target.src = getPathByTag(evt.target.id + "_tapped.png");
}

//Callback for when the keyboard is hidden on android, to set the app back into lean mode to hide the status bar.
function onKeyboardHide() {
    console.log("onKeyboardHide()");
    AndroidFullScreen.immersiveMode();
}

function onKeyboardShow() {
    console.log("onKeyboardShow()");
    AndroidFullScreen.showSystemUI();
}
