var CONTROLLER_ERROR_CABLE_A = 0x1;
var CONTROLLER_ERROR_CABLE_B = 0x2;
var CONTROLLER_ERROR_CABLE_AB = 3;
var CONTROLLER_ERROR_AUTH = 0x4;
var CONTROLLER_ERROR_CABLE_A_IRQ_FAULT = 0x8;
var CONTROLLER_ERROR_CABLE_B_IRQ_FAULT = 0x10;
var CONTROLLER_ERROR_HARDWARE_FAULT = 0x20;


var CONTROLLER_WARNING_SENSOR_1_MISALIGNED = 0x10000;
var CONTROLLER_WARNING_SENSOR_2_MISALIGNED = 0x20000;
var CONTROLLER_WARNING_SENSOR_3_MISALIGNED = 0x40000;
var CONTROLLER_WARNING_SENSOR_4_MISALIGNED = 0x80000;

var CONTROLLER_WARNING_CORRUPT_TABLES = 0x100000;
var CONTROLLER_WARNING_MODEL_SELECT_DISABLED = 0x200000;
var CONTROLLER_WARNING_NO_MODEL_SET = 0x400000;

var CONTROLLER_NOTICE_LOW_BATT_POWER_OFF = 0x100000000;
var CONTROLLER_NOTICE_INACTIVITY_POWER_OFF = 0x200000000;
var CONTROLLER_NOTICE_SANDBOX_MODE = 0x400000000;
var CONTROLLER_NOTICE_FIRMWARE_UPDATE_ACTIVE = 0x800000000;
var CONTROLLER_NOTICE_NO_REF_VALUES = 0x1000000000;
var CONTROLLER_NOTICE_WATCHDOG_RESET = 0x2000000000;

var _errorImageDictionary = {
	1: "cableAError.png",
	2: "cableBError.png",
	3: "cableABError.png"
}

var _errorTextDictionary1 = {
	1: "Alert: Cable A is disconnected.\nPlease check the connectors.(00)" ,
	2: "Alert: Cable B is disconnected.\nPlease check the connectors.(01)" ,
	3: "Alert: Cables A&B disconnected.\nPlease check the connectors." ,
	4: "Alert: Authentication error.(02)",
	8: "Alert: Place holder for the future",
	16: "Alert: Place holder for the future",
	0x20: "Alert: Hardware Error (05)",
	0x10000: "Check sensor 1 is mounted correctly (10)",
	0x20000: "Check sensor 2 is mounted correctly (11)",
	0x40000: "Check sensor 3 is mounted correctly (12)",
	0x80000: "Check sensor 4 is mounted correctly (13)",
	0x100000: "Controller table error (14)",
	0x200000: "Model update in progress, please wait (15)",
	0x400000: "Please select trampoline model (16)",


}

var _errorTextDictionary2 = {
	0x1: "Batteries in controller flat (20)",
	0x2: "Turn on controller (21)",
	0x4: "placeholder only for future",
	0x8: "Firmware update in progress (23)"
};



var _errorTextDictionary6 = {
	0x1: "Alert: Authentication error.(161)",
	0x10: "Alert: Not logged in. Please Log in again."
};


function showErrorDialogWithEnum(p_enum, p_errorList, p_imageLookupCallback) {
	console.log("showErrorDialogWithEnum(" + p_enum + "," + p_errorList + ")");

	var errorTextDictionary;

	if(p_errorList == 1 )
	{
		errorTextDictionary = _errorTextDictionary1;
	}
	else if(p_errorList == 2)
	{
		errorTextDictionary = _errorTextDictionary2;
	}
	else if(p_errorList == 6)
	{
		errorTextDictionary = _errorTextDictionary6;
	}
	else //No other errors have been added yet.
	{
		console.log("These errors have not been set up yet");
		return;
	}


	switch(p_enum) {
		case 1: {
			if(p_errorList == 1)
			{
				showErrorDialogWithImage(_errorImageDictionary[p_enum], p_imageLookupCallback);
			}
			/*else
			{
				showErrorDialogWithText(errorTextDictionary[p_enum]);
			}*/
			break;
		}
		case 2: {
			if(p_errorList == 1)
			{
				showErrorDialogWithImage(_errorImageDictionary[p_enum], p_imageLookupCallback);
			}
			/*else
			{
				showErrorDialogWithText(errorTextDictionary[p_enum]);
			}*/
			break;
		}
		case 3: {
			if(p_errorList == 1)
			{
				showErrorDialogWithImage(_errorImageDictionary[p_enum], p_imageLookupCallback);
			}
			/*else
			{
				showErrorDialogWithText(errorTextDictionary[p_enum]);
			}*/
			break;
		}
		case 4: {
			//showErrorDialogWithText(errorTextDictionary[p_enum]);
			break;
		}
	}
}

function showErrorDialogWithImage(p_imageTag, p_imageLookupCallback) {
	console.log("showErrorDialogWithImage(" + p_imageTag + ")")

	showDialogWithContents("<img src=" + p_imageLookupCallback(p_imageTag) + " />", 340, 470);
}

function showErrorDialogWithText(p_text) {
	console.log("showErrorDialogWithText(" + p_text + ")")

	showDialogWithContents("<p>" + p_text + "</p>", 'auto', 'auto');
}

function showDialogWithContents(p_contents, p_width, p_height) {
	console.log("showDialogWithContents(" + p_contents + ")");

	$('.error-dialog').empty();

	$('.error-dialog').prepend(p_contents);

	$(".error-dialog").dialog({
	    width: p_width,
	    height: p_height,
	    modal: true,
        open:function(){
            $(".ui-dialog-titlebar-close").hide();
            //get the last overlay in the dom
            $dialogOverlay = $(".ui-widget-overlay").last();
            //remove any event handler bound to it.
            $dialogOverlay.unbind();
            $dialogOverlay.click(function(){
            //close the dialog whenever the overlay is clicked.
                closeErrorDialog();
            });
        }
  	});

	$('.error-dialog').show();

  	$(".error-dialog").dialog( "option", "position", { my: "center", at: "center", of: window } );
}

function closeErrorDialog() {
	if ($(".error-dialog").hasClass('ui-dialog-content')) {
		$(".error-dialog").dialog('close');
	}
}
