var m_creatingUser = false;

$(document).ready(function() {
	initialise();
}); 

function initialise()
{
	if(typeof parent.TgomaMessaging !== 'undefined')
	{
		console.log("Document Ready");
		hackCSS();
		console.log("CSS Hacked");

		parent.Tgoma.UserHelper.init();
	    parent.TgomaMessaging.callPlugin(onFamilyReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getFamilyAccountExists",[]);

		$('#createFamilyAccountForm').submit(function () {
			onCreateFamilyClicked();
			return false;
		});

		$('#loginFamilyAccountForm').submit(function () {
			onLoginButtonClicked();
			return false;
		});

		$('#conditionsCheckbox').change(function(){
			if($(this).is(":checked")){
				$("#conditionsCheckboxText").css("color", "");
			}
			else{
				$("#conditionsCheckboxText").css("color", "red");
			}
		})

		$("#privacyPolicySection").click(onPrivacyPolicyClicked);

		$("#continueAsGuestSection").click(onPlayAsGuestClicked);

	    if (parent.isMobile.Android()) {
	    	$("body").css('max-height', window.outerHeight);
		}

		parent.document.addEventListener("backbutton", onBackKeyDown, false);
		parent.document.addEventListener("onFamilyMembersDownloaded", onFamilyMembersDownloaded, false);
		console.log("Some event listeners added");

		if (parent.isMobile.Android()) {
	        window.addEventListener("native.keyboardhide", onKeyboardHide, false);
	        window.addEventListener("native.keyboardshow", onKeyboardShow, false);       
	    }
	    
		parent.Tgoma.UserHelper.familyCreationReturnedSignal.add(onFamilyCreated, this);

        parent.TgomaMessaging.Internal.ApplicationManagement.toggleScreenTimeout(false);
	}
	else
	{
		console.log("Tgoma Messaging not loaded, going to wait 50ms and try again.");
		setTimeout(initialise, 50);
	}
}

$(window).unload(function () {
	parent.document.removeEventListener('onResetPassword', onResetPasswordReturned);
	parent.document.removeEventListener('onFamilyMembersDownloaded', onFamilyMembersDownloaded);
	if (parent.isMobile.Android()) {
        window.removeEventListener("native.keyboardhide", onKeyboardHide, false);
        window.removeEventListener("native.keyboardshow", onKeyboardShow, false);       
    }
})

$(window).ready(function(){
	// Adds and styles placeholder text to input fields
	setupTextBoxes();
});

$(window).load(function() {
	setTimeout(hackCSS, 100);

});

// This is awful - thanks, iOS.
function hackCSS() {
	$("#navTitle").height($("#navPanel").height() * 0.7);
	$(".welcome-text").css("margin-top", (($("#navPanel").height() * 0.7) - $(".welcome-text").height()) / 2);
}

function onForgotPasswordClicked() {
	console.log("[FamilyLogin.htm] onForgotPasswordClicked()");
	showRestPasswordPrompt();
}

function setupTextBoxes(){
    $('input:text').each(
        function(){
            $(this)
                .val($(this).attr('placeholder'))
                .css('color','#999');
            $(this).click(
                function(){
                    $(this)
                        .val('')
                        .css('color','#000');
                });
            $(this).blur(
                function(){
                    if ($(this).val() === ''){
                        $(this)
                            .val($(this).attr('placeholder'))
                            .css('color','#999');
                    }
                });
        }
    );
}

function onCreateFamilyClicked(evt) {
	console.log("onCreateFamilyClicked()");
	parent.cordova.plugins.Keyboard.close();

	removeTips();

	m_creatingUser = true;

	var foundIssue = false;

	var username = $('#name').val();
	if(!validateName(username)) {
		console.log("Username is bad"); 
	  	$("#nameTip").text(parent.Tgoma.LanguageManager.getString("name_tip")).addClass("tip-state-visible");
  		$('#name').addClass("input-state-error");	
		foundIssue = true;
	}
	var email = $("#email").val();
	email = email.toLowerCase();

	if(!validateEmail(email)) {
	  	$("#emailTip").text(parent.Tgoma.LanguageManager.getString("email_tip_1")).addClass("tip-state-visible");
  		$('#email').addClass("input-state-error");	
		foundIssue = true;
	}

	if(containsSpecialCharacters(email))
	{
	  	$("#emailTip").text(parent.Tgoma.LanguageManager.getString("email_tip_2")).addClass("tip-state-visible");
  		$('#email').addClass("input-state-error");	
		foundIssue = true;
	}

	var password = $("#password").val();
	var confirmPassword = $("#confirmPassword").val();

	if (password != confirmPassword) {
		console.log("Passwords don't match");
  		$("#passwordTip").text(parent.Tgoma.LanguageManager.getString("passwords_dont_match")).addClass("tip-state-visible");
  		$('#password').addClass("input-state-error");	
		
  		$("#confirmPasswordTip").text(parent.Tgoma.LanguageManager.getString("passwords_dont_match")).addClass("tip-state-visible");
  		$('#confirmPassword').addClass("input-state-error");	
		foundIssue = true;
	}

	if(!validatePassword(password)) {
		console.log("Password Bad");
		if(password.length < 6 || password.length > 60)
		{
	  		$("#passwordTip").text(parent.Tgoma.LanguageManager.getString("password_tip_1")).addClass("tip-state-visible");
  		}
  		else
  		{
	  		$("#passwordTip").text(parent.Tgoma.LanguageManager.getString("password_tip_2")).addClass("tip-state-visible");
		}
  		$('#password').addClass("input-state-error");	
		foundIssue = true;
	}

	var serialNumber = $("#serialNumber").val();
	if(!validateSerialNumber(serialNumber))
	{
		console.log("Serial Number is bad");
	  	
	  	$("#serialNumberTip").text(parent.Tgoma.LanguageManager.getString("serial_number_missing")).addClass("tip-state-visible");
  		$('#serialNumber').addClass("input-state-error");	
		foundIssue = true;
	}

	var conditionsAccepted = $("#conditionsCheckbox").is(':checked');
	if (!conditionsAccepted) {
		foundIssue = true;
		$("#conditionsCheckboxText").css("color","red");
	}

	if(foundIssue) {
		console.log("There were errors");
		return;
	}
 	disableButtons();
	parent.TgomaMessaging.callPlugin(null, onFamilyCreatedError, this, parent.TgomaMessaging.USER_MODULE_NAME, "createFamily", [username, email, password, serialNumber]);
}

function onLoginButtonClicked() {
	console.log("onLoginButtonClicked()");
	parent.cordova.plugins.Keyboard.close();

	removeLoginTips();
	var foundIssue = false;

	m_creatingUser = false;
		
	var email = $("#existingEmail").val();
	email = email.toLowerCase();
	if(!validateEmail(email)) {
		console.log("Email is bad");
	  	
	  	$("#existingEmailTip").text(parent.Tgoma.LanguageManager.getString("email_tip_1")).addClass("tip-state-visible");
  		$('#existingEmail').addClass("input-state-error");	
		foundIssue = true;
	}
	if(containsSpecialCharacters(email))
	{
	  	$("#existingEmailTip").text(parent.Tgoma.LanguageManager.getString("email_tip_2")).addClass("tip-state-visible");
  		$('#existingEmail').addClass("input-state-error");	
		foundIssue = true;
	}
	var password = $("#existingPassword").val();
	if(!validatePassword(password)) {
		console.log("Password Bad");
		if(password.length < 6 || password.length > 60)
		{
	  		$("#existingPasswordTip").text(parent.Tgoma.LanguageManager.getString("password_tip_1")).addClass("tip-state-visible");
  		}
  		else
  		{
	  		$("#existingPasswordTip").text(parent.Tgoma.LanguageManager.getString("password_tip_2")).addClass("tip-state-visible");
		}
  		$('#existingPassword').addClass("input-state-error");	
		foundIssue = true;
	}
	
	if(foundIssue) {
		console.log("There were errors");
		return;
	}
	disableButtons();
    parent.Tgoma.UserHelper.familyLoginReturnedSignal.add(onFamilyLoginFailed, this);
	parent.TgomaMessaging.callPlugin(null, onFamilyLoginError, this, parent.TgomaMessaging.USER_MODULE_NAME, "loginFamily", [email, password]);
}

// ES 30/6/17 not used?
function onFamilyLogin(p_outcome, p_error) {
	if (!p_outcome) { 
		enableButtons();
		onFamilyLoginError(p_error);
	} else {
		var defaultPath = 'default.htm';
	}
}

function onFamilyLoginFailed(p_success, p_error) {
	if(!p_success)
	{
		console.log("onFamilyLoginFailed()");
		enableButtons();
		$("#existingEmailTip").text(parent.Tgoma.LanguageManager.getString(p_error)).addClass("tip-state-visible");	
	}
}

function onFamilyLoginError(error) {
	console.log("onFamilyLoginError()");
	enableButtons();
	$("#existingEmailTip").text(parent.Tgoma.LanguageManager.getString(error.error)).addClass("tip-state-visible");
}

function onFamilyCreatedError(error) {
	console.log("onFamilyCreatedError");
	enableButtons();
	$("#nameTip").text(parent.Tgoma.LanguageManager.getString(error.error)).addClass("tip-state-visible");
}

function removeTips() {
	  	$("#nameTip").removeClass("tip-state-visible");
  		$('#name').removeClass("input-state-error");	
	  	$("#emailTip").removeClass("tip-state-visible");
  		$('#email').removeClass("input-state-error");	
	  	$("#passwordTip").removeClass("tip-state-visible");
  		$('#password').removeClass("input-state-error");
	  	$("#confirmPasswordTip").removeClass("tip-state-visible");
  		$('#confirmPassword').removeClass("input-state-error");
	  	$("#serialNumberTip").removeClass("tip-state-visible");
  		$('#serialNumber').removeClass("input-state-error");
}

function removeLoginTips() {
	  	$("#existingEmailTip").removeClass("tip-state-visible");
  		$('#existingEmail').removeClass("input-state-error");	
	  	$("#existingPasswordTip").removeClass("tip-state-visible");
  		$('#existingPassword').removeClass("input-state-error");	
}

function enableButtons() {
	$("#createFamilyButton").attr('disabled', false);
	$("#loginFamilyButton").attr('disabled', false);
}

function disableButtons() {
	$("#createFamilyButton").attr('disabled', true);
	$("#loginFamilyButton").attr('disabled', true);
}

function onFamilyCreated(p_outcome, p_errorOrID) {
	console.log("onFamilyCreated(" + p_outcome + ',' + p_errorOrID + ")");

	enableButtons();

	if(p_outcome)
	{
		var defaultPath = 'default.htm';
		parent.window.location.replace(defaultPath/*+"?frameID=familyPreferences"*/);
	}
	else
	{
		console.log("something went wrong. Need to show this error somewhere.");
		if(m_creatingUser)
		{
	  		$("#emailTip").text(parent.Tgoma.LanguageManager.getString(p_errorOrID)).addClass("tip-state-visible");
  			$('#email').addClass("input-state-error");
  		}
  		else
  		{
	  		$("#existingEmailTip").text(parent.Tgoma.LanguageManager.getString(p_errorOrID)).addClass("tip-state-visible");
  			$('#existingPassword').addClass("input-state-error");
  			$('#existingEmail').addClass("input-state-error");
  		}	
	}
}

function onFamilyReturned(p_familyExists) {
	console.log("onFamilyReturned" + p_familyExists);

	if(p_familyExists)
	{
		console.log("got a family");
		var defaultPath = 'default.htm';
		parent.window.location.replace(defaultPath);
	}
}

function onFamilyMembersDownloaded(p_outcome) {
	console.log("On Family Memebers Downloaded: " + p_outcome.succeeded);
	setTimeout(function(){
		if(p_outcome.succeeded)
		{
			onShouldRetrySyncSelected(false);
		}
		else
		{
			parent.showConfirm(parent.Tgoma.LanguageManager.getString("error_getting_login_details"), onShouldRetrySyncSelected);
		}
	},1);
}

function onShouldRetrySyncSelected(shouldRetry)
{
	if(shouldRetry)
	{
		parent.TgomaMessaging.callPlugin(null, onRetrySyncError, this, parent.TgomaMessaging.USER_MODULE_NAME, "syncUsers", [false]);
	}
	else
	{

		if(parent.m_isParentApp)
		{
			//refresh the page
			location.reload();
		}
		else
		{
			var defaultPath = parent.getPathByTag('default.htm');
			parent.window.location.replace(defaultPath);
		}
	}
}

function onRetrySyncError(error){
	console.log(error);
	onFamilyMembersDownloaded(false);
}

function validateName(p_name) {
    var regexp = /^([\-\u0400-\u04FF\u4E00-\u9FFFA-Z0-9]{2,10})$/i
	return regexp.test(p_name)//p_name.length >= 2 && p_name.length <= 10;
}

function validateEmail(p_email) {
	if(!p_email)//One of the regexs breaks on an empty string.
	{
		p_email = " ";
	}

    // E.S. 8/8/17 Updated this regex to match the one used to automatically validate input fields of type "email"
    // The reason for this being here too is that iOS doesn't seem to apply the built-in validation.
    // This isn't going to be 100% accurate but should be consistent with existing android behaviour (see http://emailregex.com/ for more)
	var regexp = /^[a-zA-Z0-9.!#$%&*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/i;
	return regexp.test(p_email);
}

function containsSpecialCharacters(p_string)
{
	console.log("containsSpecialCharacters("+ p_string + ")");

	var containsEmoji = p_string.search(/([\uD800-\uDBFF][\uDC00-\uDFFF])/g) >=0 || 
    	p_string.search(/([\uE000-\uF8FF]|\uD83C[\uDF00-\uDFFF]|\uD83D[\uDC00-\uDDFF])/g) >=0; //Trying to find if there are emojis


  	return containsEmoji;
}

function validatePassword(p_password) {
    var regexp = /^([\u0400-\u04FF\u4E00-\u9FFFa-zA-Z0-9@*#\`\~\!\$\%\^\&\(\)\_\-\=\+\<\>\,\.\/\?\'\"\ ']{6,60})$/
	return regexp.test(p_password);
}

function validateSerialNumber(p_serialNumber) {
	console.log(p_serialNumber);
	var serialNumber = parseInt(p_serialNumber);
	return (serialNumber >= 100000 && serialNumber <= 353000 && serialNumber != 104567 && serialNumber != 123456) || serialNumber == 999999;
}

function onPrivacyPolicyClicked(evt)
{
	loadOverlayFrame(parent.getPathByTag('privacyPolicy.htm'));
}

function loadOverlayFrame(address)
{
    console.log("loadOverlayFrame(" + address +")");
    m_showingOverlay = true;

    parent.document.getElementById("overlayFrame").style.visibility = 'visible';
    parent.document.getElementById("overlay").style.display = 'block';

    parent.document.getElementById("overlayFrame").src = address;
}

function onPlayAsGuestClicked(evt)
{
    parent.showConfirm(parent.Tgoma.LanguageManager.getString("guest_confirmation"), onPlayAsGuestConfirmSelected)
}

function onPlayAsGuestConfirmSelected(result)
{    
	if(result == true)
    {
        onPlayAsGuestConfirmed();
    }
}

function onPlayAsGuestConfirmed()
{
    var defaultPath = 'default.htm';
    parent.window.location.replace(defaultPath);
}

function onBackKeyDown() {
	hideOverlayFrame();
}

function onResetPasswordReturned(e) {
	console.log("[FamilyLogin] onResetPasswordReturned()");

	parent.document.removeEventListener('onResetPassword', onResetPasswordReturned);

	var p_succeeded = e.succeeded;

    parent.plugins.ProgressView.hide();

    // Don't block the thread!
	setTimeout(function() {
		if (p_succeeded) {
			parent.showAlert("password_reset_success");
		} else {
			parent.showAlert("password_reset_fail");
		}
	}, 1);
}

//Callback for when the keyboard is hidden on android, to set the app back into lean mode to hide the status bar.
function onKeyboardHide() {
    console.log("onKeyboardHide()");
    AndroidFullScreen.immersiveMode();
}

//Callback for when the keyboard is hidden on android, to set the app back into lean mode to hide the status bar.
function onKeyboardShow() {
    console.log("onKeyboardShow()");
    AndroidFullScreen.showSystemUI();
}

function onSerialNumberHelpClicked()
{
	parent.showAlert("serial_number_tip");
};

// TODO: SF-2330 Need to change from prompt to this.
function showRestPasswordPrompt(p_callback)
{
    $("#reset-password-dialog").submit(submitPasswordReset);

	$("#reset-password-dialog").dialog({
	//position: { my: "bottom", at: "center", of: window },
	height: "auto",
	width: "60%",
	modal: true,
	resizable: false,
	open: function(event, ui) { $(".ui-dialog-titlebar-close").hide(); },
	buttons: {
	  Submit: submitPasswordReset,
	  Cancel: function() {
    	$("#reset-password-dialog").dialog( "close" );
	  }
    }
  });

  $("#descriptionText").text(parent.Tgoma.LanguageManager.getString("enter_email"));
    
  $("#reset-password-dialog").show();
  $("#reset-password-dialog").dialog( "option", "position", { my: "center", at: "center center-20%", of: window} );

}

function submitPasswordReset(e)
{
	if(e != null)
    {
      e.preventDefault();
    }
	console.log("submitPasswordReset()");

     $("#reset-password-dialog").dialog( "close" );

	_email = $("#passwordResetEmail").val();
	parent.document.addEventListener('onResetPassword', onResetPasswordReturned, false);
	_email = _email.toLowerCase();
	parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.USER_MODULE_NAME, 
		"resetPassword", [_email]);

    parent.plugins.ProgressView.show(parent.Tgoma.LanguageManager.getString("sending_email"), "CIRCLE", true);
}