var countryList = ["Australia","Austria","Belgium","Brunei","Canada","Chile","China","Czech Republic","Denmark","England","France","Germany","Ireland","Japan","Lebanon","Luxembourg","Netherlands","New Zealand","Northern Ireland","Russia","Scotland","Singapore","South Korea","Sweden","Switzerland","Thailand","United Arab Emirates","USA","Wales","Other"];
var nz_regions = ["Northland","Auckland","Waikato","Bay of Plenty","Gisborne","Hawke's Bay","Taranaki","Manawatu-Wanganui","Wellington","Tasman","Nelson","Marlborough","West Coast","Canterbury","Otago","Southland"];
var usa_regions = ["Alabama","Alaska","Arizona","Arkansas","California","Colorado","Connecticut","Delaware","Florida","Georgia","Hawaii","Idaho","Illinois", "Indiana","Iowa","Kansas","Kentucky","Louisiana","Maine","Maryland","Massachusetts","Michigan","Minnesota","Mississippi","Missouri","Montana","Nebraska","Nevada","New Hampshire","New Jersey","New Mexico","New York","North Carolina","North Dakota","Ohio","Oklahoma","Oregon","Pennsylvania","Rhode Island","South Carolina","South Dakota","Tennessee","Texas","Utah","Vermont","Virginia","Washington","West Virginia","Wisconsin","Wyoming"];
var aus_regions = ["Australian Capital Territory", "New South Wales", "Northern Territory","Queensland", "South Australia", "Tasmania", "Victoria","Western Australia"];
var china_regions = ["Anhui Province","Beijing Municipality","Chongqing Municipality","Fujian Province","Gansu Province","Guangdong Province","Guangxi Zhuang Autonomous Region","Guizhou Province","Hainan Province","Hebei Province","Heilongjiang Province","Henan Province","Hong Kong Special Administrative Region","Hubei Province","Hunan Province","Inner Mongolia Autonomous Region","Jiangsu Province","Jiangxi Province","Jilin Province","Liaoning Province","Macau Special Administrative Region","Ningxia Hui Autonomous Region","Qinghai Province","Shaanxi Province","Shandong Province","Shanghai Municipality","Shanxi Province","Sichuan Province","Taiwan Province","Tianjin Municipality","Tibet Autonomous Region","Xinjiang Uyghur Autonomous Region","Yunnan Province","Zhejiang Province"];
var england_regions = ["South East","London","North West","East of England","West Midlands","South West","Yorkshire and the Humber","East Midlands","North East"];
var canada_regions = ["Alberta","British Columbia","Manitoba","New Brunswick","Newfoundland and Labrador","Nova Scotia","Northwest Territory","Nunavut","Ontario","Prince Edward Island","Quebec","Saskatchewan","Yukon"];


$(document).ready(function() {
  window.onerror = parent.window.onerror;

  $('#save-changes-button').click(onSaveChangesClicked);

  $("#changePasswordButton").click(onChangePasswordClicked);

  $("#cancelButton").click(function() {
    if (parent.getURLParameter("ftue", location) == "true") {
      parent.loadFrame("ftue", "nav-hidden=true");
    } else {
      parent.loadFrame("settings");
    }
  });

  $(".password-dialog").load("confirmPassword.htm");

  // Load the confirmPassword javascript now
  $.getScript("confirmPassword.js", function()
  {
    $("#password-entry-form").submit(function(e) {
      console.log("[FamilyPreferences] password-entry-form.submit()");
      e.preventDefault();
      return false;
    });
  });

  for(var i in countryList) {
    $('#countrySelector').append($('<option>', {
        value: countryList[i],
        text: parent.Tgoma.LanguageManager.getString(countryList[i])
    }));
  }

  onFamilyAccountReturned(parent.Tgoma.UserHelper.currentFamilyAccount);

});

$(window).unload(function () {
  parent.document.removeEventListener('onFamilyAccountUpdated', onFamilyAccountUpdated);
})

function onChangePasswordClicked() {
  if (parent.getURLParameter("ftue", location) == "true") {
    parent.loadFrame("changePassword", "nav-hidden=true?ftue=true");
  } else {
    parent.loadFrame("changePassword");
  }
}

function onSettingChanged() {
  $("#save-changes-button").css("background-color", "#8CB53F");
}

function onFamilyAccountReturned(p_familyAccount) {
  console.log("onFamilyAccountReturned(" + p_familyAccount + ")");

  // If they're a guest account, redirect them.
  if (p_familyAccount.m_email == "") {
    parent.loadFrame("familyLoginFrame");
    return;
  }


  $("#countrySelector").val(p_familyAccount.m_country || "Not Set");
  updateRegionAndFlag(p_familyAccount.m_country);
  $("#regionSelector").val(p_familyAccount.m_region || "Not Set");

  // This is pretty gross
  $("#radio-date-metric").prop('checked', !p_familyAccount.m_dateIsUSFormat);
  $("#radio-date-imperial").prop('checked', p_familyAccount.m_dateIsUSFormat);
  $("#radio-energy-metric").prop('checked', !p_familyAccount.m_energyIsUSFormat);
  $("#radio-energy-imperial").prop('checked', p_familyAccount.m_energyIsUSFormat);
  $("#radio-units-metric").prop('checked', !p_familyAccount.m_unitsAreUSFormat);
  $("#radio-units-imperial").prop('checked', p_familyAccount.m_unitsAreUSFormat);

  // Add a change listener to all radio buttons on the screen
  $("form input:radio").change(onCheckboxChanged);

  // Set the family name and email text labels.
  $("#familyNameText").html(parent.Tgoma.LanguageManager.getString("LBL_family_name") + " " + p_familyAccount.m_familyName);
  $("#emailText").html(parent.Tgoma.LanguageManager.getString("LBL_email") + " " + p_familyAccount.m_email);
  if(p_familyAccount.m_serialNumber)
  {
      $("#serialNumberText").html(parent.Tgoma.LanguageManager.getString("LBL_serial_number") +" "+ p_familyAccount.m_serialNumber);
  }
}

function onSaveChangesClicked(evt) {
  console.log("onSaveChangesClicked()");

 	// Validity testing!
  var error_tip = parent.Tgoma.LanguageManager.getString("invalid_country_tip");
	var _valid = checkDropdownValidity($("#countrySelector"), error_tip);
  error_tip = parent.Tgoma.LanguageManager.getString("invalid_region_tip", $("#countrySelector").find('option:selected').text());
	_valid = checkDropdownValidity($("#regionSelector"), error_tip) && _valid;
	console.log("onSaveChangesClicked validation returned: " + _valid);

  if (_valid) {
    parent.TgomaMessaging.callPlugin(
      function(result)
      {
        if(!result)
        {
          parent.Tgoma.UserHelper.familyLoginReturnedSignal.addOnce(onLoginComplete, this);
          setTimeout(function() {
            setPasswordConfirmationDescription("Please enter your password to continue using tgoma.");
            showConfirmPasswordDialog();
          }, 100); //Wait a second just to make sure we're all good. No rush.
        }
        else
        {
          parent.document.addEventListener("onFamilyAccountUpdated", onFamilyAccountUpdated, false);
          parent.TgomaMessaging.Internal.UserManagement.updateFamilyAccountPreferences(null, null,
              $("#countrySelector").find('option:selected').val(),
              $("#regionSelector").find('option:selected').val(),
              $("#radio-date-imperial").is(':checked'),
              $("#radio-energy-imperial").is(':checked'),
              $("#radio-units-imperial").is(':checked'));
        }
      },
      null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getIsAuthTokenValid", []);
  }
}

function checkDropdownValidity(p_dropdown, p_tip) {

  p_dropdown.removeClass("input-state-error");

	var _valid = p_dropdown.find('option:selected').val() != "Not Set";

  if (!_valid) {
    p_dropdown.addClass("input-state-error");
   	//$("#validationTips").removeClass("tip-state-invisible");
   	//$("#validationTips").addClass("tip-state-visible");
    //$("#validationTips").text(p_tip);
    parent.showAlert(p_tip)
  }

	return _valid;
}

function onLoginComplete(p_outcome, p_error)
{
  if(p_outcome)
  {
    parent.document.addEventListener("onFamilyAccountUpdated", onFamilyAccountUpdated, false);

    parent.TgomaMessaging.Internal.UserManagement.updateFamilyAccountPreferences(null, null,
      $("#countrySelector").find('option:selected').val(),
      $("#regionSelector").find('option:selected').val(),
      $("#radio-date-imperial").is(':checked'),
      $("#radio-energy-imperial").is(':checked'),
      $("#radio-units-imperial").is(':checked'));
  }
  else
  {
    parent.showAlert("Login failed with error: " + p_error + ". Please try again.");
  }
}

function onFamilyAccountUpdated (e) {
  console.log("onFamilyAccountUpdated()");

  setTimeout(function() {
    parent.TgomaMessaging.Internal.UserManagement.setHasSetFamilySettings(true);
    parent.showAlert("preferences_saved");
    if (parent.getURLParameter("ftue", location) == "true") {
      parent.loadFrame("ftue", "nav-hidden=true");
    }
    else
    {
      parent.loadFrame("settings");
    }
  }, 1);
}

function onCountryChanged() {
  console.log("onCountryChanged()");
  var country = $("#countrySelector").find('option:selected').val();
  updateRegionAndFlag(country);
  onSettingChanged();

 	//$("#validationTips").removeClass("tip-state-visible");
 	//$("#validationTips").addClass("tip-state-invisible");
  $("#countrySelector").removeClass("input-state-error");
  $("#regionSelector").removeClass("input-state-error");
}

function onRegionChanged() {
  console.log("onRegionChanged()");
  onSettingChanged();

 	//$("#validationTips").removeClass("tip-state-visible");
 	//$("#validationTips").addClass("tip-state-invisible");
  $("#regionSelector").removeClass("input-state-error");
}

function onCheckboxChanged() {
  console.log("onCheckboxChanged()");
  onSettingChanged();
}

function updateRegionAndFlag(p_country) {
  if (p_country != "Other" && p_country != "" && p_country != "Not Set") {
    $("#flag").attr('src', p_country);
    $("#flag").show();
  } else {
    $("#flag").hide();
  }


  $("#regionSelector").html("");
  var regionList = getRegionList();

  if (regionList[0] == "") {
    // Hide the region selector
    $('#regionField').hide();
  } else {
    $('#regionField').show();
    // reset selected value to Not Set
    $('#regionSelector').append($('<option>', {
        selected: true,
        hidden:true,
        disabled: true,
        value: "Not Set",
        text: parent.Tgoma.LanguageManager.getString("Not Set")
    }));
  }

  //Populate the regions selector with the regions for that country.
  for(var i in regionList)
  {
    $('#regionSelector').append($('<option>', {
        value: regionList[i],
        text: parent.Tgoma.LanguageManager.getString(regionList[i])
    }));
  }
}

function getRegionList() {
  var option = $("#countrySelector").find('option:selected').val();
  var regionList;
  if(option == "New Zealand") {
    regionList = nz_regions;
  }
  else if(option == "USA" ) {
    regionList = usa_regions;
  }
  else if(option == "Australia") {
    regionList = aus_regions;
  }
  else if(option == "China") {
    regionList = china_regions;
  }
  else if(option == "England") {
    regionList = england_regions;
  }
  else if(option == "Canada") {
    regionList = canada_regions;
  }
  else {
    regionList = [""];
  }
  return regionList;
}
