var m_ftueProgress = 0;
var m_maxSteps = 5;
var m_connected = false;
var m_tabletOriented = false;
var m_hasSetTrampolineModel = false;


$(document).ready(function() {
	console.log("[FTUE] ready()")

	document.addEventListener("localisedFramePopulated", onLocalisedFramePopulated);
});


$(window).unload(function() {
    parent.Tgoma.ConnectionHelper.connectionSignal.remove(onConnectionReturned, this.document);
	parent.Tgoma.TrampolineHelper.trampolineDetailsChangedSignal.remove(onTrampolineDetailsUpdated, this.document);
});

function onLocalisedFramePopulated(){
	console.log("onLocalisedFramePopulated");

	document.removeEventListener("localisedFramePopulated", onLocalisedFramePopulated);

	parent.m_doingFtue = true;

	$("#progress-bar").progressbar({
        value: false
    });

	parent.Tgoma.TrampolineHelper.trampolineDetailsChangedSignal.addOnce(onTrampolineDetailsUpdated, this);

	// Get connection status, and establish a listener.

    onConnectionReturned(parent.Tgoma.ConnectionHelper.isConnected);
    parent.Tgoma.ConnectionHelper.connectionSignal.addOnce(onConnectionReturned, this);

    parent.TgomaMessaging.Internal.UserManagement.getNumFamilyMembers(onGetNumFamilyMembersReturned, this);

    $("#check-item-button-preferences").unbind().click(function() {
			parent.window.analytics.trackEvent("FTUE", "FamilyAccDoStepPressed");
    	parent.loadFrame("familyPreferences", "nav-hidden=true?ftue=true");
    })

    $("#check-item-button-family-members").unbind().click(function() {
			parent.window.analytics.trackEvent("FTUE", "NewPlayerDoStepPressed");
    	parent.loadFrame("createPlayer", "nav-hidden=true?ftue=true");
    })

    $("#check-item-button-orientate").unbind().click(function() {
			parent.window.analytics.trackEvent("FTUE", "SetPositionStepPressed");
    	parent.loadFrame("configureTrampoline", "nav-hidden=true?ftue=true");
    })

    $("#check-item-button-connect").off().on('click', function() {
			parent.window.analytics.trackEvent("FTUE", "ConnectDoStepPressed");
    	parent.showAlert("ftue_connection_tip");
    });

    $("#skip-button").click(onSkipButtonClicked)

    console.log(parent.Tgoma.UserHelper.currentFamilyAccount);
    // If Guest, hide the preferences and family members bit, and the "don't show this again" bit
		// TGOM-25 Guest should show the "Don't show again" checkbox (4/4/17)
    if (parent.Tgoma.UserHelper.currentFamilyAccount.m_parseId == "") {
    	m_maxSteps = 3;
    	$("#preferences-container").hide();
    	$("#family-members-container").hide();
    }

    // Listen for model change on the UI
    $("#check-item-button-model-select").unbind();
	$("#check-item-button-model-select").change(onModelChanged);


	parent.TgomaMessaging.Internal.UserManagement.getHasSetFamilySettings(onHasSetFamilySettingsReturned, this);
}


function onHasSetFamilySettingsReturned(p_hasSetFamilySettings) {
    console.log("[FTUE] onHasSetFamilySettingsReturned(" + p_hasSetFamilySettings + ")");
	if (p_hasSetFamilySettings) {
    	// One step forward
    	addProgress("preferences");
	}
}

function onTrampolineDetailsUpdated(p_hardwareID, p_trampolineModel, p_hardwareVersion, p_firmwareVersion) {
	console.log("[FTUE] onTrampolineDetailsUpdated(" + p_hardwareID + ", " + p_trampolineModel + ", " + p_hardwareVersion + ", " + p_firmwareVersion + ")");

	onTrampolineModelSelectOptionsChanged(p_firmwareVersion, p_trampolineModel);
	parent.TgomaMessaging.Internal.Trampoline.getHasSetTrampolineOrientation(onHasSetTrampolineOrientationReturned, this);
}

function onTrampolineModelSelectOptionsChanged(p_firmwareVersion, p_trampolineModel) {
  console.log("[FTUE] onTrampolineModelSelectOptionsChanged(" + p_firmwareVersion + ", " + p_trampolineModel + ")");

	//reset the #check-item-button-model-select options as these depend on the firmware version
	$('#check-item-button-model-select').empty();

	if (p_firmwareVersion == "unset") {
		// If there is no firmware version we can't know what models to offer and it's almost certainly
		// because the trampoline is not connected or something has gone wrong with the firmware.
		$('#check-item-button-model-select').append($('<option>', {
			value: 0,
			text: parent.Tgoma.LanguageManager.getString("ftue_connect_first")
		}));
	}
	else {
		var supportedModels = parent.Tgoma.TrampolineHelper.allTrampolineModels;
		for(var i in supportedModels)
		{
			var model = supportedModels[i];
			$('#check-item-button-model-select').append($('<option>', {
				value: model.value,
				text: parent.Tgoma.LanguageManager.getString(model.tag)
			}));
		}

		if (p_trampolineModel != "unset" && p_trampolineModel != "") {
			onSetTrampolineModelComplete();
		}
		else {
			$("#check-item-button-model-button").removeClass("blocked").removeClass("complete").addClass("incomplete");
			$("#check-item-button-model-button").text(parent.Tgoma.LanguageManager.getString("ftue_do_this_step"));
	    $("#check-item-button-model-button").attr("texttag", 'ftue_do_this_step');
			$("#check-item-button-model-select" + " option[value=0]").text(parent.Tgoma.LanguageManager.getString("ftue_do_this_step"));
	    $("#check-item-button-model-select" + " option[value=0]").attr("texttag", 'ftue_do_this_step');
		}
	}
}

function onSkipButtonClicked() {
	console.log("[FTUE] onSkipButtonClicked");

	if (m_ftueProgress == m_maxSteps) {
		parent.window.analytics.trackEvent("FTUE", "CompletedSetup");
		parent.TgomaMessaging.Internal.UserManagement.setHasCompletedFtue(true);
	}
	else if ($("#dont-show-again-check").prop("checked")) {
		parent.window.analytics.trackEvent("FTUE", "SkipForever", m_ftueProgress);
		parent.TgomaMessaging.Internal.UserManagement.setHasCompletedFtue(true);
	}
	else {
		parent.window.analytics.trackEvent("FTUE", "SkipOnce", m_ftueProgress);
	}

	parent.m_doingFtue = false;

	parent.loadFrame("games");
}

function onModelChanged() {
	console.log("[FTUE] onModelChanged")
	var option = parseInt($("#check-item-button-model-select").find('option:selected').val());
	window.changeHappened = false; //For some reason this event gets fired twice. Because I can't seem to track down why, I will deal with it in a hackier way sorry.
	if(option > 0) {

		setTimeout(function(){
			if(!changeHappened)
			{
				parent.window.analytics.trackEvent("FTUE", "TrampolineModelSelected", $("#check-item-button-model-select").find('option:selected').text());
				changeHappened = true;

				function hasModel(model) {
    			return model["value"] === option;
				}

				var isSupportedModel = parent.Tgoma.TrampolineHelper.supportedTrampolineModels.some(hasModel);
				if (isSupportedModel) {
					var message = parent.Tgoma.LanguageManager.getString("ftue_confirm_trampoline_model", $("#check-item-button-model-select").find('option:selected').text());
					window.option = option;
					parent.showConfirm(message, onModelChangeConfirmSelected);
				}
				else {
					parent.showAlert(parent.Tgoma.LanguageManager.getString("invalid_trampoline_model"));
				}
			}
		}, 1); // iOS needed a small timeout before showing the confirm dialog or else the selector wasn't hidden, and the confirm wasn't shown.

		setTimeout(resetSelector, 1); // Need a small delay before changing the selector on iOS.
	}
}

function onModelChangeConfirmSelected(result)
{
	if (result) {
		parent.TgomaMessaging.callPlugin(onSetTrampolineModelComplete, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "setTrampolineModel", [window.option]);
	}
}

function onSetTrampolineModelComplete() {
	// Only allow this to count as progress the first time they change it
	if (!m_hasSetTrampolineModel) {
    	m_hasSetTrampolineModel = true;

        // One step forward
    	addProgress("model-select");
    }
}

function resetSelector() {
	$("#check-item-button-model-select option[value=0]").text(parent.Tgoma.LanguageManager.getString("ftue_completed"));
	$("#check-item-button-model-select option[value=0]").attr("texttag", 'ftue_completed');
	$("#check-item-button-model-select").val(0);
}

function onConnectionReturned(p_connected) {
    console.log("[FTUE] onConnectionReturned(" + p_connected + ")");
    m_connected = p_connected;
    if(m_connected) {
    	//If we were already connected we need to get the trampoline details.
    	parent.TgomaMessaging.callPlugin(
    		function onTrampolineDetailsReturned(trampDetails){
				  console.log("[FTUE] onConnectionReturned FirmwareVersion = " + trampDetails["firmwareVersion"]);
    			parent.Tgoma.TrampolineHelper.m_firmwareVersion = trampDetails["firmwareVersion"];
					if (trampDetails["firmwareVersion"] != "unset"){
						onTrampolineModelSelectOptionsChanged(trampDetails["firmwareVersion"], trampDetails["trampolineModel"]);
					}
    		},
				null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getTrampolineDetails");

			// One step forward
			addProgress("connect");

			unblock("model-select");
			unblock("orientate");

			$(".connection-icon").attr("src", "connected_icon.png");

			parent.TgomaMessaging.Internal.Trampoline.getHasSetTrampolineOrientation(onHasSetTrampolineOrientationReturned, this);
    }
    else {
        // One step back
    	removeProgress("connect");

    	if (m_hasSetTrampolineModel) {
    		m_hasSetTrampolineModel = false;
			removeProgress("model-select");
		}
    	block("model-select");

    	if (m_tabletOriented) {
			removeProgress("orientate");
			m_tabletOriented = false;
		}
		block("orientate");

        $(".connection-icon").attr("src", "disconnected_icon.png");
    }
}

function onHasSetTrampolineOrientationReturned(p_hasSetTrampolineOrientation) {
    console.log("[FTUE] onHasSetTrampolineOrientationReturned(" + p_hasSetTrampolineOrientation + ")");
    // This trampoline has been configured
    if (p_hasSetTrampolineOrientation != 0) {

    	// If we hadn't been orientated before, mark it as orientated now.
    	if (!m_tabletOriented) {
	    	// One step forward
	    	addProgress("orientate");
	    	m_tabletOriented = true;
	    }
    } else {
    	m_tabletOriented = false
    }
}

function onGetNumFamilyMembersReturned(p_numFamilyMembers) {
    console.log("[FTUE] onGetNumFamilyMembersReturned(" + p_numFamilyMembers + ")");
	if (p_numFamilyMembers > 1) {
		// One step forward
    	addProgress("family-members");
	}
}

function addProgress(p_item) {
    console.log("[FTUE] addProgress(" + p_item + ")");
	m_ftueProgress++;

	$("#check-item-bullet-" + p_item).attr("src", "blue-tick.png");
	$("#check-item-button-" + p_item).removeClass("incomplete").removeClass("blocked").addClass("complete");

	if (p_item == "model-select") {
		$("#check-item-button-model-select" + " option[value=0]").text(parent.Tgoma.LanguageManager.getString("ftue_completed"));
		$("#check-item-button-model-select option[value=0]").attr("texttag", 'ftue_completed');
		$("#check-item-button-model-button").removeClass("incomplete").removeClass("blocked").addClass("complete");
		$("#check-item-button-model-button").text(parent.Tgoma.LanguageManager.getString("ftue_completed"));
		$("#check-item-button-model-button").attr("texttag", 'ftue_completed');
	} else {
		$("#check-item-button-" + p_item).text(parent.Tgoma.LanguageManager.getString("ftue_completed"));
	}

	updateProgress();
}

function block(p_item) {
    console.log("[FTUE] block(" + p_item + ")");
	$("#check-item-button-" + p_item).addClass("blocked").removeClass("incomplete");
	$("#check-item-button-" + p_item).prop("disabled", true);

	if (p_item == "model-select") {
		$("#check-item-button-model-button").addClass("blocked").removeClass("incomplete");
		$("#check-item-button-model-button").text(parent.Tgoma.LanguageManager.getString("ftue_connect_first"));
		$("#check-item-button-model-button").attr("texttag", 'ftue_connect_first');
		$("#check-item-button-" + p_item).prop("disabled", true);
		$("#check-item-button-" + p_item + " option[value=0]").text(parent.Tgoma.LanguageManager.getString("ftue_connect_first"));
		$("#check-item-button-" + p_item + " option[value=0]").attr("texttag", 'ftue_connect_first');
	} else {
		$("#check-item-button-" + p_item).text(parent.Tgoma.LanguageManager.getString("ftue_connect_first"));
		$("#check-item-button-" + p_item).attr("texttag", 'ftue_connect_first');
	}
}

function unblock(p_item) {
    console.log("[FTUE] unblock(" + p_item + ")");
	$("#check-item-button-" + p_item).removeClass("blocked").addClass("incomplete");
	$("#check-item-button-" + p_item).prop("disabled", false);

	if (p_item == "model-select") {
		var supportedModels = parent.Tgoma.TrampolineHelper.allTrampolineModels;

		$("#check-item-button-model-select").html("");

		$('#check-item-button-model-select').append($('<option>', {
			value: 0,
			text: parent.Tgoma.LanguageManager.getString("ftue_connect_first")
		}));

		for(var i in supportedModels)
		{
			var model = supportedModels[i];
			$('#check-item-button-model-select').append($('<option>', {
				value: model.value,
				text: parent.Tgoma.LanguageManager.getString(model.tag)
			}));
		}

		$("#check-item-button-model-button").removeClass("blocked").addClass("incomplete");
		$("#check-item-button-model-button").text(parent.Tgoma.LanguageManager.getString("ftue_do_this_step"));
		$("#check-item-button-model-button").attr("texttag", 'ftue_do_this_step');
		$("#check-item-button-" + p_item).prop("disabled", false);
		$("#check-item-button-model-button").addClass("dropdown-center-hack-small").removeClass("dropdown-center-hack-large");
		$("#check-item-button-" + p_item + " option[value=0]").text(parent.Tgoma.LanguageManager.getString("ftue_do_this_step"));
		$("#check-item-button-" + p_item + " option[value=0]").attr("texttag", 'ftue_do_this_step');
	} else {
		$("#check-item-button-" + p_item).text(parent.Tgoma.LanguageManager.getString("ftue_do_this_step"));
		$("#check-item-button-" + p_item).attr("texttag", 'ftue_do_this_step');
	}
}

function removeProgress(p_item) {
    console.log("[FTUE] removeProgress(" + p_item + ")");
    // FTUE progress can't go below 0
	m_ftueProgress = Math.max(0, m_ftueProgress-1);

	$("#check-item-bullet-" + p_item).attr("src", "blue-bullet.png");
	$("#check-item-button-" + p_item).addClass("incomplete").removeClass("complete");


	if (p_item != "model-select") {
		$("#check-item-button-" + p_item).text(parent.Tgoma.LanguageManager.getString("ftue_do_this_step"));
	}

	updateProgress();
}

function updateProgress() {
    console.log("[FTUE] updateProgress(" + m_ftueProgress + ")");
	$(".progress-bar-text").text(parent.Tgoma.LanguageManager.getString("ftue_percentage_complete", Math.round((m_ftueProgress / m_maxSteps) * 100).toString()));


	$("#progress-bar").progressbar("option", {
        value: (m_ftueProgress / m_maxSteps) * 100
    })

	// When complete, adjust the button
    if (m_ftueProgress >= m_maxSteps) {
    	$("#skip-button").removeClass("negative-submit").addClass("positive-submit");
    	$("#skip-button").attr("value", parent.Tgoma.LanguageManager.getString("BTN_continue"));
    	$("#dont-show-again-check").hide();
    	$("#dont-show-again-check-label").hide();
    	$("#dont-show-again-check").prop("checked",true);
    } else {
    	$("#skip-button").removeClass("positive-submit").addClass("negative-submit");
    	$("#skip-button").attr("value", parent.Tgoma.LanguageManager.getString("BTN_skip_setup"));
    	$("#dont-show-again-check").show();
    	$("#dont-show-again-check-label").show();
    }
}
