var m_gameId;
var m_price = 9999;

$(window).unload(function () {
	parent.document.removeEventListener('onGamePurchaseReturned', onGamePurchaseReturned);
	parent.document.removeEventListener("onNetworkError", onNetworkError);

})

$(window).load(function() {

	window.onerror = parent.window.onerror;
	// Disable page scrolling
	document.addEventListener("touchmove", function(e){ e.preventDefault(); }, false);


	parent.document.addEventListener("onGamePurchaseReturned", onGamePurchaseReturned, false);
	parent.document.addEventListener("onNetworkError", onNetworkError, false);

	// Load the confirm password files

  	$(".password-dialog").load(parent.getPathByTag("confirmPassword.htm"));
	$.getScript(parent.getPathByTag("confirmPassword.js"))


	// Grab the URL parameter telling us which game we're looking at
	m_gameId = parent.getURLParameter("gameId", location);

	// Fetch the game details for that game

	parent.TgomaMessaging.callPlugin(onGetGameDetailsSucceeded, onGetGameDetailsFailed, this, 
		parent.TgomaMessaging.GAME_MODULE_NAME, "getGameDetails", [m_gameId]);

	// Fake data
	// onGetGameDetailsSucceeded({
	// 	gameTag: "wam",
	// 	gameName: "Alien Stomp",
	// 	gameDescription: "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris placerat nisl nec odio gravida, nec dictum nunc rhoncus. Phasellus volutpat, ante eget semper rhoncus, neque leo luctus neque, vitae facilisis nisi urna tempus mauris. Nullam malesuada eu purus vitae volutpat. Aliquam non enim sit amet turpis imperdiet cursus nec vel risus. Morbi aliquam consectetur nulla ullamcorper auctor.",
	// 	p_screenshots: ["event_image_large-Jumper1.jpg", "event_image_large-Jumper2.jpg"],
	// 	p_price: 500
	// });
});

function onGetGameDetailsSucceeded(p_game) {
	console.log("onGetGameDetailsSucceeded(" + p_game + ")");

	// Boilerplate stuff
	var _source = $("#game-template").html();
	var _template = Handlebars.compile(_source);

	m_price = p_game["price"];

	// Set up the template with our values and img sources
	var _context = {
		tokenIconSrc: "vc-icon.png",
		newIconSrc: "new-icon.png",
		newTag: parent.Tgoma.LanguageManager.getString("LBL_new"),
		backButtonSrc: "return-to-shop-icon.png",
		buyButtonSrc: "buy-button.png",
		itemName: p_game["gameName"],
		itemDescription: p_game["gameDescription"],
		itemPrice: p_game["price"],
		getTag: parent.Tgoma.LanguageManager.getString("BTN_get")
	};


	// Turn the template into html
	var _html = _template(_context);

	// Add the template to our main panel
	$(".panel").append(_html);

	// Configure the owl carousel for screenshots
	$(".screenshot-carousel").owlCarousel({
		singleItem: true,
		autoPlay: true,
		pagination: true,
		navigation: true,
		items: 1,
		navigationText: [
			"<img class='control-img' src='" + parent.getPathByTag("leftArrow.png") + "' />", 
			"<img class='control-img' src='" + parent.getPathByTag("rightArrow.png") + "' />"]
	});

	var _screenshots = JSON.parse(p_game["screenShots"]);
	if (_screenshots != "") {
		// Put this game's screenshots into the carousel
		for (var _i = 0; _i < _screenshots.length; _i++) {
			var _screenshotSrc = parent.getPathByTag(_screenshots[_i]);
			if(_screenshotSrc != "") {
				var _content = '<img src="' + _screenshotSrc + '"/>'
				$(".screenshot-carousel").data('owlCarousel').addItem(_content);
			}
		}
	}

	// Add a listener to the back button
	$(".back-button").click(function(){
		parent.loadFrame("shop");
	})

	// Add a listener to the back button
	$(".buy-button").click(onBuyButtonClicked)

}

function onGetGameDetailsFailed() {
	console.log("onGetGameDetailsFailed()");
}

function onBuyButtonClicked() {
  	console.log("onBuyButtonClicked()")

	if (parent.Tgoma.UserHelper.currentFamilyAccount.m_email == ""){
		parent.showConfirm("need_account_to_purchase", onShouldChangePageSelected);
		return;
	}

	if(m_price == 0)
	{
		parent.TgomaMessaging.callPlugin(null, onGetGameError, this, 
			parent.TgomaMessaging.USER_MODULE_NAME, "getFreeGame", [m_gameId]);
	}
	else
	{
		// Set up the request object that'll get sent along with the family login
		var requestParams = new Object();
		requestParams["gameId"] = m_gameId;
		setRequestParams("buyGame", JSON.stringify(requestParams));

	  	parent.Tgoma.UserHelper.familyLoginReturnedSignal.addOnce(onLoginForGamePurchaseReturned, this);

		// Show the password entry dialog that will send our request to native
		setPasswordConfirmationDescription(parent.Tgoma.LanguageManager.getString("log_in_for_game"));
	  	showConfirmPasswordDialog();
  	}
}

function onShouldChangePageSelected(result)
{
	if(result) {
		parent.loadFrame("familyLoginFrame");
	}
}

function onNetworkError(p_event) {
	console.log("onNetworkError(" + p_event.code + "," + p_event.message + ")");
	setTimeout(function() {
		var retry = parent.showConfirm("network_error_on_purchase");
		if(retry) {
			showConfirmPasswordDialog();
		}	
	}, 1);
}

function onLoginForGamePurchaseReturned(p_outcome, p_error) {
  console.log("onLoginForGamePurchaseReturned(", p_outcome , p_error, ")")
  if (p_outcome == false) {
  	setTimeout(function() { parent.showAlert ("login_error", parent.Tgoma.LanguageManager.getString(p_error));}, 1);
  }
}

function onGamePurchaseReturned(e) {
  console.log("onGamePurchaseReturned(", e, ")")
	var _succeeded = e.succeeded;
	var _code = e.code;
	var _message = e.message;

	// Spin this off on a new thread for iOS
	setTimeout(function(){
		if (_succeeded) {

			setTimeout(function() { 
				parent.showAlert("game_purchase_complete");
				parent.loadFrame("games"); 
			}, 1);

		} 
		else {
			if (_code == 3) {

				parent.showConfirm(parent.Tgoma.LanguageManager.getString("not_enough_tokens"), function(_choice){
					if (_choice) {
						setTimeout(function(){
							parent.loadFrame("shop", "dest=vc");
						}, 1);
					}	
				});
			} else {
				setTimeout(function() { parent.showAlert("error_with_error_code", _code); }, 1);
			}
		}
	}, 1);
}

function onGetGameError()
{
	// Set up the request object that'll get sent along with the family login
	var requestParams = new Object();
	requestParams["gameId"] = m_gameId;
	setRequestParams("buyGame", JSON.stringify(requestParams));

  	parent.Tgoma.UserHelper.familyLoginReturnedSignal.addOnce(onLoginForGamePurchaseReturned, this);

	// Show the password entry dialog that will send our request to native
	setPasswordConfirmationDescription(parent.Tgoma.LanguageManager.getString("log_in_for_game"));
  	showConfirmPasswordDialog();
}