var m_scrollingUp = false;
var m_scrollingDown = false;
var m_lastScrollTop = 0;
var m_updatingGame = "";
var m_gameFailed = false;
var m_noTrampolineModelSet = false;

$(window).load(function() {
	console.log("init()");
	window.onerror = parent.window.onerror;

		parent.TgomaMessaging.callPlugin(onTrampolineModelSet, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getHasSetTrampolineModel");
		parent.Tgoma.TrampolineHelper.trampolineDetailsChangedSignal.add(onTrampolineDetailsUpdated, this);
        parent.TgomaMessaging.callPlugin(onGamesListReturned, null, this, parent.TgomaMessaging.GAME_MODULE_NAME, "getGameList");

	/*/onGamesListReturned([
		{GameName: "Alien Stomp", 	link: "wam"},
		{GameName: "FreeBounce", 	link: "freebounce"},
		{GameName: "Fruitants", 	link: "fruitants"},
		{GameName: "Math Hopper", 	link: "mh"},
		{GameName: "Stickers!", 	link: "stickerbook"},
		{GameName: "Whatzat?", 		link: "soundboard"},
		{GameName: "JumpFit", 		link: "jumpfit"},
		{GameName: "2048", 			link: "twok48"}
	]);*/

	//$(".game").click(onGameClicked);

	$("#gridControlUp").click(onGridControlUpClicked);
	$("#gridControlDown").click(onGridControlDownClicked);

});

$(window).unload(function () {
    parent.Tgoma.TrampolineHelper.trampolineDetailsChangedSignal.removeAll(onTrampolineDetailsUpdated, this);
    parent.document.removeEventListener("onDownloadProgress", onDownloadProgress);
    parent.document.removeEventListener("onDownloadComplete", onDownloadComplete);
    parent.document.removeEventListener("onDownloadStarted", onDownloadStarted);
    parent.document.removeEventListener("onDownloadError", onDownloadError);
});

function onGridControlUpClicked() {
	console.log("onGridControlUpClicked()");
	var _scrollTop = $("#gameGrid").scrollTop();
	if(m_scrollingUp)
	{
		_scrollTop = m_lastScrollTop;
	}

	console.log($("#gameGrid").children());

	var _gameHeight = $("#gameGrid").children()[0].clientHeight;

	var _newScrollTop = (Math.ceil(_scrollTop / _gameHeight) - 1) * _gameHeight;
	if(_newScrollTop < 0)
	{
		_newScrollTop = 0;
	}
	console.log(_newScrollTop);
	if(m_scrollingDown)
	{
		m_scrollingDown = false;
		$("#gameGrid").stop();
	}
	if(_newScrollTop != m_lastScrollTop)
	{
		m_scrollingUp = false;
		$("#gameGrid").stop();
	}

	if(!m_scrollingUp)
	{
		m_lastScrollTop = _newScrollTop;
		m_scrollingUp = true;
		$("#gameGrid").animate({
			scrollTop: _newScrollTop
		}, 200, "linear",
		function(){m_scrollingUp = false;} );
	}
}

function onGridControlDownClicked() {
	console.log("onGridControlDownClicked()");
	var _scrollTop = $("#gameGrid").scrollTop();
	if(m_scrollingDown)
	{
		_scrollTop = m_lastScrollTop;
	}

	var _gameHeight = $("#gameGrid").children()[0].clientHeight;

	var _newScrollTop = (Math.floor(_scrollTop / _gameHeight) + 1) * _gameHeight;


	if(_newScrollTop != m_lastScrollTop)
	{
		m_scrollingDown = false;
		$("#gameGrid").stop();
	}
	if(m_scrollingUp)
	{
		m_scrollingUp = false;
		$("#gameGrid").stop();
	}
	if(!m_scrollingDown || _newScrollTop != m_lastScrollTop)
	{
		m_scrollingDown = true;
		m_lastScrollTop = _newScrollTop;
		$("#gameGrid").animate({
			scrollTop: _newScrollTop
		}, 200, "linear",
		function(){m_scrollingDown = false;} );
	}
}

function onGameClicked(evt) {
	console.log("onGameClicked(" + evt + ")")
	if(evt.target.tagName == "A") {
		evt.target = evt.target.parentElement;
	}
	window.gameId = $(evt.target).attr("data-link");

	if (m_noTrampolineModelSet) {
		parent.showConfirm(parent.Tgoma.LanguageManager.getString("error_16"), onSetModelConfirmSelected);
	}
	else {
		if (parent.Tgoma.ApplicationUtils.DeviceUtils.isMobile.Android()) {
		   parent.AndroidFullScreen.immersiveMode();
		}

		try {
	    	parent.window.analytics.trackEvent('Game', 'Click', window.gameId, 0);
		} catch(err){}

		parent.showSafetyMessage(onSafetyMessageConfirmed);
	}
}

function onTrampolineModelSet(isSet) {
	console.log("onTrampolineModelSet(" + isSet + ")");
	m_noTrampolineModelSet = !isSet && parent.Tgoma.ConnectionHelper.isConnected;
}

// This is called both when connecting and disconnecting from a controller
function onTrampolineDetailsUpdated(p_hardwareID, p_trampolineModel, p_hardwareVersion, p_firmwareVersion) {
	console.log("onTrampolineDetailsUpdated(Model = " + p_trampolineModel + ")");
	m_noTrampolineModelSet = (p_trampolineModel == "unset" || p_trampolineModel == "") && parent.Tgoma.ConnectionHelper.isConnected;
}

function onSetModelConfirmSelected(willSetModel)
{
	if(willSetModel)
	{
		parent.loadFrame("trampolineSettings");
	}
}


function onDownloadStarted(p_event)
{
	console.log("onDownloadStarted("+p_event["appId"] + ")");
	m_updatingGame = p_event["appId"];

	if($("#"+m_updatingGame) != null && m_updatingGame != "")
	{
		var updatingIcon = document.getElementById(m_updatingGame);
		if(updatingIcon)
		{
			if(document.getElementById(m_updatingGame).classList.contains("gameNotDownloaded"))
			{
				$("#downloadingDetailsProgress").css("display","");
				$("#downloadingDetailsText").css("display","");
			}
			else
			{
				$("#downloadingDetailsProgress").css("display","hidden");
				$("#downloadingDetailsText").css("display","hidden");
			}

			$("#"+m_updatingGame).parent().append($("#downloadDetailsDiv"));
		    $(".progress-dialog-bar").progressbar({
		        value: 0
		    });
			$("#downloadingDetailsProgress").html("0%");
		}
		else
		{
			m_updatingGame = null;
		}
	}
	else
	{
		m_updatingGame = null;
	}
}

function onDownloadError(p_event)
{
	console.log("onDownloadError()");
	var errorId = p_event["errorId"];
	var gameId = p_event["gameId"];

	console.log("ErrorId: ", errorId, "gameId", gameId);

	if(errorId == 1) // Could not load Manifest
	{
		addErrorToGame(gameId, errorId, "download_pending", "no_internet_access");
		m_gameFailed = true;
	}
	else if(errorId == 2) //Download Failed
	{
		addErrorToGame(gameId, errorId, "download_pending", "no_internet_access");
		m_gameFailed = true;

	}
	else if(errorId == 3) //Not enough space
	{
		addErrorToGame(gameId, errorId, "download_pending", "disk_full");
	}
}

function addErrorToGame(p_gameId, p_errorId,p_errorMessage1, p_errorMessage2)
{
	p_errorMessage1 = parent.Tgoma.LanguageManager.getString(p_errorMessage1);
	p_errorMessage2 = parent.Tgoma.LanguageManager.getString(p_errorMessage2);
	//Find the game icon
	var gameIcon = document.getElementById(p_gameId);
	if(gameIcon == null || !gameIcon.classList.contains("gameNotDownloaded"))
	{
		return;
	}
	//Remove the old error if there is one.
	removeErrorFromGame(p_gameId);
	removeLoadingFromGame(p_gameId);
	//Generate the error element

	p_errorMessage1 = p_errorMessage1 ? p_errorMessage1 : "";
	p_errorMessage2 = p_errorMessage2 ? p_errorMessage2 : "";

	var source = $("#error-template").html();
	var template = Handlebars.compile(source);
	var context = {errorMessage1: p_errorMessage1, errorMessage2: p_errorMessage2, gameId: p_gameId, errorId: p_errorId};
	var html = template(context);
	$(gameIcon).parent().append(html);
}

function removeErrorFromGame(p_gameId)
{
	var oldErrorDialog = document.getElementById("errorDetails"+p_gameId);
	if(oldErrorDialog != null)
	{
		oldErrorDialog.remove();
	}
}

function addLoadingToGame(p_gameId)
{
	//Find the game icon
	var gameIcon = document.getElementById(p_gameId);
	if(gameIcon == null || !gameIcon.classList.contains("gameNotDownloaded"))
	{
		return;
	}
	removeErrorFromGame(p_gameId);
	removeLoadingFromGame(p_gameId);

	var source = $("#loading-template").html();
	var template = Handlebars.compile(source);
	var context = {gameId: p_gameId, waitingText: parent.Tgoma.LanguageManager.getString("LBL_waiting")};
	var html = template(context);
	$(gameIcon).parent().append(html);
}

function removeLoadingFromGame(p_gameId)
{
	var oldLoadingDialog = document.getElementById("loadingDetails"+p_gameId);
	if(oldLoadingDialog != null)
	{
		oldLoadingDialog.remove();
	}
}

function onDownloadProgress(p_event){
	var progress = p_event["progress"];

	if(m_gameFailed)
	{
		addWaitingToAllUndownlaodedGames();
		m_gameFailed = false;
	}

	if(m_updatingGame != null && m_updatingGame != "")
	{
		removeErrorFromGame(m_updatingGame);
		removeLoadingFromGame(m_updatingGame);
		$("#downloadDetailsDiv").css("display","");

		var progress = progress * 100;
		progress = Math.floor(progress);
		$("#downloadingDetailsProgress").html(progress + "%");

	    $(".progress-dialog-bar").progressbar({
	        value: progress
	    });
	}
}

function onDownloadComplete(p_event) {
	var downloadSuccessful = p_event["downloadSuccessful"];
	var gameId = p_event["appId"];
	console.log("onDownloadComplete("+downloadSuccessful+"," +gameId + ")");

	if($("#"+gameId) == null)
	{
		return;
	}

	if(downloadSuccessful)
	{
		//parent.showSafetyMessage(onSafetyMessageConfirmed);
		$("#"+gameId).removeClass("gameNotDownloaded");
		$("#"+gameId+"Text").removeClass("gameNotDownloaded");
		//Find the new game that is updating

		if(m_updatingGame == gameId);
		{
			$("#downloadDetailsDiv").css("display","none");
			m_updatingGame = null;
		}
		var gameButton = document.getElementById(gameId);
		if(gameButton != null)
		{
			$(gameButton).off("click");
			gameButton.addEventListener("click", onGameClicked, false);
			document.getElementById(gameId+"Text");
			removeErrorFromGame(gameId);
			removeLoadingFromGame(gameId);
		}
	}
	else
	{
		//Show that the download failed on the icon.
		//addErrorToGame(gameId, "Download Failed","Check Wifi");
		$("#downloadDetailsDiv").css("display","none");
		m_updatingGame = null;
	}
}

function addWaitingToAllUndownlaodedGames()
{
	var gameButtonList = document.getElementsByClassName("gameBackgroundImg");
	for(var i = 0; i < gameButtonList.length; i++){
		if(gameButtonList[i].classList.contains("gameNotDownloaded"))
		{
			var gameError = document.getElementById("errorDetails"+i);
			if(gameError != null && !$(gameError).hasClass("errorId3"))
			{
				addLoadingToGame(i);
			}
		}
	}
}

function onSafetyMessageConfirmed() {

	try {
    	parent.window.analytics.trackEvent('Game', 'Play', window.gameId, 0);
	} catch(err){}

	parent.Tgoma.DownloadUtils.locateGame(window.gameId);
}

function lockInterface() {
	var gameButtonList = document.getElementsByClassName("gameBackgroundImg");
	for(var i = 0; i < gameButtonList.length; i++){
		gameButtonList[i].removeEventListener("click", onGameClicked);
	}
}

function unlockInterface() {
	addButtonListeners();
}

function addButtonListeners() {

	var gameButtonList = document.getElementsByClassName("gameBackgroundImg");
	for(var i = 0; i < gameButtonList.length; i++){
		if(!gameButtonList[i].classList.contains("gameNotDownloaded"))
		{
			$(gameButtonList[i]).off("click");
			gameButtonList[i].addEventListener("click", onGameClicked, false);
		}
	}
}

function onGamesListReturned(p_payload) {
	console.log("onGamesListReturned(" + p_payload + ")")
	var source = $("#entry-template").html();
	var template = Handlebars.compile(source);

	p_payload.forEach(function (game)
	{
		var _iconPath = parent.getPathByTag(game.link + "_icon.png");
		if(!parent.checkTagInManifest(_iconPath))
		{
			_iconPath = "freebounce_icon.png";
		}
		var _noDownloadedClass = "";
		if(!game.isDownloaded)
		{
			_noDownloadedClass = "gameNotDownloaded";
		}
		var context = {link: game.link, name: game.GameName, imgSrc: _iconPath, notDownloadedClass:_noDownloadedClass};
		var html = template(context);
		$("#gameGrid").append(html);

		if(!game.isDownloaded)
		{
            // This should be done after the gameGrid item has been added, otherwise 
		    if (!game.hasUpdate) {
		        //If the game has not been downloaded, and there is no manifest we need to fetch the manifest.
		        parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "checkForNewManifest", [game.link.toString()]);
		    }
			addLoadingToGame(game.link.toString());
		}

	});

	addButtonListeners();

    parent.document.addEventListener("onDownloadProgress", onDownloadProgress, false);
    parent.document.addEventListener("onDownloadComplete", onDownloadComplete, false);
    parent.document.addEventListener("onDownloadStarted", onDownloadStarted, false);
    parent.document.addEventListener("onDownloadError", onDownloadError, false);

	parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getCurrentGameDownloading");
}
