// GOAL TYPES
var JUMPS = 1;
/*var DISTANCE = 2; Not being used*/
var HEIGHT = 3;
var JUMP_TIME = 4;
var CALORIES = 5;

// GOAL STATUSES
var IN_PROGRESS = 0;
var COMPLETE = 1;
var ON_HOLD = 2;
var ABANDONED = 3;

var m_goal;

var m_goalCreated = false;

var m_currentGoalMultiplier;

var DEVICE = true;

$(window).load(function() {
  window.onerror = parent.window.onerror;

  $('#createGoalForm').submit(function () {
    onCreateGoalButtonClicked();
    return false;
  });

  //$("#createGoalPanel").hide();
  $("#goalProgressPanel").hide();

  $("#createGoalButton").click(onCreateGoalButtonClicked);
  $("#deleteGoalButton").click(onDeleteGoalButtonClicked);

  $("#showProgressInFreebounceCheckbox").change(onShowGoalsInFreebounceClicked);

  if (DEVICE) {
     parent.TgomaMessaging.Goal.getShowGoalsInGame(this,onCheckShowGoalsInFreebounce);
     parent.TgomaMessaging.callPlugin(onGetAllGoalsReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getAllGoals");
  }
  else {
    onGetAllGoalsReturned([
      {"endDate":1411967559,"goalID":1,"goalLink":0,"goalStatus":0,"goalType":3,"progress":10000,"startDate":1411967559,"target":150000,"userID":1},
      {"endDate":1411867559,"goalID":1,"goalLink":0,"goalStatus":1,"goalType":3,"progress":50,"startDate":1411967559,"target":10000,"userID":1},
      {"endDate":1411767559,"goalID":1,"goalLink":0,"goalStatus":1,"goalType":4,"progress":50,"startDate":1411967559,"target":200000,"userID":1},
      {"endDate":1411667559,"goalID":1,"goalLink":0,"goalStatus":1,"goalType":5,"progress":50,"startDate":1411967559,"target":40000,"userID":1},
      {"endDate":1411567559,"goalID":1,"goalLink":0,"goalStatus":1,"goalType":5,"progress":10,"startDate":1411967559,"target":15000,"userID":1},
      {"endDate":1411467559,"goalID":1,"goalLink":0,"goalStatus":1,"goalType":3,"progress":50,"startDate":1411967559,"target":10000,"userID":1},
      {"endDate":1411367559,"goalID":1,"goalLink":0,"goalStatus":1,"goalType":4,"progress":50,"startDate":1411967559,"target":200000,"userID":1},
      {"endDate":1411267559,"goalID":1,"goalLink":0,"goalStatus":1,"goalType":5,"progress":50,"startDate":1411967559,"target":40000,"userID":1},
      {"endDate":1410967559,"goalID":1,"goalLink":0,"goalStatus":1,"goalType":5,"progress":10,"startDate":1411967559,"target":15000,"userID":1},
      {"endDate":1410867559,"goalID":1,"goalLink":0,"goalStatus":1,"goalType":3,"progress":50,"startDate":1411967559,"target":10000,"userID":1},
      {"endDate":1410767559,"goalID":1,"goalLink":0,"goalStatus":1,"goalType":4,"progress":50,"startDate":1411967559,"target":200000,"userID":1},
      {"endDate":1410167559,"goalID":1,"goalLink":0,"goalStatus":1,"goalType":5,"progress":50,"startDate":1411967559,"target":40000,"userID":1},
    ]);
  }
  $("#dial").knob({
    'fgColor': "#FF9416",
    'bgColor': "#FFDC18",
    'thickness': 0.35,
    'displayPrevious': true,
    'readOnly': true,
    'width': '100%',
    'displayInput': false,
    'format' : function (value) {
      // return value + '%';
      return '';
    }
  });

    if(parent.Tgoma.UserHelper.currentFamilyAccount.m_unitsAreUSFormat)
    {
      $("#heightSelector").text(parent.Tgoma.LanguageManager.getString("height_ft"));
    }
    else
    {
      $("#heightSelector").text(parent.Tgoma.LanguageManager.getString("height_m"));
    }

    if(parent.Tgoma.UserHelper.currentFamilyAccount.m_energyIsUSFormat)
    {
      $("#caloriesSelector").text(parent.Tgoma.LanguageManager.getString("calories"));
    }
    else
    {
      $("#caloriesSelector").text(parent.Tgoma.LanguageManager.getString("kilojoules"));
    }

});

$(window).unload(function () {
    parent.document.removeEventListener("onGoalProgress", onGoalProgress);
})

function onCreateGoalButtonClicked(evt) {
  parent.cordova.plugins.Keyboard.close();
  if (m_goalCreated) {
    return;
  }

  //parent.cordova.plugins.Keyboard.close();

  var _goalType = parseInt($("#goalTypeSelector").val());
  var _goalTarget = $("#target").val();
  console.log("onCreateGoalButtonClicked(GoalType: " + _goalType + ", GoalTarget: " + _goalTarget + ")");

  var _multiplier = 1;
  var _label = "jumps"

  switch(_goalType) {
    case (HEIGHT): {
      _label = "height";

      if(parent.Tgoma.UserHelper.currentFamilyAccount.m_unitsAreUSFormat)
      {
        _multiplier = parent.Tgoma.Utils.convertFeetToMetres(1);
      }
      _multiplier = _multiplier * 1000;

      break;
    }
    case (JUMP_TIME): {
      _label = "jump_time";
      _multiplier = 60000;
      if(_goalTarget > 1439)
      {
          parent.showAlert("invalid_goal", 1439);// Max jump time is 1 day.
          //parent.showAlert("Invalid Goal. Target must be between 1 and " + 1439);
          return;
      }

      break;
    }
    case (CALORIES): {
      _label = "energy";
      if(!parent.Tgoma.UserHelper.currentFamilyAccount.m_energyIsUSFormat)
      {
        _multiplier = parent.Tgoma.Utils.convertKiloJoulesToCalories(1);
      }

      _multiplier = _multiplier * 1000;
      break;
    }
  }

  console.log(_goalType + " " + _goalTarget + " " + _multiplier)

  if (!(/^[0-9]+$/).test(_goalTarget)) {
    parent.showAlert("must_be_whole_number");
  }
  else if (_multiplier * _goalTarget > 2100000000 || _goalTarget < 1) {
    if(_goalType == JUMP_TIME)
    {
      parent.showAlert("invalid_goal", 1439);
    }
    else
    {
      parent.showAlert("invalid_goal", commify(Math.floor(2100000000 / _multiplier)));
    }
  }
  else {
      m_goalCreated = true; //Stop people from being able to spam the create goal button giving them multiple goals.
    if (DEVICE) {
        parent.TgomaMessaging.callPlugin(populateCurrentGoal, function(){m_goalCreated = false;}, this, parent.TgomaMessaging.USER_MODULE_NAME, "createGoal", [_goalType, Math.round(_multiplier * _goalTarget)]);
        parent.window.analytics.trackEvent('Goal', 'Create', _label, _multiplier * _goalTarget);
      } else {
        populateCurrentGoal({"endDate":0,"goalID":1,"goalLink":0,"goalStatus":0,"goalType":3,"progress":0,"startDate":"23/08/14","target":100,"userID":1})
      }
    }
    $("#deleteGoalButton").show();
}


function onGetAllGoalsReturned(p_goals) {
  console.log("onGetAllGoalsReturned(" + p_goals + ")");
  console.log(p_goals);

  p_goals.sort(function(a,b) {return b.endDate - a.endDate;});

  p_goals.forEach(addGoal);

  //touchScroll("achievedGoalsPanel");
}

function addGoal(p_goal) {
  console.log("addGoal(" + p_goal + ")");

  if (p_goal.goalStatus == IN_PROGRESS) {
    populateCurrentGoal(p_goal);
    return;
  }

  if (p_goal.goalStatus != COMPLETE) {
    return;
  }

  $("#noGoalsAchievedYetDiv").hide();

  var source = $("#achieved-goal-template").html();
  var template = Handlebars.compile(source);
  var _multiplier = 1;
  var _text = "";
  var _imgSrc = parent.getPathByTag("goalCompleteIcon.png");
  switch(p_goal.goalType) {
    case JUMPS: {
      _text += parent.Tgoma.LanguageManager.getString("num_jumps", commify(p_goal.target));
      _imgSrc = parent.getPathByTag("jumps_icon.png");
      break;
    }
    case HEIGHT: {
      if(parent.Tgoma.UserHelper.currentFamilyAccount.m_unitsAreUSFormat) {
        _multiplier = parent.Tgoma.Utils.convertFeetToMetres(1);
      }
      _multiplier = _multiplier * 1000;

      if (parent.Tgoma.UserHelper.currentFamilyAccount.m_unitsAreUSFormat) {
        _text += parent.Tgoma.LanguageManager.getString("height_jumped_ft", formatNumber(p_goal.target / _multiplier));
      } else {
        _text += parent.Tgoma.LanguageManager.getString("height_jumped_m", formatNumber(p_goal.target / _multiplier));
      }

      _imgSrc = parent.getPathByTag("height_icon.png");
      break;
    }
    case JUMP_TIME: {
      _multiplier = 60000;
      _text += parent.Tgoma.LanguageManager.getString("jumping_time_num", formatTime(p_goal.target));
      _imgSrc = parent.getPathByTag("airtime_icon.png");
      break;
    }
    case CALORIES: {

      if(!parent.Tgoma.UserHelper.currentFamilyAccount.m_energyIsUSFormat) {
        _multiplier = parent.Tgoma.Utils.convertKiloJoulesToCalories(1);
      }
      _multiplier = _multiplier * 1000;

      if (parent.Tgoma.UserHelper.currentFamilyAccount.m_energyIsUSFormat) {
        _text += parent.Tgoma.LanguageManager.getString("cal_burned", formatNumber(p_goal.target / _multiplier))
      } else {
        _text += parent.Tgoma.LanguageManager.getString("kj_burned", formatNumber(p_goal.target / _multiplier))
      }
      _imgSrc = parent.getPathByTag("calories_icon.png");
      break;
    }
  }

  // Set the date
  var d = new Date(0);
  d.setUTCSeconds(p_goal.endDate);
  var _endDate = pad(d.getMonth()+1, 2) + "/" + pad(d.getDate(), 2) + "/" + d.getFullYear();
  if(!parent.Tgoma.UserHelper.currentFamilyAccount.m_dateIsUSFormat)
  {
    _endDate = pad(d.getDate(), 2) + "/" + pad(d.getMonth()+1, 2) + "/" + d.getFullYear();
  }

  // Create the goal div and add it to the panel
  var context = {text: _text, endDate: _endDate, imgSrc: _imgSrc};
  var html = template(context);
  $(".scrolling-goal-div").append(html);
}

function populateCurrentGoal(p_goal) {
  console.log("populateCurrentGoal(" + p_goal + ")");
  m_goal = p_goal;

  // Switch panels
  $("#createGoalPanel").hide();
  $("#goalProgressPanel").show();

  if (DEVICE) {
    // Start listening.
    parent.document.addEventListener("onGoalProgress", onGoalProgress);
  }

  // Set the knob to the goal progress
  $("#dial").val(Math.floor((p_goal.progress / p_goal.target) * 100))
     .trigger('change');

   //$('#circle').css("height", $("canvas").height() * 1.05);


  // Set the date
  var d = new Date(0);
  d.setUTCSeconds(p_goal.startDate);
  if(parent.Tgoma.UserHelper.currentFamilyAccount.m_dateIsUSFormat) {
    $("#goalStartDate").text(parent.Tgoma.LanguageManager.getString("created_on", (pad(d.getMonth()+1, 2) + "/" + pad(d.getDate(), 2) + "/" + d.getFullYear())));
  } else {
    $("#goalStartDate").text(parent.Tgoma.LanguageManager.getString("created_on", (pad(d.getDate(), 2) + "/" + pad(d.getMonth()+1, 2) + "/" + d.getFullYear())));
  }

  // Figure out the background image and title text based on the goal type.
  var _backgroundImg = ""
  m_currentGoalMultiplier = 1;

  switch (p_goal.goalType) {
    case (JUMPS): {
      m_currentGoalMultiplier = 1;
      $("#titlePanelText").text(parent.Tgoma.LanguageManager.getString("goal_jumps"));
      $("#titlePanelText").attr("texttag", "goal_jumps");
      _backgroundImg = "jumps_icon.png";
      break;
    }
    case (HEIGHT): {
      if(parent.Tgoma.UserHelper.currentFamilyAccount.m_unitsAreUSFormat)
      {
        m_currentGoalMultiplier = parent.Tgoma.Utils.convertFeetToMetres(1);
      }
      m_currentGoalMultiplier = m_currentGoalMultiplier * 1000;
      $("#titlePanelText").text(parent.Tgoma.LanguageManager.getString("goal_height"));
      $("#titlePanelText").attr("texttag", "goal_height");
      _backgroundImg = "height_icon.png";
      break;
    }
    case (JUMP_TIME): {
      m_currentGoalMultiplier = 60000;
      $("#titlePanelText").text(parent.Tgoma.LanguageManager.getString("goal_time"));
      $("#titlePanelText").attr("texttag", "goal_time");
      _backgroundImg = "airtime_icon.png";
      break;
    }
    case (CALORIES): {
      if(!parent.Tgoma.UserHelper.currentFamilyAccount.m_energyIsUSFormat)
      {
        m_currentGoalMultiplier = parent.Tgoma.Utils.convertKiloJoulesToCalories(1);
      }
      m_currentGoalMultiplier = m_currentGoalMultiplier * 1000;

      $("#titlePanelText").text(parent.Tgoma.LanguageManager.getString("goal_energy"));
      $("#titlePanelText").attr("texttag", "goal_energy");
      _backgroundImg = "calories_icon.png";
      break;
    }
  }
  // Set the progress text
  setProgressText(p_goal.progress)


  _imgSrc = parent.getPathByTag(_backgroundImg);

  // Change the background image.
  $('#circle').css('background-image', 'url(' + _imgSrc + ')');
  $('#circle').css('background-size', ''); //Scale the image back to 50%
  $('#circle').children(0).css('visibility',''); //Show the knob.
}

function onGoalProgress(p_event) {
  var _goalID = p_event.goalId;
  var _percentComplete = p_event.percentComplete;
  var _progress = p_event.progress;

  if(_percentComplete > 1.0)
  {
    _percentComplete = 1.0;
    _progress = m_goal.target;
  }

  console.log("onGoalProgress(" + _goalID + ", " + _percentComplete +", " + _progress + ")");

  $("#dial").val(Math.floor(_percentComplete * 100))
    .trigger('change');

    setProgressText(_progress)

  if (_percentComplete >= 1.0) {
    _imgSrc = parent.getPathByTag("goalCompleteIcon.png");
    $('#circle').css('background-image', 'url(' + _imgSrc + ')');
    $('#circle').css('background-size', '100%'); //Scale the background image up.
    $('#circle').children(0).css("visibility","hidden"); //Hide the knob.
    if (DEVICE) {
      parent.document.removeEventListener("onGoalProgress", onGoalProgress);
    }

    $("#deleteGoalButton").hide();
  }
}

function setProgressText(p_progress) {
    if (m_goal.goalType == JUMP_TIME) {
    $("#goalProgress").text(parent.Tgoma.LanguageManager.getString("goal_progress", (formatTime(p_progress) + "/" + formatTime(m_goal.target) + '\n' + formatNumber((p_progress / m_goal.target) * 100))));
  } else if (m_goal.goalType == JUMPS) {
    $("#goalProgress").text(parent.Tgoma.LanguageManager.getString("goal_progress", (commify(p_progress) + "/" + commify(m_goal.target) + '\n' + formatNumber((p_progress / m_goal.target) * 100))));
  } else {
    $("#goalProgress").text(parent.Tgoma.LanguageManager.getString("goal_progress", (formatNumber(p_progress/m_currentGoalMultiplier) + "/" + formatNumber(m_goal.target/m_currentGoalMultiplier) + '\n' + formatNumber((p_progress / m_goal.target) * 100))));
  }

  $("#goalProgress").html($("#goalProgress").html().replace(/\n/g,'<br/>'));
}

function onDeleteGoalButtonClicked(evt) {
  console.log("onDeleteGoalButtonClicked()");

  m_goalCreated = false;

  // Prompt for confirmation
  parent.showConfirm("delete_goal_prompt", function(result){
    if(result)
      {
        // Remove goal progress listener
        if (DEVICE) {
          parent.document.removeEventListener("onGoalProgress", onGoalProgress);
          parent.window.analytics.trackEvent('Goal', 'Delete');
          parent.TgomaMessaging.callPlugin(onDeleteGoalReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "cancelGoal", [m_goal.goalID]);
        } else {
          onDeleteGoalReturned();
        }
    }
  });
}

function onDeleteGoalReturned() {
  // Switch panels back to "create goal" screen.
  $("#goalProgressPanel").hide();
  $("#createGoalPanel").show();
  $("#titlePanelText").text(parent.Tgoma.LanguageManager.getString("LBL_set_goal"));
  $("#titlePanelText").attr("texttag", "LBL_set_goal");
}

/**************** FREEBOUNCE OPTIONS **********************/

function onCheckShowGoalsInFreebounce(showingGoals) {
  console.log("onCheckShowGoalsInFreebounce(" + showingGoals + ")");
  document.getElementById("showProgressInFreebounceCheckbox").checked = showingGoals;
}

function onShowGoalsInFreebounceClicked() {
  console.log("onShowGoalsInFreebounceClicked()");
  var _checked = document.getElementById("showProgressInFreebounceCheckbox").checked;

  parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.GAME_MODULE_NAME, "setShowGoalsOnFreebounce", [_checked]);
}

function pad(n, width, z) {
  z = z || '0';
  n = n + '';
  return n.length >= width ? n : new Array(width - n.length + 1).join(z) + n;
}

function formatTime(p_time) {
  var ms = p_time % 1000;
  p_time = (p_time - ms) / 1000;
  var secs = p_time % 60;
  p_time = (p_time - secs) / 60;
  var mins = p_time % 60;
  p_time = (p_time - mins) / 60;
  var hrs = p_time % 24;
  p_time = (p_time - hrs) / 24;
  var days = p_time;

  return pad(hrs, 2) + ':' + pad(mins, 2) + ':' + pad(secs, 2);
}

function formatNumber(p_number) {
  return commify(Math.floor(p_number));
}

function commify(x) {
  return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
}

function touchScroll(id){
  if(parent.Tgoma.ApplicationUtils.DeviceUtils.isMobile.iOS())
  {
    var element=document.getElementById(id);
    window.scrollStartPos=0;

    element.addEventListener("touchstart", this.onTouchStart,false);
    element.addEventListener("touchmove", this.onTouchMove,false);
  }
}

function onTouchStart(event){
  window.scrollStartPos=this.scrollTop+event.touches[0].pageY;
}

function onTouchMove(event){
  this.scrollTop=window.scrollStartPos-event.touches[0].pageY;
}
