var DEVICE = true;

var m_currentUser;
var m_currentGame = "%";
var m_currentTime = "604800000";

var HOUR = 3600000;
var DAY = 86400000;
var WEEK = 604800000;
var MONTH = 2419200000;
var YEAR = 31449600000;

var JUMPS = "totalJumps";
var JUMP_TIME = "totalJumpTime";
var HEIGHT = "totalHeight";
var CALORIES = "totalCalories";

var m_userData;

var m_currentMetric;

var m_USdateFormat = true;
var m_USenergyFormat = true;
var m_USunitFormat = true;

$(document).ready(function() {

  window.onerror = parent.window.onerror;
  m_USdateFormat = parent.Tgoma.UserHelper.currentFamilyAccount.m_dateIsUSFormat;
  m_USenergyFormat = parent.Tgoma.UserHelper.currentFamilyAccount.m_energyIsUSFormat;
  m_USunitFormat = parent.Tgoma.UserHelper.currentFamilyAccount.m_unitsAreUSFormat;

  $("#totalJumps").click(onMetricsBoxClicked);
  $("#totalJumpTime").click(onMetricsBoxClicked);
  $("#totalHeight").click(onMetricsBoxClicked);
  $("#totalCalories").click(onMetricsBoxClicked);

  $("#userList").change(onUserChanged);
  $("#gamesList").change(onGameChanged);
  $("#timeList").change(onTimeChanged);
    
  document.addEventListener("localisedFramePopulated", onLocalisedFramePopulated);

});

function onLocalisedFramePopulated() {
    console.log("onLocalisedFramePopulated");

    document.removeEventListener("localisedFramePopulated", onLocalisedFramePopulated);

    $("#totalJumps").click();

    onCurrentUserReturned(parent.Tgoma.UserHelper.currentFamilyMemberName);
    parent.TgomaMessaging.callPlugin(onGamesListReturned, null, this, parent.TgomaMessaging.GAME_MODULE_NAME, "getGameList");
}

function onGamesListReturned(p_payload) {
  console.log("onGamesListReturned(" + p_payload + ")")
  p_payload.forEach(function(game) {
    var gameName = game.GameName;
    var gameId = game.link;
    $('#gamesList').append($('<option>', {
        value: gameId,
        text: gameName
    }));
  });

  //addButtonListeners();
}

function onMetricsBoxClicked(evt) {
  console.log("onMetricsBoxClicked(" + evt.target.id + ")");

  // Remove the highlighted state from the old box
  $("#" + m_currentMetric).removeClass("metricBoxSelected");

  m_currentMetric = evt.target.id;

  // Add the highlighted state to the new box.
  $("#" + m_currentMetric).addClass("metricBoxSelected");

  // Redraw the graph
  createGraph(m_currentMetric);

  parent.window.analytics.trackEvent('JumpTracker', m_currentMetric.substring(5));
}

function onUserChanged(evt) {
  m_currentUser = evt.target.selectedOptions[0].value;
  $("#" + evt.target.id).blur();
  updateStats();
  parent.window.analytics.trackEvent('JumpTracker', 'User');
}

function onGameChanged(evt) {
  m_currentGame = evt.target.selectedOptions[0].value;
  $("#" + evt.target.id).blur();
  updateStats();
  if (m_currentGame == "%") {
    parent.window.analytics.trackEvent('JumpTracker', 'Game', "All Games");
  }
  else {
    parent.window.analytics.trackEvent('JumpTracker', 'Game', m_currentGame);
  }
}

function onTimeChanged(evt) {
  m_currentTime = evt.target.selectedOptions[0].value;
  // Hack to force Ludei builds to properly update the select field...
  $("#" + evt.target.id).blur();
  // End hack
  updateStats();

  switch (parseInt(m_currentTime)) {
    case (DAY) : {
      parent.window.analytics.trackEvent('JumpTracker', 'Time', "Day");
      break;
    }
    case (WEEK) : {
      parent.window.analytics.trackEvent('JumpTracker', 'Time', "Week");
      break;
    }
    case (MONTH) : {
      parent.window.analytics.trackEvent('JumpTracker', 'Time', "Month");
      break;
    }
    case (YEAR) : {
      parent.window.analytics.trackEvent('JumpTracker', 'Time', "Year");
      break;
    }
    default : {
      parent.window.analytics.trackEvent('JumpTracker', 'Time', "Unknown");
      break;
    }
  }
}

function onCurrentUserReturned(p_user) {
  window.m_currentUser = p_user;
  updateStats();
  if (DEVICE) {
    parent.TgomaMessaging.callPlugin(onUserListReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getUserList");
  } else {
    onUserListReturned(["Joel", "Guest"]);
  }
}

function onUserListReturned(p_users) {
  console.log("User list returned: " + p_users);

  var optionItemSource = $("#option-template").html();
  var optionItemTemplate = Handlebars.compile(optionItemSource);

  p_users.forEach(function(user){
    var context = {text: user, value: user};
    var optionItem = optionItemTemplate(context);
    $("#userList").append(optionItem);
  });

  $("#userList").val(window.m_currentUser);

}

function updateStats() {
  console.log("Updating stats selector");
  if (DEVICE) {

    date = new Date();
    date.setYear(1970);
    date.setMonth(0);
    date.setDate(1);

    var timeSinceMidnight = date.getTime();

    // BEGIN HACK BEGIN HACK BEGIN HACK
    var _time = parseInt(window.m_currentTime);
    if (_time == DAY) {
      // It's actually not a day, it's "since midnight"
      _time = timeSinceMidnight;
    }
    else if(_time == WEEK)
    {
      _time = timeSinceMidnight + DAY * 6; //7 days minus a part day
    }
    else if(_time == MONTH)
    {
      _time = timeSinceMidnight + DAY * 27; //28 days minus a part day
    }
    else if(_time == YEAR)
    {
      _time = timeSinceMidnight + DAY * 363; //364 days minus a part day
    }
    _time -= date.getTimezoneOffset()*60000;
    // END HACK END HACK END HACK

    parent.TgomaMessaging.callPlugin(onUserDataTotalsReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getUserDataTotals", [m_currentUser, m_currentGame, _time]);
    parent.TgomaMessaging.callPlugin(onUserDataReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getUserData", [m_currentUser, m_currentGame, _time]);
  } else {
    onUserDataTotalsReturned({"airtime":26638,"calories":396,"distance":4557,"height":9276,"jumps":1296,"sessionTime":63, "jumpTime":123});
    onUserDataReturned(
      [
        {"startDate":1412127124,"totalSessionTime":7,"weight":96,"controllerID":"","score":0,"endDate":1412127131,"totalHeight":10000000,"userID":3,"sessionID":1,"level":1,"gameTag":"wam",
        "trampolineModel":"","totalJumps":0,"beenSynched":false,"totalDistance":0,"totalCalories":0,"firmwareVersion":"","totalAirTime":0, "toatlJumpTime":123},
        {"startDate":1412135325,"totalSessionTime":48,"weight":96,"controllerID":"","score":39,"endDate":1412135373,"totalHeight":380,"userID":3,"sessionID":2,"level":1,"gameTag":"wam",
        "trampolineModel":"","totalJumps":20,"beenSynched":false,"totalDistance":1376,"totalCalories":31,"firmwareVersion":"","totalAirTime":2495, "toatlJumpTime":123},
        {"startDate":1412135576,"totalSessionTime":21,"weight":96,"controllerID":"","score":11,"endDate":1412135597,"totalHeight":2005,"userID":3,"sessionID":3,"level":1,"gameTag":"wam",
        "trampolineModel":"","totalJumps":22,"beenSynched":false,"totalDistance":293,"totalCalories":164,"firmwareVersion":"","totalAirTime":3733, "toatlJumpTime":123},
        {"startDate":1412198066,"totalSessionTime":141,"weight":96,"controllerID":"","score":10,"endDate":1412198207,"totalHeight":1836,"userID":3,"sessionID":4,"level":0,"gameTag":"mh",
        "trampolineModel":"","totalJumps":60,"beenSynched":false,"totalDistance":1466,"totalCalories":150,"firmwareVersion":"","totalAirTime":9323, "toatlJumpTime":123},
        {"startDate":1412164549,"totalSessionTime":88,"weight":96,"controllerID":"","score":84,"endDate":1412199902,"totalHeight":932,"userID":3,"sessionID":5,"level":2,"gameTag":"wam",
        "trampolineModel":"","totalJumps":48,"beenSynched":false,"totalDistance":2848,"totalCalories":76,"firmwareVersion":"","totalAirTime":5907, "toatlJumpTime":123}
      ]);
  }
}

function onUserDataTotalsReturned(p_totals) {
  console.log("onUserDataTotalsReturned()");

  // No need to convert jumps
  $("#jumpTotal").text(commify(p_totals.jumps));

  // Or jumptime
  $("#jumpTimeTotal").text(formatTime(p_totals.jumpTime));

	// Need to convert height to feet based on their preference though
  var _heightTotal = p_totals.height/1000;
  if (m_USunitFormat) {
  	_heightTotal = Tgoma.Utils.convertMetresToFeet(_heightTotal);
  }
  else {
  	$("#heightDescription").text(parent.Tgoma.LanguageManager.getString("LBL_height_jumped_m"));
    $("#heightDescription").attr("texttag", 'LBL_height_jumped_m');
  }
  $("#heightTotal").text(commify(_heightTotal.toFixed(1)));

  // N.B. Calories are the american format - only convert if we're NOT the american format
  var energyTotal = p_totals.calories / 1000; //Converting from calories to kcal.
  if (!m_USenergyFormat) {
  	energyTotal = Tgoma.Utils.convertCaloriesToKiloJoules(energyTotal);
  	$("#energyDescription").text(parent.Tgoma.LanguageManager.getString("LBL_energy_burnt_kJ"));
    $("#energyDescription").attr("texttag", "LBL_energy_burnt_kJ");
  }
  $("#caloriesTotal").text(commify(energyTotal.toFixed(1)));
}

function onUserDataReturned(p_data) {
  console.log("onUserDataReturned()");

  m_userData = p_data;

  createGraph(m_currentMetric)
}

function createGraph(p_stat) {
  console.log("createGraph(" + p_stat + ")");

  var _tickFreq;
  var _dataArray = [];
  var _datesArray = [];
  var _filterStartTimeMS;
  var _numDataPoints;
  var _periodInMS = DAY;
  var _showTime = false;

  switch (parseInt(m_currentTime)) {
    case (DAY) : {
      _filterStartTimeMS = new Date();
      // If it's 3am, we have 3 data points to grab, and 3 ticks.
      _tickFreq = 1;
      _numDataPoints = _filterStartTimeMS.getHours() + 1;
      _filterStartTimeMS.setHours(0,0,0,0);
      _filterStartTimeMS = _filterStartTimeMS.getTime();
      _periodInMS = HOUR;
      _showTime = true;
      break;
    }
    case (WEEK) : {
      _tickFreq = 1;
      _numDataPoints = 7;
      _filterStartTimeMS = makeDate(WEEK - DAY).getTime();
      break;
    }
    case (MONTH) : {
      _tickFreq = 7;
      _numDataPoints = 28;
      _filterStartTimeMS = makeDate(MONTH - DAY).getTime();
      break;
    }
    case (YEAR) : {
      _numDataPoints = 364;
      _tickFreq = 28;
      _filterStartTimeMS = makeDate(YEAR - DAY).getTime();
      break;
    }
    default : {
      break;
    }
  }

  // Make the data collection first
  for (var _i = 0; _i < _numDataPoints; _i++)
  {
    // Add an entry to the _dataArray with index i, empty total [i, 0]
    _dataArray.push([_i, 0]);
    if (_i % _tickFreq == 0)
    {
      // Push it to the dates array, this will be a tick on the x-axis
      _tickDate = new Date(_filterStartTimeMS + (_i * _periodInMS))
      var _tickString;
      if (_showTime) {
        _tickString = pad(_tickDate.getHours(), 2) + ":" + pad(_tickDate.getMinutes(), 2);
      } else {

        // Format the date according to the user's preferred format.
        if (m_USdateFormat) {
          _tickString = (_tickDate.getMonth() + 1) + "/" +_tickDate.getDate() + "/" +  _tickDate.getFullYear();
        } else {
          _tickString = _tickDate.getDate() + "/" + (_tickDate.getMonth() + 1) + "/" + _tickDate.getFullYear();
        }
      }
      _datesArray.push([_i, _tickString]);
    }
  }

  // We now have a populated tick array, and a data array ready to receive totals

  // Iterate over sessions in m_userData
  for (sessionIndex in m_userData)
  {
    var session = m_userData[sessionIndex];
    var sessionDate = session["startDate"] * 1000;

    // If the session started within our current time (i.e. session["startDate"] >= _filterStartTimeMS)
    if (sessionDate >= _filterStartTimeMS && sessionDate <= new Date().getTime())
    {
      // Grab the relevant stat
      var _stat = session[p_stat];

      // We now have to figure out which bucket of our dataArray it belongs to

      // sessionDate - _filterStartTimeMS = time difference in ms
      var _timeDiff = sessionDate - _filterStartTimeMS;
      // Math.floor(timeDifferenceInMs / _periodInMS ) = how many periods since the startTime the data occurred

      var _timePeriods;
      _timePeriods = Math.floor(_timeDiff / _periodInMS);

      // Add the stat to the bucket
      console.log(_timeDiff / _periodInMS)
      _dataArray[_timePeriods][1] += _stat;
    }
  }

  // Draw the thing!
  drawGraph(_dataArray, _datesArray);

}

function drawGraph(p_data, p_ticks) {

  var _graphTitle;
  var _yTitle;
  var _xTitle = parent.Tgoma.LanguageManager.getString((parseInt(m_currentTime) == DAY) ? "time_of_session" : "date_of_session");
  switch (m_currentMetric) {
    case (JUMPS) : {
      _yTitle = parent.Tgoma.LanguageManager.getString("jumps");
      _graphTitle = parent.Tgoma.LanguageManager.getString("jumps");
      break;
    }
    case (JUMP_TIME) : {
      _yTitle = parent.Tgoma.LanguageManager.getString("jumping_time");
      _graphTitle = parent.Tgoma.LanguageManager.getString("jumping_time");

      break;
    }
    case (HEIGHT) : {
      _yTitle = parent.Tgoma.LanguageManager.getString(m_USunitFormat ? "height_ft" : "height_m");
      _graphTitle = parent.Tgoma.LanguageManager.getString("height");
      break;
    }
    case (CALORIES) : {
      _yTitle = parent.Tgoma.LanguageManager.getString(m_USenergyFormat ? "calories" : "kilojoules");
      _graphTitle = parent.Tgoma.LanguageManager.getString(m_USenergyFormat ? "cals_burned" : "kiljoules_burned");

      break;
    }
  }


  Flotr.draw(
    document.getElementById('chart'),
    [p_data],
    {
      HtmlText: false,
      bars : {
        show : true,
        horizontal : false,
        shadowSize : 0,
        barWidth : 0.5,
        lineWidth: 0,
        fillColor: '#69BA00',
        fillOpacity: 1
      },
      yaxis : {
        min : 0,
        showLabels: true,
        tickFormatter: function(val){
          if (m_currentMetric == "totalJumpTime") {
            return formatTime(val);
          }
          else if (m_currentMetric == "totalHeight") {
          	var _height = val/1000;
          	if (m_USunitFormat) {
          		_height = Tgoma.Utils.convertMetresToFeet(_height);
          	}
            return commify(_height.toFixed(1));
          }
          else if (m_currentMetric == "totalCalories") {
          	var _calories = parseFloat(val) * 0.001;
          	if (!m_USenergyFormat) {
          		_calories = Tgoma.Utils.convertCaloriesToKiloJoules(_calories);
          	}
            return commify(_calories.toFixed(1));
          }
          return val;
        },
        title: _yTitle,
        titleAngle: 90
      },
      xaxis : {
        showLabels: true,
        labelsAngle: 45,
        ticks: p_ticks,
        title: _xTitle,
      },
      grid : {
        verticalLines: true,
        horizontalLines: false,
        outlineWidth: 1,
        outline: 'sw',
        tickColor: '#b7b7b7',
        labelMargin: 5
      },
      title : _graphTitle
    }
  );
}

function makeDate(p_offset) {
  var d = new Date();
  d.setTime(d.getTime() - p_offset);
  d.setHours(0);
  d.setMinutes(0);
  d.setSeconds(0);
  console.log(d.toDateString());
  return d;
}

function commify(x) {
  return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
}

function formatTime(p_time) {
  var ms = p_time % 1000;
  p_time = (p_time - ms) / 1000;
  var secs = p_time % 60;
  p_time = (p_time - secs) / 60;
  var mins = p_time % 60;
  p_time = (p_time - mins) / 60;
  var hrs = p_time % 24;

  return pad(hrs) + ':' + pad(mins) + ':' + pad(secs);
}

function pad(n) {
    return (n < 10 ? '0' : '') + n;
}
