var m_owl;
var m_eventIdToOwlIndexDictionary = {};
var m_eventIdToEventDictionary = {};
var m_populatedEvents = [];
var m_retrievedNewsItems = {};
var _second = 1;
var _minute = _second * 60;
var _hour = _minute * 60;
var _day = _hour * 24;

var AD_TYPE_HALF_PAGE_AD = 0;
var AD_TYPE_FULL_PAGE_BANNER = 1;
var AD_TYPE_EVENT_ANOUNCEMENT = 2;

var returnedItems = [];
var newsReturned = false;
var eventsReturned = false;


$(window).unload(function () {
	parent.document.removeEventListener('onEventReturned', onEventUpdated);
	parent.document.removeEventListener('onNewsItemReturned', onNewsItemUpdated);

	parent.Tgoma.EventHelper.eventLeaderboardReturnedSignal.remove(onEventLeaderboardDataReturned, null);
	parent.Tgoma.EventHelper.userRankReturnedSignal.remove(onEventPersonalDataReturned, null);
});

$(window).load(function() {

	window.onerror = parent.window.onerror;
	document.addEventListener("touchmove", function(e){ e.preventDefault(); }, false);

	parent.Tgoma.EventHelper.eventLeaderboardReturnedSignal.add(onEventLeaderboardDataReturned);
	parent.Tgoma.EventHelper.userRankReturnedSignal.add(onEventPersonalDataReturned);

	parent.document.addEventListener('onEventReturned', onEventUpdated);
	parent.document.addEventListener('onNewsItemReturned', onNewsItemUpdated);

  $("#newsCarousel").owlCarousel({
  	singleItem: true,
  	autoPlay: false,
  	navigation: true,
    navigationText: [
      "<img src='" + parent.getPathByTag("leftArrow.png") + "' />",
      "<img src='" + parent.getPathByTag("rightArrow.png") + "' />"],
      afterMove:onPageChanged,
      afterInit:onPageChanged
  });

  m_owl = $("#newsCarousel").data('owlCarousel');

	parent.TgomaMessaging.callPlugin(onEventItemsReturned, null, null, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getEventItems");
	parent.TgomaMessaging.callPlugin(onNewsItemsReturned, null, null, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getNewsItems");
});

function onPageChanged() {
	//Now we need to find which news/event is on this page.
	var newPage = m_owl.owl.currentItem;
	var foundItem = false;

	//Search through the events dictionary to see if this page is an event.
	for(var index in m_eventIdToOwlIndexDictionary)
	{
		console.log(index);
		if(m_eventIdToOwlIndexDictionary[index] == newPage)
		{
			parent.setItemAsSeen(index);
			foundItem = true;
			break;
		}
	}

	//Search through the news dictionary to see if this page is a news item.
	for(var index in m_retrievedNewsItems)
	{
		console.log(index);
		if(m_retrievedNewsItems[index] == newPage)
		{
			parent.setItemAsSeen(index);
			break;
		}
	}

	parent.refreshUnseenEvents();
}

function onEventItemsReturned(p_data) {
	$.each(p_data, function(i, entry) {
		console.log("entry: " + entry);
		entry.itemType = parent.Tgoma.LanguageManager.getString("event_tag");
		returnedItems.push(entry);
	});
	eventsReturned = true;
	if(newsReturned)
	{
		addItems();
	}
}

function onNewsItemsReturned(p_data) {
	$.each(p_data, function(i, entry) {
		entry.itemType = parent.Tgoma.LanguageManager.getString("news_tag");
		entry.startTime = entry.startDate;
		returnedItems.push(entry);
	});

	newsReturned = true;
	if(eventsReturned)
	{
		addItems();
	}
}

/**
 * Go through the arry of items that need to be added, sort them by their start time,
 * then add them to the carousel.
 */
function addItems()
{
	returnedItems.sort(function(a,b)
	{
		console.log("Start time A:" , a.startTime);
		console.log("Start time B:" , b.startTime);
		// sort in reverse order as last item added to carousel appears first
		return b.startTime - a.startTime;
	});
	$.each(returnedItems, function(i, entry) {
		if(entry.itemType == parent.Tgoma.LanguageManager.getString("event_tag"))
		{
			setTimeout(function() {addEventItem(entry);}, 10);
		}
		else
		{
			setTimeout(function() {addNewsItem(entry);}, 10);
		}
	});
	//Once we've added our known events, get event updates.
	parent.TgomaMessaging.callPlugin(null, null, null, parent.TgomaMessaging.TGOMA_MODULE_NAME, "updateEventItems");
}

function addNewsItem(p_jsonData) {
	// Boilerplate stuff
	console.log("addNewsItem(" + p_jsonData["title"] + ")");

	// Figure out the actual image src
	var _imgPath = p_jsonData["imageId"];
	_countdownTitle = "";
	var _countdownTime = "";
	var _source;
	console.log("AddNewsItem ad type = " + p_jsonData["adType"]);
	switch(p_jsonData["adType"])
	{
		case AD_TYPE_EVENT_ANOUNCEMENT:
		{

			endTime = p_jsonData["endDate"]
			_source = $("#news-template").html();
			var nowUTC = Math.floor(Date.now()/1000);
		    var distance = new Date(endTime) - nowUTC;
		    if (distance <= 0) {
		        _countdownTitle = parent.Tgoma.LanguageManager.getString("event_started");
		    }
		    else
		    {
			    _countdownTitle = parent.Tgoma.LanguageManager.getString("event_starts_in");
			    _countdownTime = formatTime(distance, true);
			}

			break;
		}
		case AD_TYPE_FULL_PAGE_BANNER:
		{
			_source = $("#fullpage-news-template").html();
			if(!parent.checkTagInManifest(_imgPath))
			{
				return;
			}
			break;
		}
		case AD_TYPE_HALF_PAGE_AD:
		default://Default to the half page ad.
		{
			_source = $("#news-template").html();
			break;
		}
	}

	if(_imgPath == null || !parent.checkTagInManifest(_imgPath))
	{
		_imgPath = "AnnounceNews-General5.jpg";
	}


	var _template = Handlebars.compile(_source);

	var _context = {
		itemType: parent.Tgoma.LanguageManager.getString("news_tag"),
		itemTitle: p_jsonData["title"],
		newsImg: _imgPath,
		description: p_jsonData["description"],
		//countdownTime: _countdownTime,
		timerTitle: _countdownTitle
	};

	// Turn the template into html
	var _html = _template(_context);

	// Add html to carousel
	m_owl.addItem(_html);

	m_retrievedNewsItems[p_jsonData["parseId"]] = m_owl.owl.owlItems.length-1;

	// If this is an event announcement, we should start timers that will update the countdown text
	if (p_jsonData["adType"] == AD_TYPE_EVENT_ANOUNCEMENT) {
		var _endTime = p_jsonData["endDate"]; // N.B endDATE not endTIME on this one

		var _owl = getLastOwlItem();
		setupNewsTimer(_owl, _endTime);
	}

}

function setupNewsTimer(p_owl, p_endTime) {

	updateCountdown(p_owl, p_endTime, parent.Tgoma.LanguageManager.getString("event_started"));
}

function addEventItem(p_jsonData) {
console.log("addEventItem(" + p_jsonData["title"] + ")");

	// Boilerplate stuff
	var _source = $("#event-template").html();
	var _template = Handlebars.compile(_source);

	// Figure out the actual image src
	var _imgPath = p_jsonData["imageId"];

	// We don't have an image for this event! Don't show it. Maybe should show default img instead?
	if(_imgPath == null || !parent.checkTagInManifest(_imgPath))
	{
		_imgPath = "Event-General5.jpg";
	}

	var _teamAFlagPath = parent.getPathByTag(p_jsonData["teamACountry"]);
	var _teamBFlagPath = parent.getPathByTag(p_jsonData["teamBCountry"]);

	// Name the teams by region if available, or by country if not
	var _teamAName = p_jsonData["teamARegion"] || p_jsonData["teamACountry"];
	var _teamBName = p_jsonData["teamBRegion"] || p_jsonData["teamBCountry"];

	var _targetType = p_jsonData["targetType"];
	console.log("Target type = " + _targetType);

	var _context = {
		//itemType: parent.Tgoma.LanguageManager.getString("event_tag"),
		itemTitle: p_jsonData["title"],
		countdownTime: "", // TODO
		timerTitle: parent.Tgoma.LanguageManager.getString("event_finishes_in"),
		eventImg: _imgPath,
		description: p_jsonData["description"],
		globalTotal: format(p_jsonData["globalTotal"], _targetType),

		teamAName: _teamAName,
		teamAFlag: _teamAFlagPath,
		teamATotal: format(p_jsonData["teamATotal"], _targetType),

		teamBName: _teamBName,
		teamBFlag: _teamBFlagPath,
		teamBTotal: format(p_jsonData["teamBTotal"], _targetType),
		LBL_current_total: parent.Tgoma.LanguageManager.getString("LBL_current_total"),
		LBL_retrieving_leaderboard: parent.Tgoma.LanguageManager.getString("LBL_retrieving_leaderboard"),
		LBL_retrieving_rank: parent.Tgoma.LanguageManager.getString("LBL_retrieving_rank")

		//eventProgressBarTotal: format(p_jsonData["teamATotal"], _targetType) || format(p_jsonData["globalTotal"], _targetType),
		// TODO figure out which bar to show
	};

	// Turn the template into html
	var _html = _template(_context);

	// Add html to carousel
	if(m_owl == null)
	{
		return;
	}
	m_owl.addItem(_html);

	// Grab the item we just added
	var _owl = getLastOwlItem();

	m_eventIdToOwlIndexDictionary[p_jsonData["parseId"]] = m_owl.owl.owlItems.length-1;
	m_eventIdToEventDictionary[p_jsonData["parseId"]] = p_jsonData;

	formatOwlItem(_owl, p_jsonData);

	parent.TgomaMessaging.callPlugin(null, null, null, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getEventLeaderboardByEvent", [p_jsonData["parseId"]]);
	parent.TgomaMessaging.callPlugin(null, null, null, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getEventLeaderboardUserRankByEvent", [p_jsonData["parseId"]]);

}

function onEventUpdated(e) {
	console.log("onEventUpdated(" + e.event["parseId"] + ")");
	var _event = e.event;
	setTimeout(function(){
		var _index = m_eventIdToOwlIndexDictionary[_event["parseId"]];
		if (_index != null) {
		    var _owl = getOwlItem(_index);
		    if (_owl) {
		    	formatOwlItem(_owl, _event);
			}
		} else {
			addEventItem(_event);
		}

	    //Need to call on page changed to get the updated details of pages viewed.
		onPageChanged();
	}, 1000);

}

function onNewsItemUpdated(e){
	console.log("onNewsItemUpdated(" + e + ")");

	setTimeout(function(){

		var newsItem = e.newsItem;

		var _index = m_retrievedNewsItems[newsItem["parseId"]];
		if (_index == null) {
			addNewsItem(newsItem);
		}
	}, 1000);

	//Need to call on page changed to get the updated details of pages viewed.
	onPageChanged();
}

function formatOwlItem(p_owl, p_jsonData) {
	console.log("formatOwlItem", p_jsonData["parseId"]);
	// Format event image based on description height
	//var _descriptionHeight = _owl.find('.event-description').height() * 0.8;
	//_owl.find('.event-image').height(_descriptionHeight);

	// Hide html elements based on event type / target / teams
	// If it's team based, hide the global total
	// If there's one team, teamB will be empty, we'll display this like a global event.
	if (p_jsonData["teamBCountry"] != null) {
		p_owl.find('.event-total-text-container').hide();
	} else {
		// and if it's not team based, hide the teams
		p_owl.find('.event-teams-container').hide();
	}

	// These values have been set already but in the case where the event has
	// been updated since we opened the page (see: onEventUpdated()), they need to be updated
	p_owl.find(".event-total-amount").text(format(p_jsonData["globalTotal"], p_jsonData["targetType"]));
	if (p_owl.find(".team-total").get(0) != null) {
		p_owl.find(".team-total").get(0).innerHTML = format(p_jsonData["teamATotal"], p_jsonData["targetType"]);
	}
	if (p_owl.find(".team-total").get(1) != null) {
		p_owl.find(".team-total").get(1).innerHTML = format(p_jsonData["teamBTotal"], p_jsonData["targetType"]);
	}

	// If there's no target, hide the target progress bar
	if (p_jsonData["target"] == 0) {
		p_owl.find('.event-progress-bar-container').hide();
	} else {
		// there is a target - we'd better set up the progress bar with a value
		var _progress = 0;
		// If it's team based, use my team's total
		if (p_jsonData["teamBCountry"] != null) {
			var _teamTotalColumnName = getUserTeamTotalColumnName(p_jsonData["teamACountry"], p_jsonData["teamARegion"], p_jsonData["teamBCountry"], p_jsonData["teamBRegion"])
			_progress = (p_jsonData[_teamTotalColumnName]/p_jsonData["target"]) * 100;
			p_owl.find(".event-total-amount").text(format(p_jsonData["globalTotal"], p_jsonData["targetType"]));
		} else {
			// otherwise use the global total
			_progress = (p_jsonData["globalTotal"]/p_jsonData["target"]) * 100;
		}
		if(isNaN(_progress)){
			_progress = 0;
		}

		console.log(p_jsonData["parseId"] + " progress: " + _progress);
		_progress = Math.min(_progress, 100);

		$(p_owl.find('.event-progress-bar-total')).text(format(_progress, 1) + "%");

		$(p_owl.find('.event-progress-bar')).progressbar({
			value: _progress
		});

		// Bit of a hack to catch the updating case
		p_owl.find(".event-progress-bar").progressbar("value", _progress);
	}

	if (_progress >= 100) {
		if($(p_owl.find('.timer-tile'))[0] != null)
		{
	        $(p_owl.find('.timer-title'))[0].innerHTML = parent.Tgoma.LanguageManager.getString("event_finished");
	    }
		if($(p_owl.find('.event-timer'))[0] != null)
		{
	        $(p_owl.find('.event-timer'))[0].innerHTML = "";
    	}
	} else {
		var _endTime = p_jsonData["endTime"];
		updateCountdown(p_owl, _endTime);
		// Set up the timer
		_timerRef = setInterval(function() {
			updateCountdown(
				p_owl,
				_endTime,
				parent.Tgoma.LanguageManager.getString("event_finished"),
				_timerRef);
		}, 1000);
	}
}

function getUserTeamTotalColumnName(p_teamACountry, p_teamARegion, p_teamBCountry, p_teamBRegion) {
	var _userCountry = parent.Tgoma.UserHelper.currentFamilyAccount.m_country;
	var _userRegion = parent.Tgoma.UserHelper.currentFamilyAccount.m_region;

	// These can't easily be combined into an if/else, so it's easier to lay out the options longform
	if (_userRegion == p_teamARegion) {
		return "teamATotal";
	} else if (_userRegion == p_teamBRegion) {
		return "teamBTotal";
	} else if (_userCountry == p_teamACountry) {
		return "teamATotal";
	} else if (_userCountry == p_teamBCountry) {
		return "teamBTotal";
	}
}

function onEventLeaderboardDataReturned(p_jsonData) {
	if(p_jsonData == null || p_jsonData["eventId"] == null)
	{
		return;
	}
	console.log("onEventLeaderboardDataReturned(" + p_jsonData["eventId"] + ")");
	var _eventId = p_jsonData["eventId"];
    var _owl = getOwlItem(m_eventIdToOwlIndexDictionary[_eventId]);

	var _event = m_eventIdToEventDictionary[p_jsonData["eventId"]];
	if (_owl == null || m_populatedEvents.indexOf(_eventId) >= 0) {
		return;
	}

	if (p_jsonData == null || p_jsonData["leaderboard"].length == 0) {
		$(_owl).find('.event-leaderboard tr td').text(parent.Tgoma.LanguageManager.getString("event_no_entries"));
	} else {
		$(_owl).find('.event-leaderboard tr').remove();
	}

	for (var _i = 0; _i < 10; _i++) {
		if (p_jsonData["leaderboard"][_i] != null) {
			addEntryToLeaderboard(p_jsonData["leaderboard"][_i]["rank"],
				p_jsonData["leaderboard"][_i]["country"],
				p_jsonData["leaderboard"][_i]["username"],
				p_jsonData["leaderboard"][_i]["contribution"],
				$(_owl).find('.event-leaderboard'),
				_event["targetType"]);
		} else {
			addEntryToLeaderboard("", "", "", null,
				$(_owl).find('.event-leaderboard'),
				_event["targetType"]);
		}
	}
	m_populatedEvents.push(_eventId); //If you open the page multiple times you can get mutliple responses, and if they're no data it'll put that in every row and column.
}

function onEventPersonalDataReturned(p_jsonData) {
	if(p_jsonData == null)
	{
		return;
	}
	console.log("onEventPersonalDataReturned(" + p_jsonData["eventId"] + ")");

    var _owl = getOwlItem(m_eventIdToOwlIndexDictionary[p_jsonData["eventId"]]);
	var _event = m_eventIdToEventDictionary[p_jsonData["eventId"]];

	if (_owl == null) {
		return;
	}

	$(_owl).find('.event-personal-ranking tr').remove();

	addEntryToLeaderboard(p_jsonData["userRank"]["rank"] || "N/A",
		p_jsonData["userRank"]["country"],
		p_jsonData["userRank"]["name"],
		p_jsonData["userRank"]["contribution"] || 0,
		$(_owl).find('.event-personal-ranking'),
		_event["targetType"]);
}

function addEntryToLeaderboard(p_rank, p_country, p_name, p_score, p_table, p_targetType) {
    if (p_country == undefined) {
        p_country = "Not Set"
    }
	p_table.append("<tr class='leaderboard-row'>" +
	'<td class="leaderboard-rank"><p>' + p_rank + '</p></td>' +
	'<td class="leaderboard-flag">' + (p_country == "" ? "" : "<img src='" + parent.getPathByTag(p_country) + "'/>")  + '</td>' +
	'<td class="leaderboard-name"><p>' + p_name + '</p></td>' +
	'<td class="leaderboard-score"><p>' + format(p_score, p_targetType) + '</p></td>' +
	'</tr>');
}

function updateCountdown(p_owl, p_endTime, p_endText, p_timer) {
    var nowUTC = Math.floor(Date.now()/1000);
    var distance = new Date(p_endTime) - nowUTC;
    if (distance <= 0) {

        clearInterval(p_timer);
        if($(p_owl.find('.timer-title'))[0] != null)
        {
	        $(p_owl.find('.timer-title'))[0].innerHTML = p_endText;
	        $(p_owl.find('.event-timer'))[0].innerHTML = "";
        }

        return;
    }

	var _timerTextElement = $(p_owl.find('.event-timer'))[0];

	if (p_owl != null && _timerTextElement != null) {
	    _timerTextElement.innerHTML = formatTime(distance, true);

	    // Hack for the forever-event...
	    if (_timerTextElement.innerHTML == "") {
	    	$(p_owl.find('.timer-title'))[0].innerHTML = "";
	    }
	}
}

function formatTime(p_time, p_limitTime) {

    var days = Math.floor(p_time / _day);
    var hours = Math.floor((p_time % _day) / _hour);
    var minutes = Math.floor((p_time % _hour) / _minute);
    var seconds = Math.floor((p_time % _minute) / _second);

    // HACK PREVENTING EVENTS FURTHER THAN A 5 YEARS AWAY FROM SHOWING UP
    if (p_limitTime && days > (365* 5)) {
    	return "";
    }

	var _display = "";

	if (days > 0) {
    	_display += parent.Tgoma.LanguageManager.getString("num_days", days);
	}
	if (hours > 0) {
    	_display += parent.Tgoma.LanguageManager.getString("num_hours",hours);
	}
	if (days <= 0) {
		if (minutes > 0) {
			_display += parent.Tgoma.LanguageManager.getString("num_mins",minutes);
		} else {
			_display += parent.Tgoma.LanguageManager.getString("num_seconds",seconds);
		}
	}
	return _display;
}


function format(x, p_unitType) {
	if (x == null){ return ""};

	if (typeof x === "string"){ return "-"; }

	switch (p_unitType) {
		case 1: {
			// Jumps
			x = Math.round(x);
			break;
		}
		case 2: {
			// height mm -> m
			x = Math.round(x/1000);
			break;
		}
		case 3: {
			// time
			return formatTime(Math.round(x/1000),false);
			break;
		}
		case 4: {
			// calories
			return Math.round(x/1000);
			break;
		}
	}

    return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
}

function getFirstOwlItem() {
	return getOwlItem(0);
}

function getLastOwlItem() {
	return getOwlItem(getNumOwls() - 1);
}

function getOwlItem(p_position) {
	if(m_owl != null && m_owl.owl != null && m_owl.owl.owlItems != null)
	{
		return $(m_owl.owl.owlItems[p_position]);
	}
	else
	{
		return null;
	}
}

function getNumOwls() {
	if(m_owl != null && m_owl.owl != null && m_owl.owl.owlItems != null)
	{
		return m_owl.owl.owlItems.length;
	}
	else
	{
		return 0;
	}
}
