var m_user;
var m_validName = true;
var m_syncFailed = false;
var m_waitingForResult = false;

var m_USunitFormat = false;


$(document).ready(function () {
    document.addEventListener("localisedFramePopulated", onLocalisedFramePopulated);

    window.onerror = parent.window.onerror;

    $("body").css("display", "hidden");

});

$(window).unload(function () {
    parent.document.removeEventListener('onLoginFailed', onLoginFailed);
    parent.document.removeEventListener('onUserDeleted', onDeleteAccountSuccess);
    parent.document.removeEventListener("onNetworkError", onNetworkError);
});

function onLocalisedFramePopulated() {
    console.log("onLocalisedFramePopulated");

    document.removeEventListener("localisedFramePopulated", onLocalisedFramePopulated);

    parent.TgomaMessaging.callPlugin(onFamilyReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getFamilyAccountExists", []);

    parent.document.addEventListener("onLoginFailed", onLoginFailed, false);
}

function onFamilyReturned(p_familyExists) {
    if (p_familyExists) {
        $("body").css("display", "");
        $(".password-dialog").load(parent.getPathByTag("confirmPassword.htm"));
        // Load the confirmPassword javascript now
        $.getScript(parent.getPathByTag("confirmPassword.js"), function () {
            $("#password-entry-form").submit(function (e) {
                console.log("[FamilyPreferences] password-entry-form.submit()");
                e.preventDefault();
                return false;
            });
            setPasswordConfirmationDescription(parent.Tgoma.LanguageManager.getString("delete_confirmation"));
        });

        parent.TgomaMessaging.callPlugin(function (p_accountPrefs) {

            m_USunitFormat = p_accountPrefs["unitsAreUSFormat"];
            if (m_USunitFormat) {
                $("#weightLabel").text(parent.Tgoma.LanguageManager.getString("weight_pounds"));
                $("#weightLabel").attr("texttag", "weight_pounds");
            }
            else {
                $("#weightLabel").text(parent.Tgoma.LanguageManager.getString("weight_kgs"));
                $("#weightLabel").attr("texttag", "weight_kgs");
            }

            parent.TgomaMessaging.callPlugin(function (p_playerName) {
                console.log("Player name: " + p_playerName);
                p_playerName = p_playerName.toString();
                parent.TgomaMessaging.callPlugin(onGetUserDetailsReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getUserDetailsByUsername", [p_playerName]);
            }, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getUser");


        }, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getFamilyAccountFormatPreferences");

        $("#confirmButton").click(onConfirmClicked);
    }
    else {
        parent.loadFrame("familyLoginFrame");
    }
}

function onGetUserDetailsReturned(p_user) {
    m_user = p_user;
    console.log(m_user);

    // Name
    $("#name").val(p_user.userName);

    // Account Type status + button
    if (!p_user.isVisitor) {
        // No more manual syncing
        $("#lastSyncedDiv").show();

        var _date = new Date(p_user.lastSynced * 1000);
        var _dateText;

        if (parent.Tgoma.UserHelper.currentFamilyAccount.m_dateIsUSFormat) {
            _dateText = (_date.getMonth() + 1) + "/" + _date.getDate() + "/" + _date.getFullYear();
        } else {
            _dateText = _date.getDate() + "/" + (_date.getMonth() + 1) + "/" + _date.getFullYear();
        }

        if (p_user.lastSynced == 0) {
            _dateText = parent.Tgoma.LanguageManager.getString("never");
        }

        $("#lastSynced").text(_dateText)

    }

    if (p_user.isVisitor) {
        $("#name").attr("disabled", true);
        $("#deletePlayerButton").hide();
    }

    if (p_user.profane) {
        $("#nameAlertButton").show();
        $("#nameAlertButton").click(function () {
            parent.showAlert("profane_tip")
        });
    }

    // Weight
    var weight = p_user.weight;
    if (m_USunitFormat) {
        weight = parent.Tgoma.Utils.convertKilogramsToPounds(weight);
    }
    weight = Math.round(weight); //Need to round for a conversion missmatch.
    m_user.weight = weight;

    $("#weight").val(weight);
    $("#termsConditionsButton").click(onTermsAndConditionsClicked);
    $("#weightHelpButton").click(onWeightHelpClicked);
    $("#lastSyncedHelpButton").click(onLastSyncedHelpClicked);
    $("#deletePlayerButton").click(onDeleteClicked);
    $("#cancelButton").click(onCancelClicked);
    $("#changePasswordButton").click(onPasswordChangeClicked);

    $('#name').on('input', function () {
        validateName()
    });
    $('#weight').on('input', function () {
        validateWeight()
    });
}

function onConfirmClicked(evt) {
    console.log("[PlayerDetails.htm] onConfirmClicked()");

    // If things have changed and the name and weight are valid (and the name has not been taken: [m_validName])
    // Validate name and weight first so that existing errors are picked up
    if (validateName() && validateWeight() && checkFieldsChanged() && window.m_validName) {
        console.log("checkFieldsChanged() && validateName() && validateWeight() && window.m_validName: true");

        // And then they agree to the confirmation dialog
        parent.showConfirm("confirm_save_changes", function (result) {
            if (result) {
                // Save the changes.
                console.log("Confirmed");
                var weight = parseInt($('#weight').val());
                if (m_USunitFormat) {
                    weight = parent.Tgoma.Utils.convertPoundsToKilograms(weight);
                }
                parent.TgomaMessaging.callPlugin(onUpdateUserComplete, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "updateUserDetails",
                        [$('#name').val(), weight]);

                window.m_user.userName = $('#name').val();
                window.m_user.weight = weight;
            }
        });
    }
    return false;
}

function onUserChanged(p_user) {
    window.m_user = p_user;
}
function onUpdateUserComplete() {
    console.log("[PlayerDetails.htm] onUpdateUserComplete()");

    parent.window.analytics.trackEvent('User', 'Update', 'Family Member');

    parent.loadFrame("games");
}

function onCancelClicked(evt) {
    console.log("[PlayerDetails.htm] onCancelClicked()");
    if (checkFieldsChanged()) {
        parent.showConfirm("confirm_player_cancel", function (result) {
            if (result) {
                parent.loadFrame("players");
            }
        });
    } else {
        parent.loadFrame("players");
    }
}

function onWeightHelpClicked(evt) {
    console.log("[PlayerDetails.htm] onWeightHelpClicked()");
    parent.showAlert("weight_tip");
}

function onLastSyncedHelpClicked(evt) {
    console.log("[PlayerDetails.htm] onLastSyncedHelpClicked()");
    parent.showAlert("sync_tip");
}

function onPasswordChangeClicked(evt) {
    console.log("[PlayerDetails.htm] onPasswordChangeClicked()");
    parent.loadFrame("changePassword");
}

function onTermsAndConditionsClicked(evt) {
    console.log("[PlayerDetails.htm] onTermsAndConditionsClicked()");
    parent.loadOverlayFrame(parent.getPathByTag("privacyPolicy.htm"));
}

function onDeleteClicked(evt) {
    console.log("[PlayerDetails.htm] onDeleteClicked()");

    var requestParams = new Object();
    requestParams["userId"] = window.m_user.userID;
    setRequestParams("deleteUser", JSON.stringify(requestParams));
    parent.Tgoma.UserHelper.familyLoginReturnedSignal.addOnce(onLoginForSaveChangesReturned, this);
    parent.document.addEventListener("onUserDeleted", onDeleteAccountSuccess, false);
    parent.document.addEventListener("onNetworkError", onNetworkError, false);

    showConfirmPasswordDialog();
}

function onLoginForSaveChangesReturned(p_outcome, p_error) {

    console.log("onLoginForSaveChangesReturned()")
    if (p_outcome == true) {
        //disable the confirm button so we can't try confirm changes to a user we are deleting.
        document.getElementById("confirmButton").disabled = true;

    } else {
        setTimeout(function () { parent.showAlert("login_error", parent.Tgoma.LanguageManager.getString(p_error)); }, 1);
    }
}

function onDeleteAccountSuccess() {
    console.log("[PlayerDetails.htm] onDeleteAccountSuccess()");

    parent.window.analytics.trackEvent('User', 'Delete', 'Family Member');

    parent.loadFrame("players");
}

function onNetworkError(p_event) {
    console.log("onNetworkError(" + p_event.code + "," + p_event.message + ")");
    setTimeout(function () {
        parent.showConfirm("delete_user_network_error", function (retry) {
            if (retry) {
                showConfirmPasswordDialog();
            }
        });
    }, 1);
}

function onDeleteAccountError() {
    console.log("[PlayerDetails.htm] onDeleteAccountError()");
    setTimeout(function () { parent.showAlert("delete_last_user_error"); }, 1);
}

function onLoginFailed() {
    console.log("[PlayerDetails.htm] onLoginFailed()");
    setTimeout(function () { parent.showAlert("login_failed_message"); }, 1);
    m_syncFailed = true;
}

function validateName() {
    console.log("[PlayerDetails.htm] validateName()");

    $("#name").removeClass("input-state-error");
    $("#nameTips").removeClass("tip-state-visible");

    if (window.m_user.userName != $("#name").val()) {
        parent.TgomaMessaging.callPlugin(onLocalNameExistanceCheckReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "checkLocalUserExistsOnDevice", [$("#name").val()]);
    }

    return checkLength($("#name"), $("#nameTips"), "Name", 1, 10) &&
           checkForEmojis($("#name"), $("#nameTips"), "validate_name_error") &&
           checkRegexp($("#name"), $("#nameTips"), /^[\u0400-\u04FFA-Za-z][-\u0400-\u04FFA-Za-z0-9]*$/, "validate_name_error");
}

function onLocalNameExistanceCheckReturned(p_nameExists) {
    console.log("onLocalNameExistanceCheckReturned(" + p_nameExists + ")");
    if (p_nameExists) {
        updateTips($("#name"), $("#nameTips"), "name_in_use");
        window.m_validName = false;
    }
    else {
        window.m_validName = true;
    }
}

function validateWeight() {
    console.log("[PlayerDetails.htm] validateWeight()");

    $("#weight").removeClass("input-state-error");
    $("#weightTips").removeClass("tip-state-visible");

    var _valid = checkLength($("#weight"), $("#weightTips"), "weight", 1, 3)

    if (m_USunitFormat) {
        _valid = _valid && checkRegexp($("#weight"), $("#weightTips"), /^\d+$/, "weight_check_1_pounds") && _valid;
        _valid = _valid && checkMaxValue($("#weight"), $("#weightTips"), 331, "weight_check_2_pounds") && _valid;
        _valid = _valid && checkMinValue($("#weight"), $("#weightTips"), 10, "weight_check_3_pounds") && _valid;
    } else {
        _valid = _valid && checkRegexp($("#weight"), $("#weightTips"), /^\d+$/, "weight_check_1_kgs") && _valid;
        _valid = _valid && checkMaxValue($("#weight"), $("#weightTips"), 150, "weight_check_2_kgs") && _valid;
        _valid = _valid && checkMinValue($("#weight"), $("#weightTips"), 5, "weight_check_3_kgs") && _valid;
    }

    return _valid;
}

function checkFieldsChanged() {
    console.log("[PlayerDetails.htm] checkFieldsChanged()");
    return ($("#name").val() != m_user.userName) ||
	($("#weight").val() != m_user.weight);
}


function checkLength(p_field, p_fieldTips, p_name, min, max) {
    console.log("checkLength()");
    if (p_field.val().length > max || p_field.val().length < min) {
        updateTips(p_field, p_fieldTips, "length_check_error", p_name, min, max);
        return false;
    }
    return true;
}

function checkRegexp(p_field, p_fieldTips, regexp, p_error) {
    console.log("checkRegexp()");
    if (!(regexp.test(p_field.val()))) {
        updateTips(p_field, p_fieldTips, p_error);
        return false;
    }
    return true;
}

function checkMaxValue(p_field, p_fieldTips, p_maxValue, p_error) {
    console.log("checkMaxValue()");
    if (p_field.val() > p_maxValue) {
        updateTips(p_field, p_fieldTips, p_error);
        return false;
    }
    return true;
}

function checkMinValue(p_field, p_fieldTips, p_minValue, p_error) {
    console.log("checkValue()");
    if (p_field.val() < p_minValue) {
        updateTips(p_field, p_fieldTips, p_error);
        return false;
    }
    return true;
}


function checkMatch(p_first, p_second, p_tips, p_message) {
    console.log("checkMatch()");
    if (p_first.val() != p_second.val()) {
        updateTips(p_first, p_tips, p_message);
        return false;
    }
    return true;
}

function checkForEmojis(p_field, p_tips, p_message) {
    var containsEmoji = p_field.val().search(/([\uD800-\uDBFF][\uDC00-\uDFFF])/g) >= 0 ||
    	p_field.val().search(/([\uE000-\uF8FF]|\uD83C[\uDF00-\uDFFF]|\uD83D[\uDC00-\uDDFF])/g) >= 0; //Trying to find if there are emojis
    if (containsEmoji) {
        updateTips(p_field, p_tips, p_message);
        return false;
    }
    return true;
}

function updateTips(p_field, p_fieldTips, p_error) {
    var copy = null;
    copy = [].slice.call(arguments);
    copy.splice(0, 2);
    p_error = parent.Tgoma.LanguageManager.getString.apply(parent.Tgoma.LanguageManager, copy);

    console.log("updateTips(" + p_field + ", " + p_fieldTips + ", " + p_error + ")");

    p_fieldTips.text(p_error).addClass("tip-state-visible");
    p_field.addClass("input-state-error");

}
