$(document).ready(function() {
    parent.TgomaMessaging.callPlugin(onFamilyReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getFamilyAccountExists",[]);
    $("body").css("display","hidden");

	window.onerror = parent.window.onerror;

});

function onFamilyReturned(p_familyExists){
	if(p_familyExists)
	{
	    $("body").css("display","");
	    	parent.TgomaMessaging.callPlugin(onPlayerListReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getUserList");
		//onPlayerListReturned();

		document.getElementById("newPlayerButtonImg").addEventListener("click", onNewPlayerClicked);
	}
	else
	{
		parent.loadFrame("familyLoginFrame");
	}
}

function onPlayerListReturned(p_players) {
	//p_players = ["Joel", "Daniel", "Nadia", "Melvin", "Tim", "10charname", "15characternamefgcfhjyjhkjg", "Melvin", "Tim", "10charname", "15characternamefgcfhjyjhkjg"];
	var source = $("#button-template").html();
	var template = Handlebars.compile(source);

	var buttonsArray = [];

	for (var i = 0; i < Math.max(9, p_players.length); i++) {
		var player = "";
		if (i < p_players.length){
			player = p_players[i];
		}

		var bgImgSrc = i == 0 ? "player-list-active.png" : "player-list-inactive.png";
		if (player == "") {
			bgImgSrc = "player-list-empty.png";
		}
		console.log(bgImgSrc);
		var context = {text: player, backgroundImg:bgImgSrc, class: player == "" ? "" : "player"};
		var html = template(context);
		buttonsArray.push(html);
		//$("#playerList").append(html);
	}

	var populateField = function(){ //When the page first loads sometimes the backplates are messed up.
		for(var html in buttonsArray)
		{
			$("#playerList").append(buttonsArray[html]);
		}

		var playerButtonList = document.getElementsByClassName("player");
		for(var i = 0; i < playerButtonList.length; i++){
			playerButtonList[i].addEventListener("click", onPlayerButtonClicked, false);
		}
	}

	if(window.usersShown) //Is this the first time we're trying to show the users? If it is we need to wait a bit.
	{
		populateField();
	}
	else
	{
		setTimeout(populateField, 10); //SF-2010 There were issues with the backplate being undefined if it was added too quickly. Neeed to delay it slightly.
		window.usersShown = true;
	}
	
	//touchScroll("playerListWrapper");
}

function onNewPlayerClicked(evt) {
	parent.loadFrame("createPlayer");
}

function onPlayerButtonClicked(evt) {
	var name = $(evt.target).attr("data-name");
	console.log("selected player " + name);

	if (name != null) {
		if(name != parent.Tgoma.UserHelper.m_currentFamilyMember.m_name)
		{
			parent.TgomaMessaging.callPlugin(onSetUserReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "setUser", [name]);
		}
		else
		{
			parent.loadFrame("playerDetails");
		}
	}
}

function onSetUserReturned() {
	//Relayout the users
	$("#playerList").text("");
	parent.TgomaMessaging.callPlugin(onPlayerListReturned, null, this, parent.TgomaMessaging.USER_MODULE_NAME, "getUserList");
}

function touchScroll(id){
  if(parent.Tgoma.ApplicationUtils.DeviceUtils.isMobile.iOS())
  {
	var el=document.getElementById(id);
	var scrollStartPos=0;

	document.getElementById(id).addEventListener("touchstart", function(event) {
		scrollStartPos=this.scrollTop+event.touches[0].pageY;
	},false);

	document.getElementById(id).addEventListener("touchmove", function(event) {
		this.scrollTop=scrollStartPos-event.touches[0].pageY;
	},false);
  }
}