$(document).ready(function () {
    // Load the confirm password files	
    $(".password-dialog").load("confirmPassword.htm");
    $.getScript("confirmPassword.js");
    // Load the age gate files	
    $(".age-gate-dialog").load("ageGate.htm");
    $.getScript("ageGate.js");
});

function onBackPressed() {
    console.log("onBackKeyDown()");
    parent.hideOverlayFrame();
}


function onLinkClicked(p_pageSelected) {
    _pageSelected = p_pageSelected;
    if (parent.Tgoma.UserHelper.currentFamilyAccount.m_email == "") {
        setAgeGateConfirmationDescription(parent.Tgoma.LanguageManager.getString("age_gate_no_account"));
        setAgeGateCallback(onAgeGateQuestionForLinkAnswered);
        showAgeGateDialog();
    }
    else {
        var requestParams = new Object();
        setRequestParams("none", JSON.stringify(requestParams));

        parent.Tgoma.UserHelper.familyLoginReturnedSignal.addOnce(onLoginForLeavingAppLinkReturned, this);
        // Show the password entry dialog that will send our request to native
        setPasswordConfirmationDescription(parent.Tgoma.LanguageManager.getString("age_gate_with_account"));
        showConfirmPasswordDialog();
    }
}

function onLoginForLeavingAppLinkReturned(p_outcome, p_error) {
    if (p_outcome) {
        if (_pageSelected != null) {
            parent.window.open(_pageSelected, '_system');
        }
    }
    else {
        setTimeout(function () { parent.showAlert("login_error", parent.Tgoma.LanguageManager.getString(p_error)); }, 1);
    }

    _pageSelected = null;

}

function onAgeGateQuestionForLinkAnswered(p_outcome) {
    if (p_outcome) {
        if (_pageSelected != null) {
            parent.window.open(_pageSelected, '_system');
        }
    }
    else {
        setTimeout(function () { parent.showAlert("incorrect_solution"); }, 1);
    }

    _pageSelected = null;
}

function onEmailClicked(p_emailAddress) {
    _emailSelected = p_emailAddress;

    if (parent.Tgoma.UserHelper.currentFamilyAccount.m_email == "") {
        setAgeGateConfirmationDescription(parent.Tgoma.LanguageManager.getString("age_gate_no_account"));
        setAgeGateCallback(onAgeGateQuestionForEmailAnswered);
        showAgeGateDialog();
    }
    else {
        // Set up the request object that'll get sent along with the family login
        var requestParams = new Object();
        setRequestParams("none", JSON.stringify(requestParams));

        parent.Tgoma.UserHelper.familyLoginReturnedSignal.addOnce(onLoginForLeavingAppEmailReturned, this);

        // Show the password entry dialog that will send our request to native
        setPasswordConfirmationDescription(parent.Tgoma.LanguageManager.getString("age_gate_with_account"));
        showConfirmPasswordDialog();
    }
}

function onLoginForLeavingAppEmailReturned(p_outcome, p_error) {
    if (p_outcome) {
        if (_emailSelected != null) {
            parent.window.open('mailto:' + _emailSelected, '_system');
        }
    }
    else {
        setTimeout(function () { parent.showAlert("login_error", parent.Tgoma.LanguageManager.getString(p_error)); }, 1);
    }

    _emailSelected = null;

}

function onAgeGateQuestionForEmailAnswered(p_outcome) {
    if (p_outcome) {
        if (_emailSelected != null) {
            parent.window.open('mailto:' + _emailSelected, '_system');
        }
    }
    else {
        setTimeout(function () { parent.showAlert("incorrect_solution"); }, 1);
    }

    _pageSelected = null;
}