var iaps = ["com.tgoma.trampolineapp.tokens_1", 
"com.tgoma.trampolineapp.tokens_2", 
"com.tgoma.trampolineapp.tokens_3", 
"com.tgoma.trampolineapp.tokens_4"];

var _purchaseLock = false;
var _canBuyTokens = false;

$(window).unload(function () {
	parent.document.removeEventListener('online', onOnline);
	parent.document.removeEventListener('offline', onOffline);
	parent.document.removeEventListener('onVirtualCurrencyBalanceChange', onVirtualCurrencyUpdated);
})

$(window).load(function() {
	console.log("init()")

	window.onerror = parent.window.onerror;
	// Disable page scrolling
	document.addEventListener("touchmove", function(e){ e.preventDefault(); }, false);


	$(".password-dialog").load("confirmPassword.htm");
	$.getScript(parent.getPathByTag("confirmPassword.js"));

	// Set up tabbed panel
	$(function() {
		$( "#tabs" ).tabs().addClass( "ui-tabs-vertical ui-helper-clearfix" );
		$("#tabs").tabs({
		  	beforeActivate: function (event, ui) {
		    if(_canBuyTokens || parent.Tgoma.UserHelper.currentFamilyAccount.m_email == "")
		    {
		    	return true;
		    }
		    else
		    {
				// Set up the request object that'll get sent along with the family login
				var requestParams = new Object();
				setRequestParams("none", JSON.stringify(requestParams));

			  	parent.Tgoma.UserHelper.familyLoginReturnedSignal.addOnce(onLoginForTokenPurchaseReturned, this);

				// Show the password entry dialog that will send our request to native
				setPasswordConfirmationDescription(parent.Tgoma.LanguageManager.getString("log_in_to_purchase"));

			  	setTimeout(function(){  showConfirmPasswordDialog(); }, 10);
		    	return false;
		    }
		  }
		});
		$( "#tabs li" ).removeClass( "ui-corner-top" ).addClass( "ui-corner-left" );
	});
    FastClick.attach(document.getElementById("tabs"));

	$("#gamesCarousel").owlCarousel({
		itemsCustom: [[0, 3]], 
		autoPlay: false,
		pagination: false,
		navigation: true,
		navigationText: [
			"<img src='leftArrow.png' />", 
  			"<img src='rightArrow.png' />"]
	});

	$("#virtualCurrencyCarousel").owlCarousel({
		itemsCustom: [[0, 4]],
		autoPlay: false,
		pagination: false,
		navigation: true,
		navigationText: [
			"<img src='leftArrow.png' />", 
  			"<img src='rightArrow.png' />"]
	});

	addIAPsToCarousel(iaps);

	
	parent.TgomaMessaging.callPlugin(onGetUnownedGamesSucceeded, onGetUnownedGamesFailed, this, 
		parent.TgomaMessaging.GAME_MODULE_NAME, "getGamesToPurchase");


	$('.game-container').on('click', onGameClicked);
	
	// If we have a family try to get the gem balance.
	if (parent.Tgoma.UserHelper.currentFamilyAccount.m_email != "") {
		fetchVirtualCurrencyBalance();
	}
	else
	{
		$(".vc-balance").each(function() {
			$(this).text("0");
		});
	}

	parent.document.addEventListener("online", onOnline, false);
	parent.document.addEventListener("offline", onOffline, false);
	parent.document.addEventListener("onVirtualCurrencyBalanceChange", onVirtualCurrencyUpdated, false)

	parent.SpringfreePurchaseValidation.getPurchaseList(iaps, onInAppPurchasesReturned, onGetPurchaseListFailed);

	// Make the VC tab active if we have the corresponding URLParameter ("vc")
	var _dest = parent.getURLParameter("dest", location);
	if (_dest == "vc") {
		_canBuyTokens = true;
		$('#tabs').tabs("option", "active", 1);
	}

});

function onGetUnownedGamesSucceeded(p_games) {
	console.log("onGetUnownedGamesSucceeded(" + p_games + ")"); 

	if (p_games == null || p_games.length == 0) { 
		$("#gamesCarousel").data('owlCarousel').reinit({
			itemsCustom: [[0, 1]],
			autoPlay: false,
			pagination: false,
			navigation: false
		});

		$("#gamesCarousel").data('owlCarousel').addItem("<p class='placeholder-text'>" + parent.Tgoma.LanguageManager.getString("check_back_soon") +"</p>");

		return;
	}

	for(var _game in p_games) {
		addGameToCarousel(p_games[_game]);
		parent.setItemAsSeen(p_games[_game]["gameTag"]);
	}

	parent.onNumberOfUnseenGamesReturned(0); //When you visit the shop, you should have all the games marked as seen.
	//$('.game-container').on('click', onGameClicked);
}

function onGetUnownedGamesFailed() {
	console.log("onGetUnownedGamesFailed()");
}

function addGameToCarousel(p_game) {
	console.log("addGameToCarousel(" + p_game + ")");

	// Boilerplate stuff
	var _source = $("#game-template").html();
	var _template = Handlebars.compile(_source);

	// Figure out the actual image src
	var _iconPath = parent.getPathByTag(p_game["gameTag"] + "_icon.png");

	if(!parent.checkTagInManifest(_iconPath))
	{
		_iconPath = "freebounce_icon.png";
	}
	// if (_iconPath == "") {
	// 	return;
	// }

	var _context = {
		gameId: p_game["gameTag"],
		gameName: p_game["gameName"],
		imgSrc: _iconPath
	};

	// Turn the template into html
	var _html = _template(_context);

	// Add html to carousel
	setTimeout(function() 
		{	
			$("#gamesCarousel").data('owlCarousel').addItem(_html);
			$('.game-container').on('click', onGameClicked);
		}, 10);
}

function addIAPsToCarousel(p_iaps) {
	$.each(iaps, addIAPToCarousel);
	
	$('.vc-container').on('click', onPurchaseClicked);
}

function addIAPToCarousel(p_packIndex, p_packId) {
	console.log("addIAPToCarousel(" + p_packId + ")");

	// Boilerplate stuff
	var _source = $("#vc-template").html();
	var _template = Handlebars.compile(_source);

	// Figure out the actual image src
	var _iconTag = p_packId.substring(p_packId.lastIndexOf('.') + 1, p_packId.length);
	var _iconPath = parent.getPathByTag(_iconTag);

	//var _price = "$US " + p_price.substring(p_price.lastIndexOf('$') + 1, p_price.length);

	var _context = {
		packId: p_packId,
		text: parent.Tgoma.LanguageManager.getString("not_applicable"),
		imgSrc: _iconPath
	};

	// Turn the template into html
	var _html = _template(_context);

	// Add html to carousel
	$("#virtualCurrencyCarousel").data('owlCarousel').addItem(_html);
}

function onInAppPurchasesReturned(p_iaps) {
	var iaps = JSON.parse(p_iaps);
	console.log("onInAppPurchasesReturned(" + p_iaps + ")")

	for(var purchase in iaps) {
		var _id = iaps[purchase].productIdentifier;

		// Find IAP div by ID
		var _packDiv = $("div").find("[src='" + _id + "']");

		// Update price text
		_packDiv.find('p').text(iaps[purchase].price);
	}
}

function onPurchaseClicked(evt) {
	console.log("onPurchaseClicked()", this, evt);

	// Don't allow them to revisit this function if we've locked purchases
	if (_purchaseLock) { return; }
	if(parent.Tgoma.UserHelper.currentFamilyAccount.m_email != "") {

		// Now lock the purchases with the aim to unlock once the full process is complete
		_purchaseLock = true;

		// With an aim to unlock them 3 seconds later
		setTimeout(function() { _purchaseLock = false; }, 3000)
		
		// Perform a purchase	
		var iapID = $(evt.target.parentElement).attr("src");
		console.log("onPurchaseClicked() " + iapID)
		parent.SpringfreePurchaseValidation.purchaseIAP(iapID, null, null);
		

	}
	else {
		parent.showConfirm("create_account_to_purchase", function(changePage){
			if(changePage) {
				parent.loadFrame("familyLoginFrame");
			}
		});
	}
}

function onLoginForTokenPurchaseReturned(p_outcome, p_error) {
	console.log("onLoginForTokenPurchaseReturned(", p_outcome , p_error, ")")
	if (p_outcome == false) {
		setTimeout(function() { parent.showAlert ("login_error", parent.Tgoma.LanguageManager.getString(p_error));}, 1);
	_purchaseLock = false;
	}
	else
	{
		_canBuyTokens = true;
		$("#tabs").tabs("option","active",1);

  	}	
}

function onGameClicked(evt) {
	console.log("onGameClicked()", evt);

	var _gameId = $(evt.target.parentElement).attr("src");

	console.log(_gameId);
	if (_gameId){
		parent.loadFrame("gamePreview", "gameId=" + _gameId);
	}
}

function onGetVirtualCurrencyFailed(evt) {
	console.log("onGetVirtualCurrencyFailed()", evt);
	// Hide the icon for now
	$(".vc-icon").each(function() {
		$(this).hide();
	});

	// Display that we're fetching
	$(".vc-balance").each(function() {
		$(this).text(parent.Tgoma.LanguageManager.getString("LBL_go_online"));
	});
}

function onGetPurchaseListFailed() {
	console.log("onGetPurchaseListFailed(" + arguments + ")");
	console.log(arguments);
}

function fetchVirtualCurrencyBalance() {
	console.log("fetchVirtualCurrencyBalance()");

	// Hide the icon for now
	$(".vc-icon").each(function() {
		$(this).hide();
	});

	// Display that we're fetching
	$(".vc-balance").each(function() {
		$(this).text(parent.Tgoma.LanguageManager.getString("retrieving_balance"));
	});

	parent.TgomaMessaging.callPlugin(onVirtualCurrencyUpdated, onGetVirtualCurrencyFailed, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getGemsCount");
}

function onVirtualCurrencyUpdated(e) {
	console.log("onVirtualCurrencyUpdated("+ e.virtualCurrency + ")");

	// This is to catch the success callback of the VC refresh call
	if (e == undefined) {
		return;
	}

	if(e.virtualCurrency == -1001)
	{
		e.virtualCurrency = parent.Tgoma.LanguageManager.getString("error_fetching_balance");
		$(".vc-icon").each(function() {
			$(this).hide();
		});
			// Hide the icon for now
		$(".vc-icon").each(function() {
			$(this).hide();
		});
	}
	else
	{
		$(".vc-icon").each(function() {
			$(this).show();
		});
	}

	$(".vc-balance").each(function() {
		$(this).text(e.virtualCurrency);
	});
}

function onOnline() {
	console.log("onOnline()");
	$("#balance").text(parent.Tgoma.LanguageManager.getString("retrieving_balance"));

	parent.SpringfreePurchaseValidation.getPurchaseList(iaps, onInAppPurchasesReturned, onGetPurchaseListFailed);

	if(parent.Tgoma.UserHelper.currentFamilyAccount.m_email != "") {
		fetchVirtualCurrencyBalance();
	}
	else
	{
		$(".vc-balance").each(function() {
			$(this).text("0");
		});
	}
}

function onOffline() {
	console.log("onOffline()");

	// Hide the icon for now
	$(".vc-icon").each(function() {
		$(this).hide();
	});

	if(parent.Tgoma.UserHelper.currentFamilyAccount.m_email != "") 
	{
		// Display that we're fetching
		$(".vc-balance").each(function() {
			$(this).text(parent.Tgoma.LanguageManager.getString("LBL_go_online"));
		});
	}

	// Hide all those pack prices.
	$(".pack-price").each(function() {
		$(this).text(parent.Tgoma.LanguageManager.getString("N/A"));
	});
}