var hardwareVersion = "N/A Connect to a trampoline.";
var firmwareVersion = "N/A  Connect to a trampoline.";
var hardwareID = "N/A Connect to a trampoline.";
var trampolineModel = "N/A Connect to a trampoline.";
var m_currentTrampolineModelEnum = 0;
var _pageSelected = null;

var _trampModelDictionary = {
	"R54" : "trampoline_r54",
	"R79" : "trampoline_r79",
	"O77" : "trampoline_o77",
	"O92" : "trampoline_o92",
	"S113" : "trampoline_s113",
	"S155" : "trampoline_s155",
	"R132" : "trampoline_r132"
}

var m_modelToEnumDictionary = {
	"R54" : 1,
	"R79" : 2,
	"O77" : 3,
	"O92" : 4,
	"S113" : 5,
	"S155" : 6,
	"R132" : 7
}

$(document).ready(function() {

	window.onerror = parent.window.onerror;
	$("#trampolineModelSelector").prop('disabled', true);

	Handlebars.registerHelper('breaklines', function(text) {
	    text = Handlebars.Utils.escapeExpression(text);
	    text = text.replace(/(\r\n|\n|\r)/gm, '<br>');
	    return new Handlebars.SafeString(text);
	});

	parent.TgomaMessaging.callPlugin(onTrampolineDetailsReturned, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getTrampolineDetails");
	parent.TgomaMessaging.callPlugin(onVersionReturned, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "getVersionNumber");

	parent.Tgoma.TrampolineHelper.trampolineDetailsChangedSignal.add(onTrampolineDetailsUpdated, this);

	// Load the errorDialog javascript now
	$.getScript(parent.getPathByTag("errorDialog-v2.js"), function() {

		onControllerErrorsReturned(parent.Tgoma.ErrorHelper.currentErrorField1,
		 parent.Tgoma.ErrorHelper.currentErrorField2,
		 parent.Tgoma.ErrorHelper.currentErrorField3);
		parent.Tgoma.ErrorHelper.errorSignal.add(onControllerErrorsReturned, this);

	});

	// Load the confirm password files

  	$(".password-dialog").load(parent.getPathByTag("confirmPassword.htm"));
	$.getScript("confirmPassword.js");

	// Load the age gate files
  	$(".age-gate-dialog").load(parent.getPathByTag("ageGate.htm"));
	$.getScript("ageGate.js");

	$("#unpairButton").click(onUnpairButtonClicked);
	$("#trampolineModelSelector").change(onModelChanged);

});


$(window).unload(function () {
    parent.Tgoma.TrampolineHelper.trampolineDetailsChangedSignal.remove(onTrampolineDetailsUpdated, this.document);
    parent.Tgoma.ErrorHelper.errorSignal.remove(onControllerErrorsReturned, this.document);
});

function onTrampolineDetailsReturned(trampDetails) {
	console.log("onTrampolineDetailsReturned(" + trampDetails + ")");

	onTrampolineDetailsUpdated(trampDetails["hardwareID"], trampDetails["trampolineModel"], trampDetails["hardwareVersion"], trampDetails["firmwareVersion"])
}

function onTrampolineDetailsUpdated(p_hardwareID, p_trampolineModel, p_hardwareVersion, p_firmwareVersion) {

	if (p_trampolineModel != "unset" ) {
		window.trampolineModel = _trampModelDictionary[p_trampolineModel] || p_trampolineModel;
		m_currentTrampolineModelEnum = m_modelToEnumDictionary[p_trampolineModel];
		window.trampolineModel = parent.Tgoma.LanguageManager.getString(window.trampolineModel);
	} else {
	    window.trampolineModel = parent.Tgoma.LanguageManager.getString("settings_connect_to_trampoline");
        // When disconnecting reset all controller error alerts
	    onControllerErrorsReturned(0, 0, 0);
	}

	if (p_hardwareVersion != "unset" ) {
		window.hardwareVersion = p_hardwareVersion;
	} else {
		window.hardwareVersion = parent.Tgoma.LanguageManager.getString("settings_connect_to_trampoline");
	}

	if (p_firmwareVersion != "unset" ) {
		window.firmwareVersion = p_firmwareVersion;
		parent.Tgoma.TrampolineHelper.m_firmwareVersion = p_firmwareVersion;

		var supportedModels = parent.Tgoma.TrampolineHelper.allTrampolineModels;

		// Clear out the drop down menu.
		$("#trampolineModelSelector").html("");

		// Populate it with the models that are supported.
		$('#trampolineModelSelector').append($('<option>', {
			value: 0,
			text: parent.Tgoma.LanguageManager.getString("LBL_change")
		}));

		// Populate it with the models that are supported.
		for(var i in supportedModels)
		{
			var model = supportedModels[i];
			$('#trampolineModelSelector').append($('<option>', {
				value: model.value,
				text: parent.Tgoma.LanguageManager.getString(model.tag)
			}));
		}

		$("#trampolineModelSelector").prop('disabled', false);

	} else {
			$("#trampolineModelSelector").prop('disabled', true);
		window.firmwareVersion = parent.Tgoma.LanguageManager.getString("settings_connect_to_trampoline");
	}

	if (p_hardwareID != "unset" ) {
		window.hardwareID = p_hardwareID;
	} else {
		window.hardwareID = parent.Tgoma.LanguageManager.getString("settings_connect_to_trampoline");
	}


	$("#trampolineModel").text(window.trampolineModel);
	$("#hardwareVersion").text(window.hardwareVersion);
	$("#firmwareVersion").text(window.firmwareVersion);
	$("#hardwareID").text(window.hardwareID);
	$("#contentVersion").text(parent.getManifestVersion(parent.manifestDoc));
}

function onVersionReturned(versionNumber) {
	console.log("onVersionReturned(" + versionNumber + ")");

	if (versionNumber["appVersion"] != "" ) {
		window.appVersionappVersion = versionNumber["appVersion"];
	}
	$("#appVersion").text(window.appVersionappVersion);
}

function onControllerErrorsReturned(p_errorfield1, p_errorfield2, p_errorfield3) {
	console.log("onControllerErrorsReturned(" + p_errorfield1 + "," + p_errorfield2 + "," + p_errorfield3 +")");
	// Remove all alerts
	$(".error-container").empty()

	var w = 4294967296; // 2^32

	if (p_errorfield1 > 0 || p_errorfield2 > 0 || p_errorfield3 > 0) {
		if ((CONTROLLER_ERROR_CABLE_A & p_errorfield1) && (CONTROLLER_ERROR_CABLE_B & p_errorfield1)) {
			addAlert(3,1);
		}
		else if (CONTROLLER_ERROR_CABLE_A & p_errorfield1) {
			addAlert(1,1);
		}
		else if (CONTROLLER_ERROR_CABLE_B & p_errorfield1) {
			addAlert(2,1);
		}

		var index = 0x4;
		for(var i = 0; i < 30; i++)
		{
			if(p_errorfield1 & index)
			{
				console.log("Error flag set", index, "For flag field 1-1");
				addAlert(index,1);
			}
			index = index * 2;
		}
		var errorField1_2 = p_errorfield1 / w;
		var index = 0x1;
		for(var i = 0; i < 32; i++)
		{
			if(errorField1_2 & index)
			{
				console.log("Error flag set", index, "For flag field 1-2");
				addAlert(index,2);
			}
			index = index * 2;
		}

		var index = 0x1;
		for(var i = 0; i < 32; i++)
		{
			if(p_errorfield2 & index)
			{
				console.log("Error flag set", index, "For flag field 2-1");
				addAlert(index,3);

			}
			index = index * 2;
		}

		var errorField2_2 = p_errorfield2 / w;

		var index = 0x1;
		for(var i = 0; i < 32; i++)
		{
			if(errorField2_2 & index)
			{
				console.log("Error flag set", index, "For flag field 2-2");
				addAlert(index,4);

			}
			index = index * 2;
		}

		var index = 0x1;
		for(var i = 0; i < 32; i++)
		{
			if(p_errorfield3 & index)
			{
				console.log("Error flag set", index, "For flag field 3-1");
				addAlert(index,5);

			}
			index = index * 2;
		}

		var errorField3_2 = p_errorfield3 / w;

		console.log("Error flags 3_2 =" + errorField3_2)

		var index = 0x1;
		for(var i = 0; i < 32; i++)
		{
			if(errorField3_2 & index)
			{
				console.log("Error flag set", index, "For flag field 3-2");
				addAlert(index,6);

			}
			index = index * 2;
		}
	}
}

function addAlert(p_errorEnum, p_errorFieldNumber) {
	console.log('addAlert(' + p_errorEnum + ')');
	var errorTextDictionary;
	if(p_errorFieldNumber == 1 )
	{
		errorTextDictionary = _errorTextDictionary1;
	}
	else if(p_errorFieldNumber == 2)
	{
		errorTextDictionary = _errorTextDictionary2;
	}
	else if(p_errorFieldNumber == 6)
	{
		errorTextDictionary = _errorTextDictionary6;
	}
	else //No other errors have been added yet.
	{
		console.log("These errors have not been set up yet", p_errorFieldNumber);
		return;
	}


	var errorText = errorTextDictionary[p_errorEnum];
	if(errorText == null || errorText == "")
	{
		console.log("Couldn't find any error details");
		return;
	}

	var source = $("#alert-template").html();
	var template = Handlebars.compile(source);

	var context = {errorImg: parent.getPathByTag("error.png"), errorText: parent.Tgoma.LanguageManager.getString(errorText), error: p_errorEnum, errorList: p_errorFieldNumber};
	var html = template(context);
	$(".error-container").append(html);
}

function onAlertClicked(p_errorEnum, p_errorList) {
	console.log('onAlertClicked(' + p_errorEnum + ',' + p_errorList +')');
	//parent.showAlert(_errorTextDictionary[p_errorEnum]);
	showErrorDialogWithEnum(p_errorEnum, p_errorList, parent.getPathByTag);
}

function onUnpairButtonClicked(evt) {
	console.log('onUnpairButtonClicked()');
	parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.BLUETOOTH_MODULE_NAME, "disconnect");
}

function onModelChanged(evt) {
	console.log("onModelChanged")
	var option = parseInt($("#trampolineModelSelector").find('option:selected').val());
	if(option > 0 && m_currentTrampolineModelEnum != option) {
		setTimeout(function(){

			function hasModel(model) {
		 			return model["value"] === option;
			}

			var isSupportedModel = parent.Tgoma.TrampolineHelper.supportedTrampolineModels.some(hasModel);
			if (isSupportedModel) {
				var message = parent.Tgoma.LanguageManager.getString("confirm_trampoline_model", $("#trampolineModelSelector").find('option:selected').text())
				parent.showConfirm(message, function(result){
					if (result) {
						parent.TgomaMessaging.callPlugin(null, null, this, parent.TgomaMessaging.TGOMA_MODULE_NAME, "setTrampolineModel", [option]);
					}
				});
			}
			else {
				parent.showAlert(parent.Tgoma.LanguageManager.getString("invalid_trampoline_model"));
			}
		},1);//iOS needed a small timeout before showing the confirm dialog or else the selector wasn't hidden, and the confirm wasn't shown.

	}
	setTimeout(resetSelector, 1); //Need a small delay before changing the selector on iOS.
}


function resetSelector() {
	document.getElementById("trampolineModelSelector").value = 0; //Set the selector back to 0.
}

function onLinkClicked(p_link){
	_pageSelected = p_link;

	if(parent.Tgoma.UserHelper.currentFamilyAccount.m_email == "")
	{
		setAgeGateConfirmationDescription(parent.Tgoma.LanguageManager.getString("age_gate_no_account"));
	  	setAgeGateCallback(onAgeGateQuestionAnswered);
	  	showAgeGateDialog();
	}
	else
	{
		var requestParams = new Object();
		setRequestParams("none", JSON.stringify(requestParams));

	  	parent.Tgoma.UserHelper.familyLoginReturnedSignal.addOnce(onLoginForLeavingAppReturned, this);

		// Show the password entry dialog that will send our request to native
		setPasswordConfirmationDescription(parent.Tgoma.LanguageManager.getString("age_gate_with_account"));
	  showConfirmPasswordDialog(function() {
				parent.Tgoma.UserHelper.familyLoginReturnedSignal.removeAll(onLoginForLeavingAppReturned, this);
		});
  }
}

function onAgeGateQuestionAnswered(p_outcome)
{
	if(p_outcome)
	{
		if(_pageSelected != null)
		{
			parent.window.open(_pageSelected, '_system');
		}
	}
	else
	{
	  	setTimeout(function() { parent.showAlert ("incorrect_solution");}, 1);
	}

	_pageSelected = null;
}

function onLoginForLeavingAppReturned(p_outcome, p_error) {
	if(p_outcome)
	{
		if(_pageSelected != null)
		{
			parent.window.open(_pageSelected, '_system');
		}
	}
	else
	{
	  	setTimeout(function() { parent.showAlert ("login_error", parent.Tgoma.LanguageManager.getString(p_error) );}, 1);
	}

	_pageSelected = null;

}
