var Tgoma;
(function (Tgoma) {
    var DownloadUtils = (function () {
        function DownloadUtils() {
        }
        DownloadUtils.setOnDownloadComplete = function (p_onDownloadCompleteCallback) {
            this.m_onDownloadCompleteCallback = p_onDownloadCompleteCallback;
        };
        DownloadUtils.onGameClicked = function (p_appId, p_onDownloadUpdateProgressCallback, p_silentMode, p_unlockInteractionCallback, p_onDownloadCompleteCallback) {
            DownloadUtils.m_appID = p_appId.toString();
            DownloadUtils.m_onDownloadUpdateProgressCallback = p_onDownloadUpdateProgressCallback || DownloadUtils.onDownloadProgress;
            DownloadUtils.m_unlockInteractionCallback = p_unlockInteractionCallback;
            if (p_onDownloadCompleteCallback != null) {
                DownloadUtils.m_onDownloadCompleteCallback = p_onDownloadCompleteCallback;
            }
            DownloadUtils.m_silentMode = p_silentMode;
            parent.document.addEventListener("offline", DownloadUtils.onNetworkConnectionLost, false);
            parent.document.addEventListener("onDownloadCancelled", DownloadUtils.onDownloadCancelled, false);
            if (!DownloadUtils.m_silentMode) {
                $("#progress-dialog").dialog({
                    modal: true,
                    dialogClass: 'no-close'
                });
                $("#progress-dialog").dialog("option", "width", screen.width * 0.8);
                $(".progress-dialog-text").text("Loading game...");
                $(".progress-dialog-bar").progressbar({
                    value: false
                });
                $(".progress-dialog-button").button().click(function () { return DownloadUtils.onCancelDownloadClicked(p_appId.toString()); });
                $(".progress-dialog-button").hide();
            }
            DownloadUtils.checkForInternet(p_appId.toString(), function () {
                DownloadUtils.checkForNewManifest(p_appId.toString(), DownloadUtils.checkIfMustDownload);
            }, function () {
                DownloadUtils.checkIfMustDownload(p_appId.toString());
            });
        };
        DownloadUtils.checkForInternetConnection = function () {
            console.log("[DownloadUtils] checkForInternetConnection()");
            return DownloadUtils.checkForWifi();
        };
        DownloadUtils.checkForWifi = function () {
            console.log("[DownloadUtils] checkForWifi()");
            return navigator.connection.type == "wifi";
        };
        DownloadUtils.checkForNewManifest = function (p_appId, p_onCheckForManifestUpdateReturnedCallback) {
            console.log("[DownloadUtils] checkForNewManifest(" + p_appId + ")");
            DownloadUtils.m_onCheckForManifestUpdateReturnedCallback = p_onCheckForManifestUpdateReturnedCallback;
            parent.document.addEventListener("onCheckForNewManifestReturned", DownloadUtils.onCheckForNewManifestReturned, false);
            TgomaMessaging.Internal.ApplicationManagement.checkForNewManifest(p_appId.toString());
        };
        DownloadUtils.onCheckForNewManifestReturned = function (e) {
            console.log("[DownloadUtils] onCheckForNewManifestReturned(" + e["hasUpdates"] + "," + e["appId"] + ")");
            if (e["appId"] == DownloadUtils.m_appID) {
                parent.document.removeEventListener("onCheckForNewManifestReturned", DownloadUtils.onCheckForNewManifestReturned);
                clearTimeout(DownloadUtils.m_manifestReturnedRef);
                DownloadUtils.m_onCheckForManifestUpdateReturnedCallback.apply(null, [e["appId"].toString()]);
            }
        };
        DownloadUtils.checkIfMustDownload = function (p_appId) {
            console.log("[DownloadUtils] checkIfMustDownload(" + p_appId + ")");
            TgomaMessaging.Internal.ApplicationManagement.checkIfMustDownload(p_appId.toString(), DownloadUtils, DownloadUtils.mandatoryDownloadPrompt, DownloadUtils.checkForUpdate);
        };
        DownloadUtils.checkForUpdate = function (p_appId) {
            console.log("[DownloadUtils] checkForUpdate(" + p_appId + ")");
            TgomaMessaging.Internal.ApplicationManagement.checkForUpdate(p_appId.toString(), DownloadUtils, DownloadUtils.optionalDownloadPrompt, DownloadUtils.onNoUpdatesReturned);
        };
        DownloadUtils.onNoUpdatesReturned = function (p_appId) {
            if (DownloadUtils.m_onDownloadCompleteCallback) {
                DownloadUtils.m_onDownloadCompleteCallback(true, p_appId);
            }
            else {
                DownloadUtils.locateGame(p_appId.toString());
            }
            if (DownloadUtils.m_unlockInteractionCallback != null) {
                DownloadUtils.m_unlockInteractionCallback();
            }
            DownloadUtils.hideProgressView();
            DownloadUtils.removeEventListeners();
        };
        DownloadUtils.optionalDownloadPrompt = function (p_appId) {
            console.log("[DownloadUtils] optionalDownloadPrompt(" + p_appId + ")");
            DownloadUtils.m_mandatory = false;
            var _choice = DownloadUtils.m_silentMode || parent.showConfirm("There is an update available - would you like to download it?");
            if (_choice) {
                DownloadUtils.startDownload(p_appId.toString());
            }
            else {
                if (DownloadUtils.m_unlockInteractionCallback != null) {
                    DownloadUtils.m_unlockInteractionCallback();
                }
                if (DownloadUtils.m_onDownloadCompleteCallback) {
                    DownloadUtils.m_onDownloadCompleteCallback(true, p_appId.toString());
                }
                else {
                    DownloadUtils.locateGame(p_appId.toString());
                }
                DownloadUtils.hideProgressView();
                DownloadUtils.removeEventListeners();
            }
        };
        DownloadUtils.hideProgressView = function () {
            console.log("[DownloadUtils] hideProgressView()");
            if (!DownloadUtils.m_silentMode) {
                if ($("#progress-dialog").hasClass('ui-dialog-content')) {
                    $("#progress-dialog").dialog('close');
                }
            }
        };
        DownloadUtils.mandatoryDownloadPrompt = function (p_appId) {
            console.log("[DownloadUtils] mandatoryDownloadPrompt(" + p_appId + ")");
            DownloadUtils.hideProgressView();
            DownloadUtils.m_mandatory = true;
            setTimeout(function () {
                var _choice = DownloadUtils.m_silentMode;
                if (!DownloadUtils.m_silentMode) {
                    if (DownloadUtils.checkForInternetConnection()) {
                        _choice = parent.showConfirm("You must download files before you can play this game");
                    }
                    else {
                        parent.showAlert("Download failed. Please check your internet and try again.");
                        _choice = false;
                    }
                }
                if (_choice) {
                    DownloadUtils.startDownload(p_appId.toString());
                }
                else {
                    if (DownloadUtils.m_unlockInteractionCallback != null) {
                        DownloadUtils.m_unlockInteractionCallback();
                    }
                    DownloadUtils.removeEventListeners();
                }
            }, 30);
        };
        DownloadUtils.onNetworkConnectionGained = function () {
            console.log("[DownloadUtils] onNetworkConnectionGained()");
            clearInterval(DownloadUtils.m_offlineTimer);
            if (!DownloadUtils.m_silentMode) {
                DownloadUtils.removeEventListeners();
                setTimeout(function () {
                    DownloadUtils.checkForNewManifest(DownloadUtils.m_appID.toString(), DownloadUtils.startDownload);
                }, 3000);
            }
        };
        DownloadUtils.onNetworkConnectionLost = function () {
            console.log("[DownloadUtils] onNetworkConnectionLost()");
            $(".progress-dialog-text").text("Waiting for network...");
            DownloadUtils.m_offlineTimer = setTimeout(DownloadUtils.showCancelButton, 5000);
            TgomaMessaging.Internal.ApplicationManagement.cancelDownload();
        };
        DownloadUtils.showCancelButton = function () {
            if (!DownloadUtils.m_silentMode) {
                $(".progress-dialog-button").show();
            }
        };
        DownloadUtils.onCancelDownloadClicked = function (p_appId) {
            console.log("[DownloadUtils] onCancelDownloadClicked(" + p_appId + ")");
            DownloadUtils.removeEventListeners();
            TgomaMessaging.Internal.ApplicationManagement.cancelDownload();
            DownloadUtils.hideProgressView();
            if (!DownloadUtils.m_mandatory) {
                DownloadUtils.locateGame(p_appId.toString());
            }
            else {
            }
        };
        DownloadUtils.removeEventListeners = function () {
            console.log("[DownloadUtils] removeEventListeners()");
            parent.document.removeEventListener("onDownloadStarted", DownloadUtils.onDownloadStarted);
            parent.document.removeEventListener("onDownloadProgress", DownloadUtils.onDownloadProgress);
            parent.document.removeEventListener("onDownloadComplete", DownloadUtils.onDownloadComplete);
            parent.document.removeEventListener("online", DownloadUtils.onNetworkConnectionGained);
            parent.document.removeEventListener("offline", DownloadUtils.onNetworkConnectionLost);
            parent.document.removeEventListener("onCheckForNewManifestReturned", DownloadUtils.onCheckForNewManifestReturned);
        };
        DownloadUtils.startDownload = function (p_appId) {
            console.log("[DownloadUtils] startDownload(" + p_appId + ")");
            parent.document.addEventListener("onDownloadStarted", DownloadUtils.onDownloadStarted, false);
            parent.document.addEventListener("onDownloadProgress", DownloadUtils.onDownloadProgress, false);
            parent.document.addEventListener("onDownloadComplete", DownloadUtils.onDownloadComplete, false);
            parent.document.addEventListener("online", DownloadUtils.onNetworkConnectionGained, false);
            $("#progress-dialog").dialog('open');
            DownloadUtils.checkForInternet(p_appId.toString(), function () {
                TgomaMessaging.Internal.ApplicationManagement.downloadUpdate(p_appId.toString());
            }, function () {
                DownloadUtils.hideProgressView();
                DownloadUtils.locateGame(p_appId.toString());
            });
        };
        DownloadUtils.checkForInternet = function (p_appId, p_success, p_failure) {
            console.log("[DownloadUtils] checkForInternet(" + p_appId + ")");
            if (DownloadUtils.checkForInternetConnection()) {
                p_success();
            }
            else {
                p_failure();
            }
        };
        DownloadUtils.promptForInternet = function (p_appId) {
            console.log("[DownloadUtils] promptForInternet(" + p_appId + ")");
            DownloadUtils.hideProgressView();
            if (!DownloadUtils.m_silentMode) {
                parent.showAlert("Connect to the internet and try again");
            }
            if (DownloadUtils.m_unlockInteractionCallback != null) {
                DownloadUtils.m_unlockInteractionCallback();
            }
        };
        DownloadUtils.onDownloadStarted = function (e) {
            console.log("[DownloadUtils] onDownloadStarted()");
            if (!DownloadUtils.m_silentMode) {
                $(".progress-dialog-text").text("Downloading...");
            }
        };
        DownloadUtils.onDownloadProgress = function (e) {
            console.log("[DownloadUtils] onDownloadProgress(" + e["progress"] + ")");
            $(".progress-dialog-bar").progressbar("option", {
                value: e["progress"] * 100
            });
        };
        DownloadUtils.onDownloadCancelled = function () {
            console.log("[DownloadUtils] onDownloadCancelled()");
            window.clearInterval(DownloadUtils.m_updateDownloadProgressRef);
            if (DownloadUtils.m_unlockInteractionCallback != null) {
                DownloadUtils.m_unlockInteractionCallback();
            }
        };
        DownloadUtils.onDownloadComplete = function (e) {
            console.log("[DownloadUtils] onDownloadComplete(" + e["downloadSuccessful"] + ", " + e["appId"] + ")");
            if (!DownloadUtils.m_silentMode) {
                $(".progress-dialog-text").text("Download complete");
                $(".progress-dialog-bar").progressbar("option", {
                    value: 100
                });
                $(".progress-dialog-button").hide();
            }
            clearInterval(DownloadUtils.m_updateDownloadProgressRef);
            if (DownloadUtils.m_onDownloadCompleteCallback) {
                DownloadUtils.m_onDownloadCompleteCallback(e["downloadSuccessful"], e["appId"]);
            }
            else {
                DownloadUtils.locateGame(e["appId"].toString());
            }
            if (DownloadUtils.m_unlockInteractionCallback != null) {
                DownloadUtils.m_unlockInteractionCallback();
            }
            DownloadUtils.hideProgressView();
            DownloadUtils.removeEventListeners();
        };
        DownloadUtils.locateGame = function (p_appId, p_entryPoint) {
            if (p_entryPoint === void 0) { p_entryPoint = "default.htm"; }
            console.log("[DownloadUtils] locateGame(" + p_appId + ", " + p_entryPoint + ")");
            TgomaMessaging.Internal.ApplicationManagement.getBaseDirectoryForGame(p_appId, DownloadUtils, function (p_baseDir) { return DownloadUtils.onGetBaseDirectoryForGameReturned(p_baseDir, p_appId, p_entryPoint); }, null);
        };
        DownloadUtils.onGetBaseDirectoryForGameReturned = function (p_baseDir, p_appId, p_entryPoint) {
            console.log("[DownloadUtils] onGetBaseDirectoryForGameReturned(" + p_baseDir + ", " + p_appId + ", " + p_entryPoint + ")");
            if (p_baseDir == "") {
                parent.showAlert("Please check your internet connection and try again.");
                if (DownloadUtils.m_unlockInteractionCallback != null) {
                    DownloadUtils.m_unlockInteractionCallback();
                }
                DownloadUtils.removeEventListeners();
            }
            else {
                Tgoma.ApplicationUtils.FileUtils.loadManifest(p_baseDir + p_appId + "/manifest.xml", function () {
                    var _entryPoint = Tgoma.ApplicationUtils.FileUtils.getPathByTagInXML(this.responseXML, p_entryPoint);
                    if (p_appId == "parent") {
                        var _defaultLocation = Tgoma.ApplicationUtils.FileUtils.getPathByTagInXML(this.responseXML, "default.htm");
                        TgomaMessaging.Internal.ApplicationManagement.cacheParentAppLocation(p_baseDir + p_appId + "/" + _defaultLocation);
                    }
                    if (_entryPoint == "") {
                        DownloadUtils.mandatoryDownloadPrompt(p_appId.toString());
                    }
                    else {
                        var _fullPath = p_baseDir + p_appId + "/" + _entryPoint;
                        DownloadUtils.launchGame(p_appId.toString(), _fullPath);
                    }
                });
            }
        };
        DownloadUtils.launchGame = function (p_appId, p_fullPath) {
            console.log("[DownloadUtils] launchGame(" + p_appId + ", " + p_fullPath + ")");
            DownloadUtils.hideProgressView();
            if (DownloadUtils.m_unlockInteractionCallback != null) {
                DownloadUtils.m_unlockInteractionCallback();
            }
            TgomaMessaging.Internal.ApplicationManagement.toggleScreenTimeout(true);
            TgomaMessaging.Internal.ApplicationManagement.launchApplication(p_appId.toString(), p_fullPath);
        };
        return DownloadUtils;
    })();
    Tgoma.DownloadUtils = DownloadUtils;
})(Tgoma || (Tgoma = {}));
//# sourceMappingURL=tgoma-internal.js.map